// Automatically generated by FFC, the FEniCS Form Compiler, version 0.3.3.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __CAHNHILLIARD3D_H
#define __CAHNHILLIARD3D_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/FiniteElementSpec.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace CahnHilliard3D {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 2;
  
      subelements = new FiniteElement* [2];
      subelements[0] = new SubElement_0();
      subelements[1] = new SubElement_1();
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 8;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 2;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      nodes[3] = cell.vertexID(3);
      int offset = mesh.numVertices();
      nodes[4] = offset + cell.vertexID(0);
      nodes[5] = offset + cell.vertexID(1);
      nodes[6] = offset + cell.vertexID(2);
      nodes[7] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
      int offset = mesh.numVertices();
      vertex_nodes[1] = offset + vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *subelements[i];
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *subelements[i];
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("mixed");
      return s;
    }
    
  private:
    
    class SubElement_0 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_0()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
      
    class SubElement_1 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_1() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_1()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
    
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:
  
    TrialElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 2;
  
      subelements = new FiniteElement* [2];
      subelements[0] = new SubElement_0();
      subelements[1] = new SubElement_1();
    }
  
    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 8;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 2;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      nodes[3] = cell.vertexID(3);
      int offset = mesh.numVertices();
      nodes[4] = offset + cell.vertexID(0);
      nodes[5] = offset + cell.vertexID(1);
      nodes[6] = offset + cell.vertexID(2);
      nodes[7] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
      int offset = mesh.numVertices();
      vertex_nodes[1] = offset + vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *subelements[i];
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *subelements[i];
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("mixed");
      return s;
    }
    
  private:
    
    class SubElement_0 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_0()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
      
    class SubElement_1 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_1() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_1()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
    
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 2;
  
      subelements = new FiniteElement* [2];
      subelements[0] = new SubElement_0();
      subelements[1] = new SubElement_1();
    }
  
    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 8;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 2;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      nodes[3] = cell.vertexID(3);
      int offset = mesh.numVertices();
      nodes[4] = offset + cell.vertexID(0);
      nodes[5] = offset + cell.vertexID(1);
      nodes[6] = offset + cell.vertexID(2);
      nodes[7] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
      int offset = mesh.numVertices();
      vertex_nodes[1] = offset + vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *subelements[i];
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *subelements[i];
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("mixed");
      return s;
    }
    
  private:
    
    class SubElement_0 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_0()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
      
    class SubElement_1 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_1() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_1()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
    
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  BilinearForm(Function& w0, const real& c0, const real& c1, const real& c2, const real& c3) : dolfin::BilinearForm(1), c0(c0), c1(c1), c2(c2), c3(c3)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();

    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute coefficients
    const real c0_0 = c[0][0];
    const real c0_1 = c[0][1];
    const real c0_2 = c[0][2];
    const real c0_3 = c[0][3];

    // Compute geometry tensors
    const real G0_ = map.det;
    const real G1_0_0_0_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g02;
    const real G1_0_0_0_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g12;
    const real G1_0_0_0_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g22;
    const real G1_0_0_1_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g02;
    const real G1_0_0_1_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g12;
    const real G1_0_0_1_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g22;
    const real G1_0_0_2_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g02;
    const real G1_0_0_2_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g12;
    const real G1_0_0_2_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g22;
    const real G1_0_1_0_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g02;
    const real G1_0_1_0_1 = map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g12;
    const real G1_0_1_0_2 = map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g22;
    const real G1_0_1_1_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g02;
    const real G1_0_1_1_1 = map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g12;
    const real G1_0_1_1_2 = map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g22;
    const real G1_0_1_2_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g02;
    const real G1_0_1_2_1 = map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g12;
    const real G1_0_1_2_2 = map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g22;
    const real G1_0_2_0_0 = map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g02;
    const real G1_0_2_0_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g12;
    const real G1_0_2_0_2 = map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g22;
    const real G1_0_2_1_0 = map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g02;
    const real G1_0_2_1_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g12;
    const real G1_0_2_1_2 = map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g22;
    const real G1_0_2_2_0 = map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g02;
    const real G1_0_2_2_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g12;
    const real G1_0_2_2_2 = map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g22;
    const real G1_0_3_0_0 = map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g02;
    const real G1_0_3_0_1 = map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g12;
    const real G1_0_3_0_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g22;
    const real G1_0_3_1_0 = map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g02;
    const real G1_0_3_1_1 = map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g12;
    const real G1_0_3_1_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g22;
    const real G1_0_3_2_0 = map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g02;
    const real G1_0_3_2_1 = map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g12;
    const real G1_0_3_2_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g22;
    const real G1_1_0_0_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g02;
    const real G1_1_0_0_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g12;
    const real G1_1_0_0_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g22;
    const real G1_1_0_1_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g02;
    const real G1_1_0_1_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g12;
    const real G1_1_0_1_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g22;
    const real G1_1_0_2_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g02;
    const real G1_1_0_2_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g12;
    const real G1_1_0_2_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g22;
    const real G1_1_1_0_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g02;
    const real G1_1_1_0_1 = map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g12;
    const real G1_1_1_0_2 = map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g22;
    const real G1_1_1_1_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g02;
    const real G1_1_1_1_1 = map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g12;
    const real G1_1_1_1_2 = map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g22;
    const real G1_1_1_2_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g02;
    const real G1_1_1_2_1 = map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g12;
    const real G1_1_1_2_2 = map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g22;
    const real G1_1_2_0_0 = map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g02;
    const real G1_1_2_0_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g12;
    const real G1_1_2_0_2 = map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g22;
    const real G1_1_2_1_0 = map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g02;
    const real G1_1_2_1_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g12;
    const real G1_1_2_1_2 = map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g22;
    const real G1_1_2_2_0 = map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g02;
    const real G1_1_2_2_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g12;
    const real G1_1_2_2_2 = map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g22;
    const real G1_1_3_0_0 = map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g02;
    const real G1_1_3_0_1 = map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g12;
    const real G1_1_3_0_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g22;
    const real G1_1_3_1_0 = map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g02;
    const real G1_1_3_1_1 = map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g12;
    const real G1_1_3_1_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g22;
    const real G1_1_3_2_0 = map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g02;
    const real G1_1_3_2_1 = map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g12;
    const real G1_1_3_2_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g22;
    const real G1_2_0_0_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g02;
    const real G1_2_0_0_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g12;
    const real G1_2_0_0_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g22;
    const real G1_2_0_1_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g02;
    const real G1_2_0_1_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g12;
    const real G1_2_0_1_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g22;
    const real G1_2_0_2_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g02;
    const real G1_2_0_2_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g12;
    const real G1_2_0_2_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g22;
    const real G1_2_1_0_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g02;
    const real G1_2_1_0_1 = map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g12;
    const real G1_2_1_0_2 = map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g22;
    const real G1_2_1_1_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g02;
    const real G1_2_1_1_1 = map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g12;
    const real G1_2_1_1_2 = map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g22;
    const real G1_2_1_2_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g02;
    const real G1_2_1_2_1 = map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g12;
    const real G1_2_1_2_2 = map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g22;
    const real G1_2_2_0_0 = map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g02;
    const real G1_2_2_0_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g12;
    const real G1_2_2_0_2 = map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g22;
    const real G1_2_2_1_0 = map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g02;
    const real G1_2_2_1_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g12;
    const real G1_2_2_1_2 = map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g22;
    const real G1_2_2_2_0 = map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g02;
    const real G1_2_2_2_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g12;
    const real G1_2_2_2_2 = map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g22;
    const real G1_2_3_0_0 = map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g02;
    const real G1_2_3_0_1 = map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g12;
    const real G1_2_3_0_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g22;
    const real G1_2_3_1_0 = map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g02;
    const real G1_2_3_1_1 = map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g12;
    const real G1_2_3_1_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g22;
    const real G1_2_3_2_0 = map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g02;
    const real G1_2_3_2_1 = map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g12;
    const real G1_2_3_2_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g22;
    const real G1_3_0_0_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g02;
    const real G1_3_0_0_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g12;
    const real G1_3_0_0_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g22;
    const real G1_3_0_1_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g02;
    const real G1_3_0_1_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g12;
    const real G1_3_0_1_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g22;
    const real G1_3_0_2_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g02;
    const real G1_3_0_2_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g12;
    const real G1_3_0_2_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g22;
    const real G1_3_1_0_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g02;
    const real G1_3_1_0_1 = map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g12;
    const real G1_3_1_0_2 = map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g22;
    const real G1_3_1_1_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g02;
    const real G1_3_1_1_1 = map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g12;
    const real G1_3_1_1_2 = map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g22;
    const real G1_3_1_2_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g02;
    const real G1_3_1_2_1 = map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g12;
    const real G1_3_1_2_2 = map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g22;
    const real G1_3_2_0_0 = map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g02;
    const real G1_3_2_0_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g12;
    const real G1_3_2_0_2 = map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g22;
    const real G1_3_2_1_0 = map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g02;
    const real G1_3_2_1_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g12;
    const real G1_3_2_1_2 = map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g22;
    const real G1_3_2_2_0 = map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g02;
    const real G1_3_2_2_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g12;
    const real G1_3_2_2_2 = map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g22;
    const real G1_3_3_0_0 = map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g02;
    const real G1_3_3_0_1 = map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g12;
    const real G1_3_3_0_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g22;
    const real G1_3_3_1_0 = map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g02;
    const real G1_3_3_1_1 = map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g12;
    const real G1_3_3_1_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g22;
    const real G1_3_3_2_0 = map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g02;
    const real G1_3_3_2_1 = map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g12;
    const real G1_3_3_2_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g22;
    const real G2_0_0_0 = map.det*c3*c2*c1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*map.g02*map.g02;
    const real G2_0_0_1 = map.det*c3*c2*c1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*map.g02*map.g12;
    const real G2_0_0_2 = map.det*c3*c2*c1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*map.g02*map.g22;
    const real G2_0_1_0 = map.det*c3*c2*c1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*map.g12*map.g02;
    const real G2_0_1_1 = map.det*c3*c2*c1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*map.g12*map.g12;
    const real G2_0_1_2 = map.det*c3*c2*c1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*map.g12*map.g22;
    const real G2_0_2_0 = map.det*c3*c2*c1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*map.g22*map.g02;
    const real G2_0_2_1 = map.det*c3*c2*c1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*map.g22*map.g12;
    const real G2_0_2_2 = map.det*c3*c2*c1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*map.g22*map.g22;
    const real G2_1_0_0 = map.det*c3*c2*c1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*map.g02*map.g02;
    const real G2_1_0_1 = map.det*c3*c2*c1*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*map.g02*map.g12;
    const real G2_1_0_2 = map.det*c3*c2*c1*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*map.g02*map.g22;
    const real G2_1_1_0 = map.det*c3*c2*c1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*map.g12*map.g02;
    const real G2_1_1_1 = map.det*c3*c2*c1*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*map.g12*map.g12;
    const real G2_1_1_2 = map.det*c3*c2*c1*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*map.g12*map.g22;
    const real G2_1_2_0 = map.det*c3*c2*c1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*map.g22*map.g02;
    const real G2_1_2_1 = map.det*c3*c2*c1*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*map.g22*map.g12;
    const real G2_1_2_2 = map.det*c3*c2*c1*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*map.g22*map.g22;
    const real G2_2_0_0 = map.det*c3*c2*c1*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*map.g02*map.g02;
    const real G2_2_0_1 = map.det*c3*c2*c1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*map.g02*map.g12;
    const real G2_2_0_2 = map.det*c3*c2*c1*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*map.g02*map.g22;
    const real G2_2_1_0 = map.det*c3*c2*c1*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*map.g12*map.g02;
    const real G2_2_1_1 = map.det*c3*c2*c1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*map.g12*map.g12;
    const real G2_2_1_2 = map.det*c3*c2*c1*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*map.g12*map.g22;
    const real G2_2_2_0 = map.det*c3*c2*c1*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*map.g22*map.g02;
    const real G2_2_2_1 = map.det*c3*c2*c1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*map.g22*map.g12;
    const real G2_2_2_2 = map.det*c3*c2*c1*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*map.g22*map.g22;
    const real G2_3_0_0 = map.det*c3*c2*c1*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*map.g02*map.g02;
    const real G2_3_0_1 = map.det*c3*c2*c1*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*map.g02*map.g12;
    const real G2_3_0_2 = map.det*c3*c2*c1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*map.g02*map.g22;
    const real G2_3_1_0 = map.det*c3*c2*c1*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*map.g12*map.g02;
    const real G2_3_1_1 = map.det*c3*c2*c1*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*map.g12*map.g12;
    const real G2_3_1_2 = map.det*c3*c2*c1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*map.g12*map.g22;
    const real G2_3_2_0 = map.det*c3*c2*c1*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*map.g22*map.g02;
    const real G2_3_2_1 = map.det*c3*c2*c1*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*map.g22*map.g12;
    const real G2_3_2_2 = map.det*c3*c2*c1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*map.g22*map.g22;
    const real G3_0_0 = map.det*c3*c2*c1*map.g00*map.g00 + map.det*c3*c2*c1*map.g01*map.g01 + map.det*c3*c2*c1*map.g02*map.g02;
    const real G3_0_1 = map.det*c3*c2*c1*map.g00*map.g10 + map.det*c3*c2*c1*map.g01*map.g11 + map.det*c3*c2*c1*map.g02*map.g12;
    const real G3_0_2 = map.det*c3*c2*c1*map.g00*map.g20 + map.det*c3*c2*c1*map.g01*map.g21 + map.det*c3*c2*c1*map.g02*map.g22;
    const real G3_1_0 = map.det*c3*c2*c1*map.g10*map.g00 + map.det*c3*c2*c1*map.g11*map.g01 + map.det*c3*c2*c1*map.g12*map.g02;
    const real G3_1_1 = map.det*c3*c2*c1*map.g10*map.g10 + map.det*c3*c2*c1*map.g11*map.g11 + map.det*c3*c2*c1*map.g12*map.g12;
    const real G3_1_2 = map.det*c3*c2*c1*map.g10*map.g20 + map.det*c3*c2*c1*map.g11*map.g21 + map.det*c3*c2*c1*map.g12*map.g22;
    const real G3_2_0 = map.det*c3*c2*c1*map.g20*map.g00 + map.det*c3*c2*c1*map.g21*map.g01 + map.det*c3*c2*c1*map.g22*map.g02;
    const real G3_2_1 = map.det*c3*c2*c1*map.g20*map.g10 + map.det*c3*c2*c1*map.g21*map.g11 + map.det*c3*c2*c1*map.g22*map.g12;
    const real G3_2_2 = map.det*c3*c2*c1*map.g20*map.g20 + map.det*c3*c2*c1*map.g21*map.g21 + map.det*c3*c2*c1*map.g22*map.g22;
    const real G4_0_0_0_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g02;
    const real G4_0_0_0_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g12;
    const real G4_0_0_0_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g22;
    const real G4_0_0_1_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g02;
    const real G4_0_0_1_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g12;
    const real G4_0_0_1_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g22;
    const real G4_0_0_2_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g02;
    const real G4_0_0_2_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g12;
    const real G4_0_0_2_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g22;
    const real G4_0_1_0_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g02;
    const real G4_0_1_0_1 = map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g12;
    const real G4_0_1_0_2 = map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g22;
    const real G4_0_1_1_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g02;
    const real G4_0_1_1_1 = map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g12;
    const real G4_0_1_1_2 = map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g22;
    const real G4_0_1_2_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g02;
    const real G4_0_1_2_1 = map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g12;
    const real G4_0_1_2_2 = map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g22;
    const real G4_0_2_0_0 = map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g02;
    const real G4_0_2_0_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g12;
    const real G4_0_2_0_2 = map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g22;
    const real G4_0_2_1_0 = map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g02;
    const real G4_0_2_1_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g12;
    const real G4_0_2_1_2 = map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g22;
    const real G4_0_2_2_0 = map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g02;
    const real G4_0_2_2_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g12;
    const real G4_0_2_2_2 = map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g22;
    const real G4_0_3_0_0 = map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g02;
    const real G4_0_3_0_1 = map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g12;
    const real G4_0_3_0_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g22;
    const real G4_0_3_1_0 = map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g02;
    const real G4_0_3_1_1 = map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g12;
    const real G4_0_3_1_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g22;
    const real G4_0_3_2_0 = map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g02;
    const real G4_0_3_2_1 = map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g12;
    const real G4_0_3_2_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g22;
    const real G4_1_0_0_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g02;
    const real G4_1_0_0_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g12;
    const real G4_1_0_0_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g22;
    const real G4_1_0_1_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g02;
    const real G4_1_0_1_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g12;
    const real G4_1_0_1_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g22;
    const real G4_1_0_2_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g02;
    const real G4_1_0_2_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g12;
    const real G4_1_0_2_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g22;
    const real G4_1_1_0_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g02;
    const real G4_1_1_0_1 = map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g12;
    const real G4_1_1_0_2 = map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g22;
    const real G4_1_1_1_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g02;
    const real G4_1_1_1_1 = map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g12;
    const real G4_1_1_1_2 = map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g22;
    const real G4_1_1_2_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g02;
    const real G4_1_1_2_1 = map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g12;
    const real G4_1_1_2_2 = map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g22;
    const real G4_1_2_0_0 = map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g02;
    const real G4_1_2_0_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g12;
    const real G4_1_2_0_2 = map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g22;
    const real G4_1_2_1_0 = map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g02;
    const real G4_1_2_1_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g12;
    const real G4_1_2_1_2 = map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g22;
    const real G4_1_2_2_0 = map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g02;
    const real G4_1_2_2_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g12;
    const real G4_1_2_2_2 = map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g22;
    const real G4_1_3_0_0 = map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g02;
    const real G4_1_3_0_1 = map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g12;
    const real G4_1_3_0_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g22;
    const real G4_1_3_1_0 = map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g02;
    const real G4_1_3_1_1 = map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g12;
    const real G4_1_3_1_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g22;
    const real G4_1_3_2_0 = map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g02;
    const real G4_1_3_2_1 = map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g12;
    const real G4_1_3_2_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g22;
    const real G4_2_0_0_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g02;
    const real G4_2_0_0_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g12;
    const real G4_2_0_0_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g22;
    const real G4_2_0_1_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g02;
    const real G4_2_0_1_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g12;
    const real G4_2_0_1_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g22;
    const real G4_2_0_2_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g02;
    const real G4_2_0_2_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g12;
    const real G4_2_0_2_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g22;
    const real G4_2_1_0_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g02;
    const real G4_2_1_0_1 = map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g12;
    const real G4_2_1_0_2 = map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g22;
    const real G4_2_1_1_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g02;
    const real G4_2_1_1_1 = map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g12;
    const real G4_2_1_1_2 = map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g22;
    const real G4_2_1_2_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g02;
    const real G4_2_1_2_1 = map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g12;
    const real G4_2_1_2_2 = map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g22;
    const real G4_2_2_0_0 = map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g02;
    const real G4_2_2_0_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g12;
    const real G4_2_2_0_2 = map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g22;
    const real G4_2_2_1_0 = map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g02;
    const real G4_2_2_1_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g12;
    const real G4_2_2_1_2 = map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g22;
    const real G4_2_2_2_0 = map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g02;
    const real G4_2_2_2_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g12;
    const real G4_2_2_2_2 = map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g22;
    const real G4_2_3_0_0 = map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g02;
    const real G4_2_3_0_1 = map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g12;
    const real G4_2_3_0_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g22;
    const real G4_2_3_1_0 = map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g02;
    const real G4_2_3_1_1 = map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g12;
    const real G4_2_3_1_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g22;
    const real G4_2_3_2_0 = map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g02;
    const real G4_2_3_2_1 = map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g12;
    const real G4_2_3_2_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g22;
    const real G4_3_0_0_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g02;
    const real G4_3_0_0_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g12;
    const real G4_3_0_0_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g22;
    const real G4_3_0_1_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g02;
    const real G4_3_0_1_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g12;
    const real G4_3_0_1_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g22;
    const real G4_3_0_2_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g02;
    const real G4_3_0_2_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g12;
    const real G4_3_0_2_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g22;
    const real G4_3_1_0_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g02;
    const real G4_3_1_0_1 = map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g12;
    const real G4_3_1_0_2 = map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g22;
    const real G4_3_1_1_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g02;
    const real G4_3_1_1_1 = map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g12;
    const real G4_3_1_1_2 = map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g22;
    const real G4_3_1_2_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g02;
    const real G4_3_1_2_1 = map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g12;
    const real G4_3_1_2_2 = map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g22;
    const real G4_3_2_0_0 = map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g02;
    const real G4_3_2_0_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g12;
    const real G4_3_2_0_2 = map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g22;
    const real G4_3_2_1_0 = map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g02;
    const real G4_3_2_1_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g12;
    const real G4_3_2_1_2 = map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g22;
    const real G4_3_2_2_0 = map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g02;
    const real G4_3_2_2_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g12;
    const real G4_3_2_2_2 = map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g22;
    const real G4_3_3_0_0 = map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g02;
    const real G4_3_3_0_1 = map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g12;
    const real G4_3_3_0_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g22;
    const real G4_3_3_1_0 = map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g02;
    const real G4_3_3_1_1 = map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g12;
    const real G4_3_3_1_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g22;
    const real G4_3_3_2_0 = map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g02;
    const real G4_3_3_2_1 = map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g12;
    const real G4_3_3_2_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g22;
    const real G5_0_0_0 = map.det*c3*c2*c1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*map.g02*map.g02;
    const real G5_0_0_1 = map.det*c3*c2*c1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*map.g02*map.g12;
    const real G5_0_0_2 = map.det*c3*c2*c1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*map.g02*map.g22;
    const real G5_0_1_0 = map.det*c3*c2*c1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*map.g12*map.g02;
    const real G5_0_1_1 = map.det*c3*c2*c1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*map.g12*map.g12;
    const real G5_0_1_2 = map.det*c3*c2*c1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*map.g12*map.g22;
    const real G5_0_2_0 = map.det*c3*c2*c1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*map.g22*map.g02;
    const real G5_0_2_1 = map.det*c3*c2*c1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*map.g22*map.g12;
    const real G5_0_2_2 = map.det*c3*c2*c1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*map.g22*map.g22;
    const real G5_1_0_0 = map.det*c3*c2*c1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*map.g02*map.g02;
    const real G5_1_0_1 = map.det*c3*c2*c1*c0_1*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*map.g02*map.g12;
    const real G5_1_0_2 = map.det*c3*c2*c1*c0_1*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*map.g02*map.g22;
    const real G5_1_1_0 = map.det*c3*c2*c1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*map.g12*map.g02;
    const real G5_1_1_1 = map.det*c3*c2*c1*c0_1*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*map.g12*map.g12;
    const real G5_1_1_2 = map.det*c3*c2*c1*c0_1*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*map.g12*map.g22;
    const real G5_1_2_0 = map.det*c3*c2*c1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*map.g22*map.g02;
    const real G5_1_2_1 = map.det*c3*c2*c1*c0_1*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*map.g22*map.g12;
    const real G5_1_2_2 = map.det*c3*c2*c1*c0_1*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*map.g22*map.g22;
    const real G5_2_0_0 = map.det*c3*c2*c1*c0_2*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*map.g02*map.g02;
    const real G5_2_0_1 = map.det*c3*c2*c1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*map.g02*map.g12;
    const real G5_2_0_2 = map.det*c3*c2*c1*c0_2*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*map.g02*map.g22;
    const real G5_2_1_0 = map.det*c3*c2*c1*c0_2*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*map.g12*map.g02;
    const real G5_2_1_1 = map.det*c3*c2*c1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*map.g12*map.g12;
    const real G5_2_1_2 = map.det*c3*c2*c1*c0_2*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*map.g12*map.g22;
    const real G5_2_2_0 = map.det*c3*c2*c1*c0_2*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*map.g22*map.g02;
    const real G5_2_2_1 = map.det*c3*c2*c1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*map.g22*map.g12;
    const real G5_2_2_2 = map.det*c3*c2*c1*c0_2*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*map.g22*map.g22;
    const real G5_3_0_0 = map.det*c3*c2*c1*c0_3*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*map.g02*map.g02;
    const real G5_3_0_1 = map.det*c3*c2*c1*c0_3*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*map.g02*map.g12;
    const real G5_3_0_2 = map.det*c3*c2*c1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*map.g02*map.g22;
    const real G5_3_1_0 = map.det*c3*c2*c1*c0_3*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*map.g12*map.g02;
    const real G5_3_1_1 = map.det*c3*c2*c1*c0_3*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*map.g12*map.g12;
    const real G5_3_1_2 = map.det*c3*c2*c1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*map.g12*map.g22;
    const real G5_3_2_0 = map.det*c3*c2*c1*c0_3*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*map.g22*map.g02;
    const real G5_3_2_1 = map.det*c3*c2*c1*c0_3*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*map.g22*map.g12;
    const real G5_3_2_2 = map.det*c3*c2*c1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*map.g22*map.g22;
    const real G9_0_0_0_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g02;
    const real G9_0_0_0_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g12;
    const real G9_0_0_0_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g22;
    const real G9_0_0_1_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g02;
    const real G9_0_0_1_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g12;
    const real G9_0_0_1_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g22;
    const real G9_0_0_2_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g02;
    const real G9_0_0_2_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g12;
    const real G9_0_0_2_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g22;
    const real G9_0_1_0_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g02;
    const real G9_0_1_1_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g02;
    const real G9_0_1_2_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g02;
    const real G9_0_2_0_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g12;
    const real G9_0_2_1_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g12;
    const real G9_0_2_2_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g12;
    const real G9_0_3_0_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g22;
    const real G9_0_3_1_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g22;
    const real G9_0_3_2_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g22;
    const real G9_1_0_0_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g02;
    const real G9_1_0_0_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g12;
    const real G9_1_0_0_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g22;
    const real G9_1_0_1_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g02;
    const real G9_1_0_1_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g12;
    const real G9_1_0_1_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g22;
    const real G9_1_0_2_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g02;
    const real G9_1_0_2_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g12;
    const real G9_1_0_2_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g22;
    const real G9_1_1_0_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g02;
    const real G9_1_1_1_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g02;
    const real G9_1_1_2_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g02;
    const real G9_1_2_0_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g12;
    const real G9_1_2_1_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g12;
    const real G9_1_2_2_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g12;
    const real G9_1_3_0_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g22;
    const real G9_1_3_1_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g22;
    const real G9_1_3_2_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g22;
    const real G9_2_0_0_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g02;
    const real G9_2_0_0_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g12;
    const real G9_2_0_0_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g22;
    const real G9_2_0_1_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g02;
    const real G9_2_0_1_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g12;
    const real G9_2_0_1_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g22;
    const real G9_2_0_2_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g02;
    const real G9_2_0_2_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g12;
    const real G9_2_0_2_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g22;
    const real G9_2_1_0_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g02;
    const real G9_2_1_1_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g02;
    const real G9_2_1_2_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g02;
    const real G9_2_2_0_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g12;
    const real G9_2_2_1_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g12;
    const real G9_2_2_2_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g12;
    const real G9_2_3_0_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g22;
    const real G9_2_3_1_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g22;
    const real G9_2_3_2_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g22;
    const real G9_3_0_0_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g02;
    const real G9_3_0_0_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g12;
    const real G9_3_0_0_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g22;
    const real G9_3_0_1_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g02;
    const real G9_3_0_1_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g12;
    const real G9_3_0_1_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g22;
    const real G9_3_0_2_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g02;
    const real G9_3_0_2_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g12;
    const real G9_3_0_2_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g22;
    const real G9_3_1_0_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g02;
    const real G9_3_1_1_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g02;
    const real G9_3_1_2_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g02;
    const real G9_3_2_0_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g12;
    const real G9_3_2_1_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g12;
    const real G9_3_2_2_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g12;
    const real G9_3_3_0_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g22;
    const real G9_3_3_1_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g22;
    const real G9_3_3_2_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g22;
    const real G10_0_0_0 = map.det*c3*c2*c1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*map.g02*map.g02;
    const real G10_0_0_1 = map.det*c3*c2*c1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*map.g02*map.g12;
    const real G10_0_0_2 = map.det*c3*c2*c1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*map.g02*map.g22;
    const real G10_0_1_0 = map.det*c3*c2*c1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*map.g12*map.g02;
    const real G10_0_1_1 = map.det*c3*c2*c1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*map.g12*map.g12;
    const real G10_0_1_2 = map.det*c3*c2*c1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*map.g12*map.g22;
    const real G10_0_2_0 = map.det*c3*c2*c1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*map.g22*map.g02;
    const real G10_0_2_1 = map.det*c3*c2*c1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*map.g22*map.g12;
    const real G10_0_2_2 = map.det*c3*c2*c1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*map.g22*map.g22;
    const real G10_1_0_0 = map.det*c3*c2*c1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*map.g02*map.g02;
    const real G10_1_1_0 = map.det*c3*c2*c1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*map.g12*map.g02;
    const real G10_1_2_0 = map.det*c3*c2*c1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*map.g22*map.g02;
    const real G10_2_0_1 = map.det*c3*c2*c1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*map.g02*map.g12;
    const real G10_2_1_1 = map.det*c3*c2*c1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*map.g12*map.g12;
    const real G10_2_2_1 = map.det*c3*c2*c1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*map.g22*map.g12;
    const real G10_3_0_2 = map.det*c3*c2*c1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*map.g02*map.g22;
    const real G10_3_1_2 = map.det*c3*c2*c1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*map.g12*map.g22;
    const real G10_3_2_2 = map.det*c3*c2*c1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*map.g22*map.g22;
    const real G11_0_0 = map.det*c3*c2*map.g00*map.g00 + map.det*c3*c2*map.g01*map.g01 + map.det*c3*c2*map.g02*map.g02;
    const real G11_0_1 = map.det*c3*c2*map.g00*map.g10 + map.det*c3*c2*map.g01*map.g11 + map.det*c3*c2*map.g02*map.g12;
    const real G11_0_2 = map.det*c3*c2*map.g00*map.g20 + map.det*c3*c2*map.g01*map.g21 + map.det*c3*c2*map.g02*map.g22;
    const real G11_1_0 = map.det*c3*c2*map.g10*map.g00 + map.det*c3*c2*map.g11*map.g01 + map.det*c3*c2*map.g12*map.g02;
    const real G11_1_1 = map.det*c3*c2*map.g10*map.g10 + map.det*c3*c2*map.g11*map.g11 + map.det*c3*c2*map.g12*map.g12;
    const real G11_1_2 = map.det*c3*c2*map.g10*map.g20 + map.det*c3*c2*map.g11*map.g21 + map.det*c3*c2*map.g12*map.g22;
    const real G11_2_0 = map.det*c3*c2*map.g20*map.g00 + map.det*c3*c2*map.g21*map.g01 + map.det*c3*c2*map.g22*map.g02;
    const real G11_2_1 = map.det*c3*c2*map.g20*map.g10 + map.det*c3*c2*map.g21*map.g11 + map.det*c3*c2*map.g22*map.g12;
    const real G11_2_2 = map.det*c3*c2*map.g20*map.g20 + map.det*c3*c2*map.g21*map.g21 + map.det*c3*c2*map.g22*map.g22;
    const real G12_ = map.det;
    const real G13_0_0 = map.det*c0*map.g00*map.g00 + map.det*c0*map.g01*map.g01 + map.det*c0*map.g02*map.g02;
    const real G13_0_1 = map.det*c0*map.g00*map.g10 + map.det*c0*map.g01*map.g11 + map.det*c0*map.g02*map.g12;
    const real G13_0_2 = map.det*c0*map.g00*map.g20 + map.det*c0*map.g01*map.g21 + map.det*c0*map.g02*map.g22;
    const real G13_1_0 = map.det*c0*map.g10*map.g00 + map.det*c0*map.g11*map.g01 + map.det*c0*map.g12*map.g02;
    const real G13_1_1 = map.det*c0*map.g10*map.g10 + map.det*c0*map.g11*map.g11 + map.det*c0*map.g12*map.g12;
    const real G13_1_2 = map.det*c0*map.g10*map.g20 + map.det*c0*map.g11*map.g21 + map.det*c0*map.g12*map.g22;
    const real G13_2_0 = map.det*c0*map.g20*map.g00 + map.det*c0*map.g21*map.g01 + map.det*c0*map.g22*map.g02;
    const real G13_2_1 = map.det*c0*map.g20*map.g10 + map.det*c0*map.g21*map.g11 + map.det*c0*map.g22*map.g12;
    const real G13_2_2 = map.det*c0*map.g20*map.g20 + map.det*c0*map.g21*map.g21 + map.det*c0*map.g22*map.g22;

    // Compute element tensor
    block[0] = 1.666666666666662e-02*G0_ + 3.333333333333323e-02*G1_0_0_0_0 + 3.333333333333324e-02*G1_0_0_0_1 + 3.333333333333324e-02*G1_0_0_0_2 + 3.333333333333324e-02*G1_0_0_1_0 + 3.333333333333324e-02*G1_0_0_1_1 + 3.333333333333324e-02*G1_0_0_1_2 + 3.333333333333324e-02*G1_0_0_2_0 + 3.333333333333324e-02*G1_0_0_2_1 + 3.333333333333325e-02*G1_0_0_2_2 + 1.666666666666661e-02*G1_0_1_0_0 + 1.666666666666661e-02*G1_0_1_0_1 + 1.666666666666662e-02*G1_0_1_0_2 + 1.666666666666661e-02*G1_0_1_1_0 + 1.666666666666662e-02*G1_0_1_1_1 + 1.666666666666662e-02*G1_0_1_1_2 + 1.666666666666662e-02*G1_0_1_2_0 + 1.666666666666662e-02*G1_0_1_2_1 + 1.666666666666662e-02*G1_0_1_2_2 + 1.666666666666661e-02*G1_0_2_0_0 + 1.666666666666661e-02*G1_0_2_0_1 + 1.666666666666661e-02*G1_0_2_0_2 + 1.666666666666661e-02*G1_0_2_1_0 + 1.666666666666661e-02*G1_0_2_1_1 + 1.666666666666662e-02*G1_0_2_1_2 + 1.666666666666661e-02*G1_0_2_2_0 + 1.666666666666662e-02*G1_0_2_2_1 + 1.666666666666662e-02*G1_0_2_2_2 + 1.666666666666661e-02*G1_0_3_0_0 + 1.666666666666662e-02*G1_0_3_0_1 + 1.666666666666662e-02*G1_0_3_0_2 + 1.666666666666662e-02*G1_0_3_1_0 + 1.666666666666662e-02*G1_0_3_1_1 + 1.666666666666663e-02*G1_0_3_1_2 + 1.666666666666662e-02*G1_0_3_2_0 + 1.666666666666663e-02*G1_0_3_2_1 + 1.666666666666663e-02*G1_0_3_2_2 + 1.666666666666661e-02*G1_1_0_0_0 + 1.666666666666661e-02*G1_1_0_0_1 + 1.666666666666662e-02*G1_1_0_0_2 + 1.666666666666661e-02*G1_1_0_1_0 + 1.666666666666662e-02*G1_1_0_1_1 + 1.666666666666662e-02*G1_1_0_1_2 + 1.666666666666662e-02*G1_1_0_2_0 + 1.666666666666662e-02*G1_1_0_2_1 + 1.666666666666662e-02*G1_1_0_2_2 + 3.333333333333323e-02*G1_1_1_0_0 + 3.333333333333323e-02*G1_1_1_0_1 + 3.333333333333323e-02*G1_1_1_0_2 + 3.333333333333323e-02*G1_1_1_1_0 + 3.333333333333324e-02*G1_1_1_1_1 + 3.333333333333324e-02*G1_1_1_1_2 + 3.333333333333323e-02*G1_1_1_2_0 + 3.333333333333324e-02*G1_1_1_2_1 + 3.333333333333324e-02*G1_1_1_2_2 + 1.666666666666662e-02*G1_1_2_0_0 + 1.666666666666662e-02*G1_1_2_0_1 + 1.666666666666662e-02*G1_1_2_0_2 + 1.666666666666662e-02*G1_1_2_1_0 + 1.666666666666662e-02*G1_1_2_1_1 + 1.666666666666662e-02*G1_1_2_1_2 + 1.666666666666662e-02*G1_1_2_2_0 + 1.666666666666662e-02*G1_1_2_2_1 + 1.666666666666662e-02*G1_1_2_2_2 + 1.666666666666662e-02*G1_1_3_0_0 + 1.666666666666662e-02*G1_1_3_0_1 + 1.666666666666662e-02*G1_1_3_0_2 + 1.666666666666662e-02*G1_1_3_1_0 + 1.666666666666662e-02*G1_1_3_1_1 + 1.666666666666662e-02*G1_1_3_1_2 + 1.666666666666662e-02*G1_1_3_2_0 + 1.666666666666662e-02*G1_1_3_2_1 + 1.666666666666662e-02*G1_1_3_2_2 + 1.666666666666661e-02*G1_2_0_0_0 + 1.666666666666661e-02*G1_2_0_0_1 + 1.666666666666661e-02*G1_2_0_0_2 + 1.666666666666661e-02*G1_2_0_1_0 + 1.666666666666661e-02*G1_2_0_1_1 + 1.666666666666661e-02*G1_2_0_1_2 + 1.666666666666661e-02*G1_2_0_2_0 + 1.666666666666661e-02*G1_2_0_2_1 + 1.666666666666662e-02*G1_2_0_2_2 + 1.666666666666662e-02*G1_2_1_0_0 + 1.666666666666662e-02*G1_2_1_0_1 + 1.666666666666662e-02*G1_2_1_0_2 + 1.666666666666662e-02*G1_2_1_1_0 + 1.666666666666662e-02*G1_2_1_1_1 + 1.666666666666662e-02*G1_2_1_1_2 + 1.666666666666662e-02*G1_2_1_2_0 + 1.666666666666662e-02*G1_2_1_2_1 + 1.666666666666662e-02*G1_2_1_2_2 + 3.333333333333323e-02*G1_2_2_0_0 + 3.333333333333324e-02*G1_2_2_0_1 + 3.333333333333324e-02*G1_2_2_0_2 + 3.333333333333324e-02*G1_2_2_1_0 + 3.333333333333324e-02*G1_2_2_1_1 + 3.333333333333324e-02*G1_2_2_1_2 + 3.333333333333324e-02*G1_2_2_2_0 + 3.333333333333324e-02*G1_2_2_2_1 + 3.333333333333324e-02*G1_2_2_2_2 + 1.666666666666662e-02*G1_2_3_0_0 + 1.666666666666662e-02*G1_2_3_0_1 + 1.666666666666662e-02*G1_2_3_0_2 + 1.666666666666662e-02*G1_2_3_1_0 + 1.666666666666662e-02*G1_2_3_1_1 + 1.666666666666663e-02*G1_2_3_1_2 + 1.666666666666662e-02*G1_2_3_2_0 + 1.666666666666663e-02*G1_2_3_2_1 + 1.666666666666663e-02*G1_2_3_2_2 + 1.666666666666662e-02*G1_3_0_0_0 + 1.666666666666662e-02*G1_3_0_0_1 + 1.666666666666662e-02*G1_3_0_0_2 + 1.666666666666662e-02*G1_3_0_1_0 + 1.666666666666662e-02*G1_3_0_1_1 + 1.666666666666663e-02*G1_3_0_1_2 + 1.666666666666662e-02*G1_3_0_2_0 + 1.666666666666663e-02*G1_3_0_2_1 + 1.666666666666663e-02*G1_3_0_2_2 + 1.666666666666662e-02*G1_3_1_0_0 + 1.666666666666662e-02*G1_3_1_0_1 + 1.666666666666662e-02*G1_3_1_0_2 + 1.666666666666662e-02*G1_3_1_1_0 + 1.666666666666662e-02*G1_3_1_1_1 + 1.666666666666662e-02*G1_3_1_1_2 + 1.666666666666662e-02*G1_3_1_2_0 + 1.666666666666662e-02*G1_3_1_2_1 + 1.666666666666662e-02*G1_3_1_2_2 + 1.666666666666662e-02*G1_3_2_0_0 + 1.666666666666662e-02*G1_3_2_0_1 + 1.666666666666662e-02*G1_3_2_0_2 + 1.666666666666662e-02*G1_3_2_1_0 + 1.666666666666662e-02*G1_3_2_1_1 + 1.666666666666663e-02*G1_3_2_1_2 + 1.666666666666662e-02*G1_3_2_2_0 + 1.666666666666663e-02*G1_3_2_2_1 + 1.666666666666663e-02*G1_3_2_2_2 + 3.333333333333323e-02*G1_3_3_0_0 + 3.333333333333324e-02*G1_3_3_0_1 + 3.333333333333324e-02*G1_3_3_0_2 + 3.333333333333324e-02*G1_3_3_1_0 + 3.333333333333324e-02*G1_3_3_1_1 + 3.333333333333324e-02*G1_3_3_1_2 + 3.333333333333324e-02*G1_3_3_2_0 + 3.333333333333324e-02*G1_3_3_2_1 + 3.333333333333325e-02*G1_3_3_2_2 - 8.333333333333320e-02*G2_0_0_0 - 8.333333333333322e-02*G2_0_0_1 - 8.333333333333322e-02*G2_0_0_2 - 8.333333333333322e-02*G2_0_1_0 - 8.333333333333323e-02*G2_0_1_1 - 8.333333333333323e-02*G2_0_1_2 - 8.333333333333322e-02*G2_0_2_0 - 8.333333333333323e-02*G2_0_2_1 - 8.333333333333323e-02*G2_0_2_2 - 8.333333333333320e-02*G2_1_0_0 - 8.333333333333322e-02*G2_1_0_1 - 8.333333333333322e-02*G2_1_0_2 - 8.333333333333322e-02*G2_1_1_0 - 8.333333333333323e-02*G2_1_1_1 - 8.333333333333323e-02*G2_1_1_2 - 8.333333333333322e-02*G2_1_2_0 - 8.333333333333323e-02*G2_1_2_1 - 8.333333333333323e-02*G2_1_2_2 - 8.333333333333320e-02*G2_2_0_0 - 8.333333333333322e-02*G2_2_0_1 - 8.333333333333322e-02*G2_2_0_2 - 8.333333333333322e-02*G2_2_1_0 - 8.333333333333323e-02*G2_2_1_1 - 8.333333333333323e-02*G2_2_1_2 - 8.333333333333322e-02*G2_2_2_0 - 8.333333333333323e-02*G2_2_2_1 - 8.333333333333323e-02*G2_2_2_2 - 8.333333333333320e-02*G2_3_0_0 - 8.333333333333322e-02*G2_3_0_1 - 8.333333333333322e-02*G2_3_0_2 - 8.333333333333322e-02*G2_3_1_0 - 8.333333333333323e-02*G2_3_1_1 - 8.333333333333323e-02*G2_3_1_2 - 8.333333333333322e-02*G2_3_2_0 - 8.333333333333323e-02*G2_3_2_1 - 8.333333333333323e-02*G2_3_2_2 + 3.333333333333328e-01*G3_0_0 + 3.333333333333329e-01*G3_0_1 + 3.333333333333329e-01*G3_0_2 + 3.333333333333329e-01*G3_1_0 + 3.333333333333329e-01*G3_1_1 + 3.333333333333329e-01*G3_1_2 + 3.333333333333329e-01*G3_2_0 + 3.333333333333329e-01*G3_2_1 + 3.333333333333329e-01*G3_2_2 + 1.333333333333329e-01*G4_0_0_0_0 + 1.333333333333329e-01*G4_0_0_0_1 + 1.333333333333330e-01*G4_0_0_0_2 + 1.333333333333329e-01*G4_0_0_1_0 + 1.333333333333329e-01*G4_0_0_1_1 + 1.333333333333330e-01*G4_0_0_1_2 + 1.333333333333330e-01*G4_0_0_2_0 + 1.333333333333330e-01*G4_0_0_2_1 + 1.333333333333330e-01*G4_0_0_2_2 + 6.666666666666646e-02*G4_0_1_0_0 + 6.666666666666646e-02*G4_0_1_0_1 + 6.666666666666647e-02*G4_0_1_0_2 + 6.666666666666646e-02*G4_0_1_1_0 + 6.666666666666647e-02*G4_0_1_1_1 + 6.666666666666647e-02*G4_0_1_1_2 + 6.666666666666647e-02*G4_0_1_2_0 + 6.666666666666647e-02*G4_0_1_2_1 + 6.666666666666649e-02*G4_0_1_2_2 + 6.666666666666644e-02*G4_0_2_0_0 + 6.666666666666644e-02*G4_0_2_0_1 + 6.666666666666646e-02*G4_0_2_0_2 + 6.666666666666644e-02*G4_0_2_1_0 + 6.666666666666646e-02*G4_0_2_1_1 + 6.666666666666647e-02*G4_0_2_1_2 + 6.666666666666646e-02*G4_0_2_2_0 + 6.666666666666647e-02*G4_0_2_2_1 + 6.666666666666647e-02*G4_0_2_2_2 + 6.666666666666644e-02*G4_0_3_0_0 + 6.666666666666647e-02*G4_0_3_0_1 + 6.666666666666647e-02*G4_0_3_0_2 + 6.666666666666647e-02*G4_0_3_1_0 + 6.666666666666650e-02*G4_0_3_1_1 + 6.666666666666651e-02*G4_0_3_1_2 + 6.666666666666647e-02*G4_0_3_2_0 + 6.666666666666651e-02*G4_0_3_2_1 + 6.666666666666651e-02*G4_0_3_2_2 + 6.666666666666646e-02*G4_1_0_0_0 + 6.666666666666646e-02*G4_1_0_0_1 + 6.666666666666647e-02*G4_1_0_0_2 + 6.666666666666646e-02*G4_1_0_1_0 + 6.666666666666647e-02*G4_1_0_1_1 + 6.666666666666647e-02*G4_1_0_1_2 + 6.666666666666647e-02*G4_1_0_2_0 + 6.666666666666647e-02*G4_1_0_2_1 + 6.666666666666649e-02*G4_1_0_2_2 + 1.333333333333329e-01*G4_1_1_0_0 + 1.333333333333329e-01*G4_1_1_0_1 + 1.333333333333329e-01*G4_1_1_0_2 + 1.333333333333329e-01*G4_1_1_1_0 + 1.333333333333329e-01*G4_1_1_1_1 + 1.333333333333329e-01*G4_1_1_1_2 + 1.333333333333329e-01*G4_1_1_2_0 + 1.333333333333329e-01*G4_1_1_2_1 + 1.333333333333329e-01*G4_1_1_2_2 + 6.666666666666647e-02*G4_1_2_0_0 + 6.666666666666647e-02*G4_1_2_0_1 + 6.666666666666647e-02*G4_1_2_0_2 + 6.666666666666647e-02*G4_1_2_1_0 + 6.666666666666649e-02*G4_1_2_1_1 + 6.666666666666649e-02*G4_1_2_1_2 + 6.666666666666647e-02*G4_1_2_2_0 + 6.666666666666649e-02*G4_1_2_2_1 + 6.666666666666649e-02*G4_1_2_2_2 + 6.666666666666649e-02*G4_1_3_0_0 + 6.666666666666649e-02*G4_1_3_0_1 + 6.666666666666650e-02*G4_1_3_0_2 + 6.666666666666649e-02*G4_1_3_1_0 + 6.666666666666650e-02*G4_1_3_1_1 + 6.666666666666650e-02*G4_1_3_1_2 + 6.666666666666650e-02*G4_1_3_2_0 + 6.666666666666650e-02*G4_1_3_2_1 + 6.666666666666650e-02*G4_1_3_2_2 + 6.666666666666643e-02*G4_2_0_0_0 + 6.666666666666644e-02*G4_2_0_0_1 + 6.666666666666646e-02*G4_2_0_0_2 + 6.666666666666644e-02*G4_2_0_1_0 + 6.666666666666646e-02*G4_2_0_1_1 + 6.666666666666646e-02*G4_2_0_1_2 + 6.666666666666646e-02*G4_2_0_2_0 + 6.666666666666646e-02*G4_2_0_2_1 + 6.666666666666647e-02*G4_2_0_2_2 + 6.666666666666647e-02*G4_2_1_0_0 + 6.666666666666647e-02*G4_2_1_0_1 + 6.666666666666647e-02*G4_2_1_0_2 + 6.666666666666647e-02*G4_2_1_1_0 + 6.666666666666649e-02*G4_2_1_1_1 + 6.666666666666649e-02*G4_2_1_1_2 + 6.666666666666647e-02*G4_2_1_2_0 + 6.666666666666649e-02*G4_2_1_2_1 + 6.666666666666649e-02*G4_2_1_2_2 + 1.333333333333329e-01*G4_2_2_0_0 + 1.333333333333329e-01*G4_2_2_0_1 + 1.333333333333329e-01*G4_2_2_0_2 + 1.333333333333329e-01*G4_2_2_1_0 + 1.333333333333330e-01*G4_2_2_1_1 + 1.333333333333330e-01*G4_2_2_1_2 + 1.333333333333329e-01*G4_2_2_2_0 + 1.333333333333330e-01*G4_2_2_2_1 + 1.333333333333330e-01*G4_2_2_2_2 + 6.666666666666647e-02*G4_2_3_0_0 + 6.666666666666649e-02*G4_2_3_0_1 + 6.666666666666649e-02*G4_2_3_0_2 + 6.666666666666649e-02*G4_2_3_1_0 + 6.666666666666650e-02*G4_2_3_1_1 + 6.666666666666651e-02*G4_2_3_1_2 + 6.666666666666649e-02*G4_2_3_2_0 + 6.666666666666651e-02*G4_2_3_2_1 + 6.666666666666651e-02*G4_2_3_2_2 + 6.666666666666647e-02*G4_3_0_0_0 + 6.666666666666649e-02*G4_3_0_0_1 + 6.666666666666649e-02*G4_3_0_0_2 + 6.666666666666649e-02*G4_3_0_1_0 + 6.666666666666650e-02*G4_3_0_1_1 + 6.666666666666651e-02*G4_3_0_1_2 + 6.666666666666649e-02*G4_3_0_2_0 + 6.666666666666651e-02*G4_3_0_2_1 + 6.666666666666651e-02*G4_3_0_2_2 + 6.666666666666649e-02*G4_3_1_0_0 + 6.666666666666649e-02*G4_3_1_0_1 + 6.666666666666650e-02*G4_3_1_0_2 + 6.666666666666649e-02*G4_3_1_1_0 + 6.666666666666650e-02*G4_3_1_1_1 + 6.666666666666650e-02*G4_3_1_1_2 + 6.666666666666650e-02*G4_3_1_2_0 + 6.666666666666650e-02*G4_3_1_2_1 + 6.666666666666650e-02*G4_3_1_2_2 + 6.666666666666647e-02*G4_3_2_0_0 + 6.666666666666649e-02*G4_3_2_0_1 + 6.666666666666649e-02*G4_3_2_0_2 + 6.666666666666649e-02*G4_3_2_1_0 + 6.666666666666649e-02*G4_3_2_1_1 + 6.666666666666651e-02*G4_3_2_1_2 + 6.666666666666649e-02*G4_3_2_2_0 + 6.666666666666651e-02*G4_3_2_2_1 + 6.666666666666651e-02*G4_3_2_2_2 + 1.333333333333329e-01*G4_3_3_0_0 + 1.333333333333329e-01*G4_3_3_0_1 + 1.333333333333330e-01*G4_3_3_0_2 + 1.333333333333329e-01*G4_3_3_1_0 + 1.333333333333330e-01*G4_3_3_1_1 + 1.333333333333330e-01*G4_3_3_1_2 + 1.333333333333330e-01*G4_3_3_2_0 + 1.333333333333330e-01*G4_3_3_2_1 + 1.333333333333330e-01*G4_3_3_2_2 - 3.333333333333328e-01*G5_0_0_0 - 3.333333333333329e-01*G5_0_0_1 - 3.333333333333329e-01*G5_0_0_2 - 3.333333333333329e-01*G5_0_1_0 - 3.333333333333329e-01*G5_0_1_1 - 3.333333333333329e-01*G5_0_1_2 - 3.333333333333329e-01*G5_0_2_0 - 3.333333333333329e-01*G5_0_2_1 - 3.333333333333329e-01*G5_0_2_2 - 3.333333333333328e-01*G5_1_0_0 - 3.333333333333329e-01*G5_1_0_1 - 3.333333333333329e-01*G5_1_0_2 - 3.333333333333329e-01*G5_1_1_0 - 3.333333333333329e-01*G5_1_1_1 - 3.333333333333329e-01*G5_1_1_2 - 3.333333333333329e-01*G5_1_2_0 - 3.333333333333329e-01*G5_1_2_1 - 3.333333333333329e-01*G5_1_2_2 - 3.333333333333328e-01*G5_2_0_0 - 3.333333333333329e-01*G5_2_0_1 - 3.333333333333329e-01*G5_2_0_2 - 3.333333333333329e-01*G5_2_1_0 - 3.333333333333329e-01*G5_2_1_1 - 3.333333333333329e-01*G5_2_1_2 - 3.333333333333329e-01*G5_2_2_0 - 3.333333333333329e-01*G5_2_2_1 - 3.333333333333329e-01*G5_2_2_2 - 3.333333333333328e-01*G5_3_0_0 - 3.333333333333329e-01*G5_3_0_1 - 3.333333333333329e-01*G5_3_0_2 - 3.333333333333329e-01*G5_3_1_0 - 3.333333333333329e-01*G5_3_1_1 - 3.333333333333329e-01*G5_3_1_2 - 3.333333333333329e-01*G5_3_2_0 - 3.333333333333329e-01*G5_3_2_1 - 3.333333333333329e-01*G5_3_2_2 + 3.999999999999986e-01*G9_0_0_0_0 + 3.999999999999987e-01*G9_0_0_0_1 + 3.999999999999988e-01*G9_0_0_0_2 + 3.999999999999987e-01*G9_0_0_1_0 + 3.999999999999988e-01*G9_0_0_1_1 + 3.999999999999989e-01*G9_0_0_1_2 + 3.999999999999988e-01*G9_0_0_2_0 + 3.999999999999989e-01*G9_0_0_2_1 + 3.999999999999989e-01*G9_0_0_2_2 - 3.999999999999986e-01*G9_0_1_0_0 - 3.999999999999987e-01*G9_0_1_1_0 - 3.999999999999988e-01*G9_0_1_2_0 - 3.999999999999987e-01*G9_0_2_0_1 - 3.999999999999988e-01*G9_0_2_1_1 - 3.999999999999989e-01*G9_0_2_2_1 - 3.999999999999987e-01*G9_0_3_0_2 - 3.999999999999988e-01*G9_0_3_1_2 - 3.999999999999989e-01*G9_0_3_2_2 + 1.999999999999993e-01*G9_1_0_0_0 + 1.999999999999993e-01*G9_1_0_0_1 + 1.999999999999993e-01*G9_1_0_0_2 + 1.999999999999993e-01*G9_1_0_1_0 + 1.999999999999994e-01*G9_1_0_1_1 + 1.999999999999994e-01*G9_1_0_1_2 + 1.999999999999993e-01*G9_1_0_2_0 + 1.999999999999994e-01*G9_1_0_2_1 + 1.999999999999994e-01*G9_1_0_2_2 - 1.999999999999993e-01*G9_1_1_0_0 - 1.999999999999993e-01*G9_1_1_1_0 - 1.999999999999993e-01*G9_1_1_2_0 - 1.999999999999993e-01*G9_1_2_0_1 - 1.999999999999994e-01*G9_1_2_1_1 - 1.999999999999994e-01*G9_1_2_2_1 - 1.999999999999993e-01*G9_1_3_0_2 - 1.999999999999994e-01*G9_1_3_1_2 - 1.999999999999994e-01*G9_1_3_2_2 + 1.999999999999993e-01*G9_2_0_0_0 + 1.999999999999993e-01*G9_2_0_0_1 + 1.999999999999994e-01*G9_2_0_0_2 + 1.999999999999993e-01*G9_2_0_1_0 + 1.999999999999994e-01*G9_2_0_1_1 + 1.999999999999994e-01*G9_2_0_1_2 + 1.999999999999994e-01*G9_2_0_2_0 + 1.999999999999994e-01*G9_2_0_2_1 + 1.999999999999994e-01*G9_2_0_2_2 - 1.999999999999993e-01*G9_2_1_0_0 - 1.999999999999993e-01*G9_2_1_1_0 - 1.999999999999994e-01*G9_2_1_2_0 - 1.999999999999993e-01*G9_2_2_0_1 - 1.999999999999994e-01*G9_2_2_1_1 - 1.999999999999994e-01*G9_2_2_2_1 - 1.999999999999993e-01*G9_2_3_0_2 - 1.999999999999994e-01*G9_2_3_1_2 - 1.999999999999994e-01*G9_2_3_2_2 + 1.999999999999994e-01*G9_3_0_0_0 + 1.999999999999994e-01*G9_3_0_0_1 + 1.999999999999994e-01*G9_3_0_0_2 + 1.999999999999994e-01*G9_3_0_1_0 + 1.999999999999995e-01*G9_3_0_1_1 + 1.999999999999995e-01*G9_3_0_1_2 + 1.999999999999994e-01*G9_3_0_2_0 + 1.999999999999995e-01*G9_3_0_2_1 + 1.999999999999995e-01*G9_3_0_2_2 - 1.999999999999994e-01*G9_3_1_0_0 - 1.999999999999994e-01*G9_3_1_1_0 - 1.999999999999994e-01*G9_3_1_2_0 - 1.999999999999994e-01*G9_3_2_0_1 - 1.999999999999995e-01*G9_3_2_1_1 - 1.999999999999995e-01*G9_3_2_2_1 - 1.999999999999994e-01*G9_3_3_0_2 - 1.999999999999995e-01*G9_3_3_1_2 - 1.999999999999995e-01*G9_3_3_2_2 - 4.999999999999993e-01*G10_0_0_0 - 4.999999999999993e-01*G10_0_0_1 - 4.999999999999993e-01*G10_0_0_2 - 4.999999999999993e-01*G10_0_1_0 - 4.999999999999994e-01*G10_0_1_1 - 4.999999999999994e-01*G10_0_1_2 - 4.999999999999993e-01*G10_0_2_0 - 4.999999999999994e-01*G10_0_2_1 - 4.999999999999994e-01*G10_0_2_2 + 4.999999999999993e-01*G10_1_0_0 + 4.999999999999993e-01*G10_1_1_0 + 4.999999999999993e-01*G10_1_2_0 + 4.999999999999993e-01*G10_2_0_1 + 4.999999999999994e-01*G10_2_1_1 + 4.999999999999994e-01*G10_2_2_1 + 4.999999999999993e-01*G10_3_0_2 + 4.999999999999994e-01*G10_3_1_2 + 4.999999999999994e-01*G10_3_2_2;
    block[1] = 8.333333333333309e-03*G0_ - 3.333333333333323e-02*G1_0_0_0_0 - 3.333333333333324e-02*G1_0_0_1_0 - 3.333333333333324e-02*G1_0_0_2_0 - 1.666666666666661e-02*G1_0_1_0_0 - 1.666666666666661e-02*G1_0_1_1_0 - 1.666666666666662e-02*G1_0_1_2_0 - 1.666666666666661e-02*G1_0_2_0_0 - 1.666666666666661e-02*G1_0_2_1_0 - 1.666666666666661e-02*G1_0_2_2_0 - 1.666666666666661e-02*G1_0_3_0_0 - 1.666666666666662e-02*G1_0_3_1_0 - 1.666666666666662e-02*G1_0_3_2_0 - 1.666666666666661e-02*G1_1_0_0_0 - 1.666666666666661e-02*G1_1_0_1_0 - 1.666666666666662e-02*G1_1_0_2_0 - 3.333333333333323e-02*G1_1_1_0_0 - 3.333333333333323e-02*G1_1_1_1_0 - 3.333333333333323e-02*G1_1_1_2_0 - 1.666666666666662e-02*G1_1_2_0_0 - 1.666666666666662e-02*G1_1_2_1_0 - 1.666666666666662e-02*G1_1_2_2_0 - 1.666666666666662e-02*G1_1_3_0_0 - 1.666666666666662e-02*G1_1_3_1_0 - 1.666666666666662e-02*G1_1_3_2_0 - 1.666666666666661e-02*G1_2_0_0_0 - 1.666666666666661e-02*G1_2_0_1_0 - 1.666666666666661e-02*G1_2_0_2_0 - 1.666666666666662e-02*G1_2_1_0_0 - 1.666666666666662e-02*G1_2_1_1_0 - 1.666666666666662e-02*G1_2_1_2_0 - 3.333333333333323e-02*G1_2_2_0_0 - 3.333333333333324e-02*G1_2_2_1_0 - 3.333333333333324e-02*G1_2_2_2_0 - 1.666666666666662e-02*G1_2_3_0_0 - 1.666666666666662e-02*G1_2_3_1_0 - 1.666666666666662e-02*G1_2_3_2_0 - 1.666666666666662e-02*G1_3_0_0_0 - 1.666666666666662e-02*G1_3_0_1_0 - 1.666666666666662e-02*G1_3_0_2_0 - 1.666666666666662e-02*G1_3_1_0_0 - 1.666666666666662e-02*G1_3_1_1_0 - 1.666666666666662e-02*G1_3_1_2_0 - 1.666666666666662e-02*G1_3_2_0_0 - 1.666666666666662e-02*G1_3_2_1_0 - 1.666666666666662e-02*G1_3_2_2_0 - 3.333333333333323e-02*G1_3_3_0_0 - 3.333333333333324e-02*G1_3_3_1_0 - 3.333333333333324e-02*G1_3_3_2_0 + 8.333333333333320e-02*G2_0_0_0 + 8.333333333333322e-02*G2_0_1_0 + 8.333333333333322e-02*G2_0_2_0 + 8.333333333333320e-02*G2_1_0_0 + 8.333333333333322e-02*G2_1_1_0 + 8.333333333333322e-02*G2_1_2_0 + 8.333333333333320e-02*G2_2_0_0 + 8.333333333333322e-02*G2_2_1_0 + 8.333333333333322e-02*G2_2_2_0 + 8.333333333333320e-02*G2_3_0_0 + 8.333333333333322e-02*G2_3_1_0 + 8.333333333333322e-02*G2_3_2_0 - 3.333333333333328e-01*G3_0_0 - 3.333333333333329e-01*G3_1_0 - 3.333333333333329e-01*G3_2_0 - 1.333333333333329e-01*G4_0_0_0_0 - 1.333333333333329e-01*G4_0_0_1_0 - 1.333333333333330e-01*G4_0_0_2_0 - 6.666666666666646e-02*G4_0_1_0_0 - 6.666666666666646e-02*G4_0_1_1_0 - 6.666666666666647e-02*G4_0_1_2_0 - 6.666666666666644e-02*G4_0_2_0_0 - 6.666666666666644e-02*G4_0_2_1_0 - 6.666666666666646e-02*G4_0_2_2_0 - 6.666666666666644e-02*G4_0_3_0_0 - 6.666666666666647e-02*G4_0_3_1_0 - 6.666666666666647e-02*G4_0_3_2_0 - 6.666666666666646e-02*G4_1_0_0_0 - 6.666666666666646e-02*G4_1_0_1_0 - 6.666666666666647e-02*G4_1_0_2_0 - 1.333333333333329e-01*G4_1_1_0_0 - 1.333333333333329e-01*G4_1_1_1_0 - 1.333333333333329e-01*G4_1_1_2_0 - 6.666666666666647e-02*G4_1_2_0_0 - 6.666666666666647e-02*G4_1_2_1_0 - 6.666666666666647e-02*G4_1_2_2_0 - 6.666666666666649e-02*G4_1_3_0_0 - 6.666666666666649e-02*G4_1_3_1_0 - 6.666666666666650e-02*G4_1_3_2_0 - 6.666666666666643e-02*G4_2_0_0_0 - 6.666666666666644e-02*G4_2_0_1_0 - 6.666666666666646e-02*G4_2_0_2_0 - 6.666666666666647e-02*G4_2_1_0_0 - 6.666666666666647e-02*G4_2_1_1_0 - 6.666666666666647e-02*G4_2_1_2_0 - 1.333333333333329e-01*G4_2_2_0_0 - 1.333333333333329e-01*G4_2_2_1_0 - 1.333333333333329e-01*G4_2_2_2_0 - 6.666666666666647e-02*G4_2_3_0_0 - 6.666666666666649e-02*G4_2_3_1_0 - 6.666666666666649e-02*G4_2_3_2_0 - 6.666666666666647e-02*G4_3_0_0_0 - 6.666666666666649e-02*G4_3_0_1_0 - 6.666666666666649e-02*G4_3_0_2_0 - 6.666666666666649e-02*G4_3_1_0_0 - 6.666666666666649e-02*G4_3_1_1_0 - 6.666666666666650e-02*G4_3_1_2_0 - 6.666666666666647e-02*G4_3_2_0_0 - 6.666666666666649e-02*G4_3_2_1_0 - 6.666666666666649e-02*G4_3_2_2_0 - 1.333333333333329e-01*G4_3_3_0_0 - 1.333333333333329e-01*G4_3_3_1_0 - 1.333333333333330e-01*G4_3_3_2_0 + 3.333333333333328e-01*G5_0_0_0 + 3.333333333333329e-01*G5_0_1_0 + 3.333333333333329e-01*G5_0_2_0 + 3.333333333333328e-01*G5_1_0_0 + 3.333333333333329e-01*G5_1_1_0 + 3.333333333333329e-01*G5_1_2_0 + 3.333333333333328e-01*G5_2_0_0 + 3.333333333333329e-01*G5_2_1_0 + 3.333333333333329e-01*G5_2_2_0 + 3.333333333333328e-01*G5_3_0_0 + 3.333333333333329e-01*G5_3_1_0 + 3.333333333333329e-01*G5_3_2_0 + 1.999999999999993e-01*G9_0_0_0_0 + 1.999999999999993e-01*G9_0_0_0_1 + 1.999999999999994e-01*G9_0_0_0_2 + 1.999999999999993e-01*G9_0_0_1_0 + 1.999999999999994e-01*G9_0_0_1_1 + 1.999999999999994e-01*G9_0_0_1_2 + 1.999999999999994e-01*G9_0_0_2_0 + 1.999999999999994e-01*G9_0_0_2_1 + 1.999999999999994e-01*G9_0_0_2_2 - 1.999999999999993e-01*G9_0_1_0_0 - 1.999999999999993e-01*G9_0_1_1_0 - 1.999999999999994e-01*G9_0_1_2_0 - 1.999999999999993e-01*G9_0_2_0_1 - 1.999999999999994e-01*G9_0_2_1_1 - 1.999999999999994e-01*G9_0_2_2_1 - 1.999999999999993e-01*G9_0_3_0_2 - 1.999999999999994e-01*G9_0_3_1_2 - 1.999999999999994e-01*G9_0_3_2_2 + 3.999999999999986e-01*G9_1_0_0_0 + 3.999999999999987e-01*G9_1_0_0_1 + 3.999999999999987e-01*G9_1_0_0_2 + 3.999999999999987e-01*G9_1_0_1_0 + 3.999999999999989e-01*G9_1_0_1_1 + 3.999999999999989e-01*G9_1_0_1_2 + 3.999999999999987e-01*G9_1_0_2_0 + 3.999999999999989e-01*G9_1_0_2_1 + 3.999999999999989e-01*G9_1_0_2_2 - 3.999999999999986e-01*G9_1_1_0_0 - 3.999999999999987e-01*G9_1_1_1_0 - 3.999999999999987e-01*G9_1_1_2_0 - 3.999999999999987e-01*G9_1_2_0_1 - 3.999999999999989e-01*G9_1_2_1_1 - 3.999999999999989e-01*G9_1_2_2_1 - 3.999999999999987e-01*G9_1_3_0_2 - 3.999999999999989e-01*G9_1_3_1_2 - 3.999999999999989e-01*G9_1_3_2_2 + 1.999999999999994e-01*G9_2_0_0_0 + 1.999999999999994e-01*G9_2_0_0_1 + 1.999999999999994e-01*G9_2_0_0_2 + 1.999999999999994e-01*G9_2_0_1_0 + 1.999999999999995e-01*G9_2_0_1_1 + 1.999999999999995e-01*G9_2_0_1_2 + 1.999999999999994e-01*G9_2_0_2_0 + 1.999999999999995e-01*G9_2_0_2_1 + 1.999999999999995e-01*G9_2_0_2_2 - 1.999999999999994e-01*G9_2_1_0_0 - 1.999999999999994e-01*G9_2_1_1_0 - 1.999999999999994e-01*G9_2_1_2_0 - 1.999999999999994e-01*G9_2_2_0_1 - 1.999999999999995e-01*G9_2_2_1_1 - 1.999999999999995e-01*G9_2_2_2_1 - 1.999999999999994e-01*G9_2_3_0_2 - 1.999999999999995e-01*G9_2_3_1_2 - 1.999999999999995e-01*G9_2_3_2_2 + 1.999999999999994e-01*G9_3_0_0_0 + 1.999999999999994e-01*G9_3_0_0_1 + 1.999999999999995e-01*G9_3_0_0_2 + 1.999999999999994e-01*G9_3_0_1_0 + 1.999999999999995e-01*G9_3_0_1_1 + 1.999999999999995e-01*G9_3_0_1_2 + 1.999999999999995e-01*G9_3_0_2_0 + 1.999999999999995e-01*G9_3_0_2_1 + 1.999999999999995e-01*G9_3_0_2_2 - 1.999999999999994e-01*G9_3_1_0_0 - 1.999999999999994e-01*G9_3_1_1_0 - 1.999999999999995e-01*G9_3_1_2_0 - 1.999999999999994e-01*G9_3_2_0_1 - 1.999999999999995e-01*G9_3_2_1_1 - 1.999999999999995e-01*G9_3_2_2_1 - 1.999999999999994e-01*G9_3_3_0_2 - 1.999999999999995e-01*G9_3_3_1_2 - 1.999999999999995e-01*G9_3_3_2_2 - 4.999999999999993e-01*G10_0_0_0 - 4.999999999999993e-01*G10_0_0_1 - 4.999999999999993e-01*G10_0_0_2 - 4.999999999999993e-01*G10_0_1_0 - 4.999999999999994e-01*G10_0_1_1 - 4.999999999999994e-01*G10_0_1_2 - 4.999999999999993e-01*G10_0_2_0 - 4.999999999999994e-01*G10_0_2_1 - 4.999999999999994e-01*G10_0_2_2 + 4.999999999999993e-01*G10_1_0_0 + 4.999999999999993e-01*G10_1_1_0 + 4.999999999999993e-01*G10_1_2_0 + 4.999999999999993e-01*G10_2_0_1 + 4.999999999999994e-01*G10_2_1_1 + 4.999999999999994e-01*G10_2_2_1 + 4.999999999999993e-01*G10_3_0_2 + 4.999999999999994e-01*G10_3_1_2 + 4.999999999999994e-01*G10_3_2_2;
    block[2] = 8.333333333333307e-03*G0_ - 3.333333333333324e-02*G1_0_0_0_1 - 3.333333333333324e-02*G1_0_0_1_1 - 3.333333333333324e-02*G1_0_0_2_1 - 1.666666666666661e-02*G1_0_1_0_1 - 1.666666666666662e-02*G1_0_1_1_1 - 1.666666666666662e-02*G1_0_1_2_1 - 1.666666666666661e-02*G1_0_2_0_1 - 1.666666666666661e-02*G1_0_2_1_1 - 1.666666666666662e-02*G1_0_2_2_1 - 1.666666666666662e-02*G1_0_3_0_1 - 1.666666666666662e-02*G1_0_3_1_1 - 1.666666666666663e-02*G1_0_3_2_1 - 1.666666666666661e-02*G1_1_0_0_1 - 1.666666666666662e-02*G1_1_0_1_1 - 1.666666666666662e-02*G1_1_0_2_1 - 3.333333333333323e-02*G1_1_1_0_1 - 3.333333333333324e-02*G1_1_1_1_1 - 3.333333333333324e-02*G1_1_1_2_1 - 1.666666666666662e-02*G1_1_2_0_1 - 1.666666666666662e-02*G1_1_2_1_1 - 1.666666666666662e-02*G1_1_2_2_1 - 1.666666666666662e-02*G1_1_3_0_1 - 1.666666666666662e-02*G1_1_3_1_1 - 1.666666666666662e-02*G1_1_3_2_1 - 1.666666666666661e-02*G1_2_0_0_1 - 1.666666666666661e-02*G1_2_0_1_1 - 1.666666666666661e-02*G1_2_0_2_1 - 1.666666666666662e-02*G1_2_1_0_1 - 1.666666666666662e-02*G1_2_1_1_1 - 1.666666666666662e-02*G1_2_1_2_1 - 3.333333333333324e-02*G1_2_2_0_1 - 3.333333333333324e-02*G1_2_2_1_1 - 3.333333333333324e-02*G1_2_2_2_1 - 1.666666666666662e-02*G1_2_3_0_1 - 1.666666666666662e-02*G1_2_3_1_1 - 1.666666666666663e-02*G1_2_3_2_1 - 1.666666666666662e-02*G1_3_0_0_1 - 1.666666666666662e-02*G1_3_0_1_1 - 1.666666666666663e-02*G1_3_0_2_1 - 1.666666666666662e-02*G1_3_1_0_1 - 1.666666666666662e-02*G1_3_1_1_1 - 1.666666666666662e-02*G1_3_1_2_1 - 1.666666666666662e-02*G1_3_2_0_1 - 1.666666666666662e-02*G1_3_2_1_1 - 1.666666666666663e-02*G1_3_2_2_1 - 3.333333333333324e-02*G1_3_3_0_1 - 3.333333333333324e-02*G1_3_3_1_1 - 3.333333333333324e-02*G1_3_3_2_1 + 8.333333333333322e-02*G2_0_0_1 + 8.333333333333323e-02*G2_0_1_1 + 8.333333333333323e-02*G2_0_2_1 + 8.333333333333322e-02*G2_1_0_1 + 8.333333333333323e-02*G2_1_1_1 + 8.333333333333323e-02*G2_1_2_1 + 8.333333333333322e-02*G2_2_0_1 + 8.333333333333323e-02*G2_2_1_1 + 8.333333333333323e-02*G2_2_2_1 + 8.333333333333322e-02*G2_3_0_1 + 8.333333333333323e-02*G2_3_1_1 + 8.333333333333323e-02*G2_3_2_1 - 3.333333333333329e-01*G3_0_1 - 3.333333333333329e-01*G3_1_1 - 3.333333333333329e-01*G3_2_1 - 1.333333333333329e-01*G4_0_0_0_1 - 1.333333333333329e-01*G4_0_0_1_1 - 1.333333333333330e-01*G4_0_0_2_1 - 6.666666666666646e-02*G4_0_1_0_1 - 6.666666666666647e-02*G4_0_1_1_1 - 6.666666666666647e-02*G4_0_1_2_1 - 6.666666666666644e-02*G4_0_2_0_1 - 6.666666666666646e-02*G4_0_2_1_1 - 6.666666666666647e-02*G4_0_2_2_1 - 6.666666666666647e-02*G4_0_3_0_1 - 6.666666666666650e-02*G4_0_3_1_1 - 6.666666666666651e-02*G4_0_3_2_1 - 6.666666666666646e-02*G4_1_0_0_1 - 6.666666666666647e-02*G4_1_0_1_1 - 6.666666666666647e-02*G4_1_0_2_1 - 1.333333333333329e-01*G4_1_1_0_1 - 1.333333333333329e-01*G4_1_1_1_1 - 1.333333333333329e-01*G4_1_1_2_1 - 6.666666666666647e-02*G4_1_2_0_1 - 6.666666666666649e-02*G4_1_2_1_1 - 6.666666666666649e-02*G4_1_2_2_1 - 6.666666666666649e-02*G4_1_3_0_1 - 6.666666666666650e-02*G4_1_3_1_1 - 6.666666666666650e-02*G4_1_3_2_1 - 6.666666666666644e-02*G4_2_0_0_1 - 6.666666666666646e-02*G4_2_0_1_1 - 6.666666666666646e-02*G4_2_0_2_1 - 6.666666666666647e-02*G4_2_1_0_1 - 6.666666666666649e-02*G4_2_1_1_1 - 6.666666666666649e-02*G4_2_1_2_1 - 1.333333333333329e-01*G4_2_2_0_1 - 1.333333333333330e-01*G4_2_2_1_1 - 1.333333333333330e-01*G4_2_2_2_1 - 6.666666666666649e-02*G4_2_3_0_1 - 6.666666666666650e-02*G4_2_3_1_1 - 6.666666666666651e-02*G4_2_3_2_1 - 6.666666666666649e-02*G4_3_0_0_1 - 6.666666666666650e-02*G4_3_0_1_1 - 6.666666666666651e-02*G4_3_0_2_1 - 6.666666666666649e-02*G4_3_1_0_1 - 6.666666666666650e-02*G4_3_1_1_1 - 6.666666666666650e-02*G4_3_1_2_1 - 6.666666666666649e-02*G4_3_2_0_1 - 6.666666666666649e-02*G4_3_2_1_1 - 6.666666666666651e-02*G4_3_2_2_1 - 1.333333333333329e-01*G4_3_3_0_1 - 1.333333333333330e-01*G4_3_3_1_1 - 1.333333333333330e-01*G4_3_3_2_1 + 3.333333333333329e-01*G5_0_0_1 + 3.333333333333329e-01*G5_0_1_1 + 3.333333333333329e-01*G5_0_2_1 + 3.333333333333329e-01*G5_1_0_1 + 3.333333333333329e-01*G5_1_1_1 + 3.333333333333329e-01*G5_1_2_1 + 3.333333333333329e-01*G5_2_0_1 + 3.333333333333329e-01*G5_2_1_1 + 3.333333333333329e-01*G5_2_2_1 + 3.333333333333329e-01*G5_3_0_1 + 3.333333333333329e-01*G5_3_1_1 + 3.333333333333329e-01*G5_3_2_1 + 1.999999999999993e-01*G9_0_0_0_0 + 1.999999999999993e-01*G9_0_0_0_1 + 1.999999999999994e-01*G9_0_0_0_2 + 1.999999999999993e-01*G9_0_0_1_0 + 1.999999999999994e-01*G9_0_0_1_1 + 1.999999999999994e-01*G9_0_0_1_2 + 1.999999999999994e-01*G9_0_0_2_0 + 1.999999999999994e-01*G9_0_0_2_1 + 1.999999999999994e-01*G9_0_0_2_2 - 1.999999999999993e-01*G9_0_1_0_0 - 1.999999999999993e-01*G9_0_1_1_0 - 1.999999999999994e-01*G9_0_1_2_0 - 1.999999999999993e-01*G9_0_2_0_1 - 1.999999999999994e-01*G9_0_2_1_1 - 1.999999999999994e-01*G9_0_2_2_1 - 1.999999999999993e-01*G9_0_3_0_2 - 1.999999999999994e-01*G9_0_3_1_2 - 1.999999999999994e-01*G9_0_3_2_2 + 1.999999999999994e-01*G9_1_0_0_0 + 1.999999999999994e-01*G9_1_0_0_1 + 1.999999999999994e-01*G9_1_0_0_2 + 1.999999999999994e-01*G9_1_0_1_0 + 1.999999999999995e-01*G9_1_0_1_1 + 1.999999999999995e-01*G9_1_0_1_2 + 1.999999999999994e-01*G9_1_0_2_0 + 1.999999999999995e-01*G9_1_0_2_1 + 1.999999999999995e-01*G9_1_0_2_2 - 1.999999999999994e-01*G9_1_1_0_0 - 1.999999999999994e-01*G9_1_1_1_0 - 1.999999999999994e-01*G9_1_1_2_0 - 1.999999999999994e-01*G9_1_2_0_1 - 1.999999999999995e-01*G9_1_2_1_1 - 1.999999999999995e-01*G9_1_2_2_1 - 1.999999999999994e-01*G9_1_3_0_2 - 1.999999999999995e-01*G9_1_3_1_2 - 1.999999999999995e-01*G9_1_3_2_2 + 3.999999999999987e-01*G9_2_0_0_0 + 3.999999999999987e-01*G9_2_0_0_1 + 3.999999999999987e-01*G9_2_0_0_2 + 3.999999999999987e-01*G9_2_0_1_0 + 3.999999999999989e-01*G9_2_0_1_1 + 3.999999999999989e-01*G9_2_0_1_2 + 3.999999999999987e-01*G9_2_0_2_0 + 3.999999999999989e-01*G9_2_0_2_1 + 3.999999999999989e-01*G9_2_0_2_2 - 3.999999999999987e-01*G9_2_1_0_0 - 3.999999999999987e-01*G9_2_1_1_0 - 3.999999999999987e-01*G9_2_1_2_0 - 3.999999999999987e-01*G9_2_2_0_1 - 3.999999999999989e-01*G9_2_2_1_1 - 3.999999999999989e-01*G9_2_2_2_1 - 3.999999999999987e-01*G9_2_3_0_2 - 3.999999999999989e-01*G9_2_3_1_2 - 3.999999999999989e-01*G9_2_3_2_2 + 1.999999999999994e-01*G9_3_0_0_0 + 1.999999999999995e-01*G9_3_0_0_1 + 1.999999999999995e-01*G9_3_0_0_2 + 1.999999999999995e-01*G9_3_0_1_0 + 1.999999999999995e-01*G9_3_0_1_1 + 1.999999999999995e-01*G9_3_0_1_2 + 1.999999999999995e-01*G9_3_0_2_0 + 1.999999999999995e-01*G9_3_0_2_1 + 1.999999999999995e-01*G9_3_0_2_2 - 1.999999999999994e-01*G9_3_1_0_0 - 1.999999999999995e-01*G9_3_1_1_0 - 1.999999999999995e-01*G9_3_1_2_0 - 1.999999999999995e-01*G9_3_2_0_1 - 1.999999999999995e-01*G9_3_2_1_1 - 1.999999999999995e-01*G9_3_2_2_1 - 1.999999999999995e-01*G9_3_3_0_2 - 1.999999999999995e-01*G9_3_3_1_2 - 1.999999999999995e-01*G9_3_3_2_2 - 4.999999999999993e-01*G10_0_0_0 - 4.999999999999993e-01*G10_0_0_1 - 4.999999999999993e-01*G10_0_0_2 - 4.999999999999993e-01*G10_0_1_0 - 4.999999999999994e-01*G10_0_1_1 - 4.999999999999994e-01*G10_0_1_2 - 4.999999999999993e-01*G10_0_2_0 - 4.999999999999994e-01*G10_0_2_1 - 4.999999999999994e-01*G10_0_2_2 + 4.999999999999993e-01*G10_1_0_0 + 4.999999999999993e-01*G10_1_1_0 + 4.999999999999993e-01*G10_1_2_0 + 4.999999999999993e-01*G10_2_0_1 + 4.999999999999994e-01*G10_2_1_1 + 4.999999999999994e-01*G10_2_2_1 + 4.999999999999993e-01*G10_3_0_2 + 4.999999999999994e-01*G10_3_1_2 + 4.999999999999994e-01*G10_3_2_2;
    block[3] = 8.333333333333312e-03*G0_ - 3.333333333333324e-02*G1_0_0_0_2 - 3.333333333333324e-02*G1_0_0_1_2 - 3.333333333333324e-02*G1_0_0_2_2 - 1.666666666666661e-02*G1_0_1_0_2 - 1.666666666666662e-02*G1_0_1_1_2 - 1.666666666666662e-02*G1_0_1_2_2 - 1.666666666666661e-02*G1_0_2_0_2 - 1.666666666666661e-02*G1_0_2_1_2 - 1.666666666666662e-02*G1_0_2_2_2 - 1.666666666666662e-02*G1_0_3_0_2 - 1.666666666666662e-02*G1_0_3_1_2 - 1.666666666666663e-02*G1_0_3_2_2 - 1.666666666666661e-02*G1_1_0_0_2 - 1.666666666666662e-02*G1_1_0_1_2 - 1.666666666666662e-02*G1_1_0_2_2 - 3.333333333333323e-02*G1_1_1_0_2 - 3.333333333333324e-02*G1_1_1_1_2 - 3.333333333333324e-02*G1_1_1_2_2 - 1.666666666666662e-02*G1_1_2_0_2 - 1.666666666666662e-02*G1_1_2_1_2 - 1.666666666666662e-02*G1_1_2_2_2 - 1.666666666666662e-02*G1_1_3_0_2 - 1.666666666666662e-02*G1_1_3_1_2 - 1.666666666666662e-02*G1_1_3_2_2 - 1.666666666666661e-02*G1_2_0_0_2 - 1.666666666666661e-02*G1_2_0_1_2 - 1.666666666666661e-02*G1_2_0_2_2 - 1.666666666666662e-02*G1_2_1_0_2 - 1.666666666666662e-02*G1_2_1_1_2 - 1.666666666666662e-02*G1_2_1_2_2 - 3.333333333333324e-02*G1_2_2_0_2 - 3.333333333333324e-02*G1_2_2_1_2 - 3.333333333333324e-02*G1_2_2_2_2 - 1.666666666666662e-02*G1_2_3_0_2 - 1.666666666666662e-02*G1_2_3_1_2 - 1.666666666666663e-02*G1_2_3_2_2 - 1.666666666666662e-02*G1_3_0_0_2 - 1.666666666666662e-02*G1_3_0_1_2 - 1.666666666666663e-02*G1_3_0_2_2 - 1.666666666666662e-02*G1_3_1_0_2 - 1.666666666666662e-02*G1_3_1_1_2 - 1.666666666666662e-02*G1_3_1_2_2 - 1.666666666666662e-02*G1_3_2_0_2 - 1.666666666666662e-02*G1_3_2_1_2 - 1.666666666666663e-02*G1_3_2_2_2 - 3.333333333333324e-02*G1_3_3_0_2 - 3.333333333333324e-02*G1_3_3_1_2 - 3.333333333333324e-02*G1_3_3_2_2 + 8.333333333333322e-02*G2_0_0_2 + 8.333333333333323e-02*G2_0_1_2 + 8.333333333333323e-02*G2_0_2_2 + 8.333333333333322e-02*G2_1_0_2 + 8.333333333333323e-02*G2_1_1_2 + 8.333333333333323e-02*G2_1_2_2 + 8.333333333333322e-02*G2_2_0_2 + 8.333333333333323e-02*G2_2_1_2 + 8.333333333333323e-02*G2_2_2_2 + 8.333333333333322e-02*G2_3_0_2 + 8.333333333333323e-02*G2_3_1_2 + 8.333333333333323e-02*G2_3_2_2 - 3.333333333333329e-01*G3_0_2 - 3.333333333333329e-01*G3_1_2 - 3.333333333333329e-01*G3_2_2 - 1.333333333333329e-01*G4_0_0_0_2 - 1.333333333333329e-01*G4_0_0_1_2 - 1.333333333333330e-01*G4_0_0_2_2 - 6.666666666666646e-02*G4_0_1_0_2 - 6.666666666666647e-02*G4_0_1_1_2 - 6.666666666666647e-02*G4_0_1_2_2 - 6.666666666666644e-02*G4_0_2_0_2 - 6.666666666666646e-02*G4_0_2_1_2 - 6.666666666666647e-02*G4_0_2_2_2 - 6.666666666666647e-02*G4_0_3_0_2 - 6.666666666666650e-02*G4_0_3_1_2 - 6.666666666666651e-02*G4_0_3_2_2 - 6.666666666666646e-02*G4_1_0_0_2 - 6.666666666666647e-02*G4_1_0_1_2 - 6.666666666666647e-02*G4_1_0_2_2 - 1.333333333333329e-01*G4_1_1_0_2 - 1.333333333333329e-01*G4_1_1_1_2 - 1.333333333333329e-01*G4_1_1_2_2 - 6.666666666666647e-02*G4_1_2_0_2 - 6.666666666666649e-02*G4_1_2_1_2 - 6.666666666666649e-02*G4_1_2_2_2 - 6.666666666666649e-02*G4_1_3_0_2 - 6.666666666666650e-02*G4_1_3_1_2 - 6.666666666666650e-02*G4_1_3_2_2 - 6.666666666666644e-02*G4_2_0_0_2 - 6.666666666666646e-02*G4_2_0_1_2 - 6.666666666666646e-02*G4_2_0_2_2 - 6.666666666666647e-02*G4_2_1_0_2 - 6.666666666666649e-02*G4_2_1_1_2 - 6.666666666666649e-02*G4_2_1_2_2 - 1.333333333333329e-01*G4_2_2_0_2 - 1.333333333333330e-01*G4_2_2_1_2 - 1.333333333333330e-01*G4_2_2_2_2 - 6.666666666666649e-02*G4_2_3_0_2 - 6.666666666666650e-02*G4_2_3_1_2 - 6.666666666666651e-02*G4_2_3_2_2 - 6.666666666666649e-02*G4_3_0_0_2 - 6.666666666666650e-02*G4_3_0_1_2 - 6.666666666666651e-02*G4_3_0_2_2 - 6.666666666666649e-02*G4_3_1_0_2 - 6.666666666666650e-02*G4_3_1_1_2 - 6.666666666666650e-02*G4_3_1_2_2 - 6.666666666666649e-02*G4_3_2_0_2 - 6.666666666666649e-02*G4_3_2_1_2 - 6.666666666666651e-02*G4_3_2_2_2 - 1.333333333333329e-01*G4_3_3_0_2 - 1.333333333333330e-01*G4_3_3_1_2 - 1.333333333333330e-01*G4_3_3_2_2 + 3.333333333333329e-01*G5_0_0_2 + 3.333333333333329e-01*G5_0_1_2 + 3.333333333333329e-01*G5_0_2_2 + 3.333333333333329e-01*G5_1_0_2 + 3.333333333333329e-01*G5_1_1_2 + 3.333333333333329e-01*G5_1_2_2 + 3.333333333333329e-01*G5_2_0_2 + 3.333333333333329e-01*G5_2_1_2 + 3.333333333333329e-01*G5_2_2_2 + 3.333333333333329e-01*G5_3_0_2 + 3.333333333333329e-01*G5_3_1_2 + 3.333333333333329e-01*G5_3_2_2 + 1.999999999999994e-01*G9_0_0_0_0 + 1.999999999999994e-01*G9_0_0_0_1 + 1.999999999999994e-01*G9_0_0_0_2 + 1.999999999999994e-01*G9_0_0_1_0 + 1.999999999999995e-01*G9_0_0_1_1 + 1.999999999999995e-01*G9_0_0_1_2 + 1.999999999999994e-01*G9_0_0_2_0 + 1.999999999999995e-01*G9_0_0_2_1 + 1.999999999999995e-01*G9_0_0_2_2 - 1.999999999999994e-01*G9_0_1_0_0 - 1.999999999999994e-01*G9_0_1_1_0 - 1.999999999999994e-01*G9_0_1_2_0 - 1.999999999999994e-01*G9_0_2_0_1 - 1.999999999999995e-01*G9_0_2_1_1 - 1.999999999999995e-01*G9_0_2_2_1 - 1.999999999999994e-01*G9_0_3_0_2 - 1.999999999999995e-01*G9_0_3_1_2 - 1.999999999999995e-01*G9_0_3_2_2 + 1.999999999999994e-01*G9_1_0_0_0 + 1.999999999999994e-01*G9_1_0_0_1 + 1.999999999999995e-01*G9_1_0_0_2 + 1.999999999999994e-01*G9_1_0_1_0 + 1.999999999999995e-01*G9_1_0_1_1 + 1.999999999999995e-01*G9_1_0_1_2 + 1.999999999999995e-01*G9_1_0_2_0 + 1.999999999999995e-01*G9_1_0_2_1 + 1.999999999999995e-01*G9_1_0_2_2 - 1.999999999999994e-01*G9_1_1_0_0 - 1.999999999999994e-01*G9_1_1_1_0 - 1.999999999999995e-01*G9_1_1_2_0 - 1.999999999999994e-01*G9_1_2_0_1 - 1.999999999999995e-01*G9_1_2_1_1 - 1.999999999999995e-01*G9_1_2_2_1 - 1.999999999999994e-01*G9_1_3_0_2 - 1.999999999999995e-01*G9_1_3_1_2 - 1.999999999999995e-01*G9_1_3_2_2 + 1.999999999999994e-01*G9_2_0_0_0 + 1.999999999999995e-01*G9_2_0_0_1 + 1.999999999999995e-01*G9_2_0_0_2 + 1.999999999999995e-01*G9_2_0_1_0 + 1.999999999999995e-01*G9_2_0_1_1 + 1.999999999999995e-01*G9_2_0_1_2 + 1.999999999999995e-01*G9_2_0_2_0 + 1.999999999999995e-01*G9_2_0_2_1 + 1.999999999999995e-01*G9_2_0_2_2 - 1.999999999999994e-01*G9_2_1_0_0 - 1.999999999999995e-01*G9_2_1_1_0 - 1.999999999999995e-01*G9_2_1_2_0 - 1.999999999999995e-01*G9_2_2_0_1 - 1.999999999999995e-01*G9_2_2_1_1 - 1.999999999999995e-01*G9_2_2_2_1 - 1.999999999999995e-01*G9_2_3_0_2 - 1.999999999999995e-01*G9_2_3_1_2 - 1.999999999999995e-01*G9_2_3_2_2 + 3.999999999999988e-01*G9_3_0_0_0 + 3.999999999999988e-01*G9_3_0_0_1 + 3.999999999999989e-01*G9_3_0_0_2 + 3.999999999999988e-01*G9_3_0_1_0 + 3.999999999999989e-01*G9_3_0_1_1 + 3.999999999999989e-01*G9_3_0_1_2 + 3.999999999999989e-01*G9_3_0_2_0 + 3.999999999999989e-01*G9_3_0_2_1 + 3.999999999999989e-01*G9_3_0_2_2 - 3.999999999999988e-01*G9_3_1_0_0 - 3.999999999999988e-01*G9_3_1_1_0 - 3.999999999999989e-01*G9_3_1_2_0 - 3.999999999999988e-01*G9_3_2_0_1 - 3.999999999999989e-01*G9_3_2_1_1 - 3.999999999999989e-01*G9_3_2_2_1 - 3.999999999999988e-01*G9_3_3_0_2 - 3.999999999999989e-01*G9_3_3_1_2 - 3.999999999999989e-01*G9_3_3_2_2 - 4.999999999999993e-01*G10_0_0_0 - 4.999999999999993e-01*G10_0_0_1 - 4.999999999999993e-01*G10_0_0_2 - 4.999999999999993e-01*G10_0_1_0 - 4.999999999999994e-01*G10_0_1_1 - 4.999999999999994e-01*G10_0_1_2 - 4.999999999999993e-01*G10_0_2_0 - 4.999999999999994e-01*G10_0_2_1 - 4.999999999999994e-01*G10_0_2_2 + 4.999999999999993e-01*G10_1_0_0 + 4.999999999999993e-01*G10_1_1_0 + 4.999999999999993e-01*G10_1_2_0 + 4.999999999999993e-01*G10_2_0_1 + 4.999999999999994e-01*G10_2_1_1 + 4.999999999999994e-01*G10_2_2_1 + 4.999999999999993e-01*G10_3_0_2 + 4.999999999999994e-01*G10_3_1_2 + 4.999999999999994e-01*G10_3_2_2;
    block[4] = -1.666666666666664e-01*G11_0_0 - 1.666666666666664e-01*G11_0_1 - 1.666666666666664e-01*G11_0_2 - 1.666666666666664e-01*G11_1_0 - 1.666666666666665e-01*G11_1_1 - 1.666666666666665e-01*G11_1_2 - 1.666666666666664e-01*G11_2_0 - 1.666666666666665e-01*G11_2_1 - 1.666666666666665e-01*G11_2_2;
    block[5] = 1.666666666666664e-01*G11_0_0 + 1.666666666666664e-01*G11_1_0 + 1.666666666666664e-01*G11_2_0;
    block[6] = 1.666666666666664e-01*G11_0_1 + 1.666666666666665e-01*G11_1_1 + 1.666666666666665e-01*G11_2_1;
    block[7] = 1.666666666666664e-01*G11_0_2 + 1.666666666666665e-01*G11_1_2 + 1.666666666666665e-01*G11_2_2;
    block[8] = 8.333333333333309e-03*G0_ - 3.333333333333323e-02*G1_0_0_0_0 - 3.333333333333324e-02*G1_0_0_0_1 - 3.333333333333324e-02*G1_0_0_0_2 - 1.666666666666661e-02*G1_0_1_0_0 - 1.666666666666661e-02*G1_0_1_0_1 - 1.666666666666662e-02*G1_0_1_0_2 - 1.666666666666661e-02*G1_0_2_0_0 - 1.666666666666661e-02*G1_0_2_0_1 - 1.666666666666661e-02*G1_0_2_0_2 - 1.666666666666661e-02*G1_0_3_0_0 - 1.666666666666662e-02*G1_0_3_0_1 - 1.666666666666662e-02*G1_0_3_0_2 - 1.666666666666661e-02*G1_1_0_0_0 - 1.666666666666661e-02*G1_1_0_0_1 - 1.666666666666662e-02*G1_1_0_0_2 - 3.333333333333323e-02*G1_1_1_0_0 - 3.333333333333323e-02*G1_1_1_0_1 - 3.333333333333323e-02*G1_1_1_0_2 - 1.666666666666662e-02*G1_1_2_0_0 - 1.666666666666662e-02*G1_1_2_0_1 - 1.666666666666662e-02*G1_1_2_0_2 - 1.666666666666662e-02*G1_1_3_0_0 - 1.666666666666662e-02*G1_1_3_0_1 - 1.666666666666662e-02*G1_1_3_0_2 - 1.666666666666661e-02*G1_2_0_0_0 - 1.666666666666661e-02*G1_2_0_0_1 - 1.666666666666661e-02*G1_2_0_0_2 - 1.666666666666662e-02*G1_2_1_0_0 - 1.666666666666662e-02*G1_2_1_0_1 - 1.666666666666662e-02*G1_2_1_0_2 - 3.333333333333323e-02*G1_2_2_0_0 - 3.333333333333324e-02*G1_2_2_0_1 - 3.333333333333324e-02*G1_2_2_0_2 - 1.666666666666662e-02*G1_2_3_0_0 - 1.666666666666662e-02*G1_2_3_0_1 - 1.666666666666662e-02*G1_2_3_0_2 - 1.666666666666662e-02*G1_3_0_0_0 - 1.666666666666662e-02*G1_3_0_0_1 - 1.666666666666662e-02*G1_3_0_0_2 - 1.666666666666662e-02*G1_3_1_0_0 - 1.666666666666662e-02*G1_3_1_0_1 - 1.666666666666662e-02*G1_3_1_0_2 - 1.666666666666662e-02*G1_3_2_0_0 - 1.666666666666662e-02*G1_3_2_0_1 - 1.666666666666662e-02*G1_3_2_0_2 - 3.333333333333323e-02*G1_3_3_0_0 - 3.333333333333324e-02*G1_3_3_0_1 - 3.333333333333324e-02*G1_3_3_0_2 + 8.333333333333320e-02*G2_0_0_0 + 8.333333333333322e-02*G2_0_0_1 + 8.333333333333322e-02*G2_0_0_2 + 8.333333333333320e-02*G2_1_0_0 + 8.333333333333322e-02*G2_1_0_1 + 8.333333333333322e-02*G2_1_0_2 + 8.333333333333320e-02*G2_2_0_0 + 8.333333333333322e-02*G2_2_0_1 + 8.333333333333322e-02*G2_2_0_2 + 8.333333333333320e-02*G2_3_0_0 + 8.333333333333322e-02*G2_3_0_1 + 8.333333333333322e-02*G2_3_0_2 - 3.333333333333328e-01*G3_0_0 - 3.333333333333329e-01*G3_0_1 - 3.333333333333329e-01*G3_0_2 - 1.333333333333329e-01*G4_0_0_0_0 - 1.333333333333329e-01*G4_0_0_0_1 - 1.333333333333330e-01*G4_0_0_0_2 - 6.666666666666646e-02*G4_0_1_0_0 - 6.666666666666646e-02*G4_0_1_0_1 - 6.666666666666647e-02*G4_0_1_0_2 - 6.666666666666644e-02*G4_0_2_0_0 - 6.666666666666644e-02*G4_0_2_0_1 - 6.666666666666646e-02*G4_0_2_0_2 - 6.666666666666644e-02*G4_0_3_0_0 - 6.666666666666647e-02*G4_0_3_0_1 - 6.666666666666647e-02*G4_0_3_0_2 - 6.666666666666646e-02*G4_1_0_0_0 - 6.666666666666646e-02*G4_1_0_0_1 - 6.666666666666647e-02*G4_1_0_0_2 - 1.333333333333329e-01*G4_1_1_0_0 - 1.333333333333329e-01*G4_1_1_0_1 - 1.333333333333329e-01*G4_1_1_0_2 - 6.666666666666647e-02*G4_1_2_0_0 - 6.666666666666647e-02*G4_1_2_0_1 - 6.666666666666647e-02*G4_1_2_0_2 - 6.666666666666649e-02*G4_1_3_0_0 - 6.666666666666649e-02*G4_1_3_0_1 - 6.666666666666650e-02*G4_1_3_0_2 - 6.666666666666643e-02*G4_2_0_0_0 - 6.666666666666644e-02*G4_2_0_0_1 - 6.666666666666646e-02*G4_2_0_0_2 - 6.666666666666647e-02*G4_2_1_0_0 - 6.666666666666647e-02*G4_2_1_0_1 - 6.666666666666647e-02*G4_2_1_0_2 - 1.333333333333329e-01*G4_2_2_0_0 - 1.333333333333329e-01*G4_2_2_0_1 - 1.333333333333329e-01*G4_2_2_0_2 - 6.666666666666647e-02*G4_2_3_0_0 - 6.666666666666649e-02*G4_2_3_0_1 - 6.666666666666649e-02*G4_2_3_0_2 - 6.666666666666647e-02*G4_3_0_0_0 - 6.666666666666649e-02*G4_3_0_0_1 - 6.666666666666649e-02*G4_3_0_0_2 - 6.666666666666649e-02*G4_3_1_0_0 - 6.666666666666649e-02*G4_3_1_0_1 - 6.666666666666650e-02*G4_3_1_0_2 - 6.666666666666647e-02*G4_3_2_0_0 - 6.666666666666649e-02*G4_3_2_0_1 - 6.666666666666649e-02*G4_3_2_0_2 - 1.333333333333329e-01*G4_3_3_0_0 - 1.333333333333329e-01*G4_3_3_0_1 - 1.333333333333330e-01*G4_3_3_0_2 + 3.333333333333328e-01*G5_0_0_0 + 3.333333333333329e-01*G5_0_0_1 + 3.333333333333329e-01*G5_0_0_2 + 3.333333333333328e-01*G5_1_0_0 + 3.333333333333329e-01*G5_1_0_1 + 3.333333333333329e-01*G5_1_0_2 + 3.333333333333328e-01*G5_2_0_0 + 3.333333333333329e-01*G5_2_0_1 + 3.333333333333329e-01*G5_2_0_2 + 3.333333333333328e-01*G5_3_0_0 + 3.333333333333329e-01*G5_3_0_1 + 3.333333333333329e-01*G5_3_0_2 - 3.999999999999986e-01*G9_0_0_0_0 - 3.999999999999987e-01*G9_0_0_0_1 - 3.999999999999988e-01*G9_0_0_0_2 + 3.999999999999986e-01*G9_0_1_0_0 + 3.999999999999987e-01*G9_0_2_0_1 + 3.999999999999987e-01*G9_0_3_0_2 - 1.999999999999993e-01*G9_1_0_0_0 - 1.999999999999993e-01*G9_1_0_0_1 - 1.999999999999993e-01*G9_1_0_0_2 + 1.999999999999993e-01*G9_1_1_0_0 + 1.999999999999993e-01*G9_1_2_0_1 + 1.999999999999993e-01*G9_1_3_0_2 - 1.999999999999993e-01*G9_2_0_0_0 - 1.999999999999993e-01*G9_2_0_0_1 - 1.999999999999994e-01*G9_2_0_0_2 + 1.999999999999993e-01*G9_2_1_0_0 + 1.999999999999993e-01*G9_2_2_0_1 + 1.999999999999993e-01*G9_2_3_0_2 - 1.999999999999994e-01*G9_3_0_0_0 - 1.999999999999994e-01*G9_3_0_0_1 - 1.999999999999994e-01*G9_3_0_0_2 + 1.999999999999994e-01*G9_3_1_0_0 + 1.999999999999994e-01*G9_3_2_0_1 + 1.999999999999994e-01*G9_3_3_0_2 + 4.999999999999993e-01*G10_0_0_0 + 4.999999999999993e-01*G10_0_0_1 + 4.999999999999993e-01*G10_0_0_2 - 4.999999999999993e-01*G10_1_0_0 - 4.999999999999993e-01*G10_2_0_1 - 4.999999999999993e-01*G10_3_0_2;
    block[9] = 1.666666666666662e-02*G0_ + 3.333333333333323e-02*G1_0_0_0_0 + 1.666666666666661e-02*G1_0_1_0_0 + 1.666666666666661e-02*G1_0_2_0_0 + 1.666666666666661e-02*G1_0_3_0_0 + 1.666666666666661e-02*G1_1_0_0_0 + 3.333333333333323e-02*G1_1_1_0_0 + 1.666666666666662e-02*G1_1_2_0_0 + 1.666666666666662e-02*G1_1_3_0_0 + 1.666666666666661e-02*G1_2_0_0_0 + 1.666666666666662e-02*G1_2_1_0_0 + 3.333333333333323e-02*G1_2_2_0_0 + 1.666666666666662e-02*G1_2_3_0_0 + 1.666666666666662e-02*G1_3_0_0_0 + 1.666666666666662e-02*G1_3_1_0_0 + 1.666666666666662e-02*G1_3_2_0_0 + 3.333333333333323e-02*G1_3_3_0_0 - 8.333333333333320e-02*G2_0_0_0 - 8.333333333333320e-02*G2_1_0_0 - 8.333333333333320e-02*G2_2_0_0 - 8.333333333333320e-02*G2_3_0_0 + 3.333333333333328e-01*G3_0_0 + 1.333333333333329e-01*G4_0_0_0_0 + 6.666666666666646e-02*G4_0_1_0_0 + 6.666666666666644e-02*G4_0_2_0_0 + 6.666666666666644e-02*G4_0_3_0_0 + 6.666666666666646e-02*G4_1_0_0_0 + 1.333333333333329e-01*G4_1_1_0_0 + 6.666666666666647e-02*G4_1_2_0_0 + 6.666666666666649e-02*G4_1_3_0_0 + 6.666666666666643e-02*G4_2_0_0_0 + 6.666666666666647e-02*G4_2_1_0_0 + 1.333333333333329e-01*G4_2_2_0_0 + 6.666666666666647e-02*G4_2_3_0_0 + 6.666666666666647e-02*G4_3_0_0_0 + 6.666666666666649e-02*G4_3_1_0_0 + 6.666666666666647e-02*G4_3_2_0_0 + 1.333333333333329e-01*G4_3_3_0_0 - 3.333333333333328e-01*G5_0_0_0 - 3.333333333333328e-01*G5_1_0_0 - 3.333333333333328e-01*G5_2_0_0 - 3.333333333333328e-01*G5_3_0_0 - 1.999999999999993e-01*G9_0_0_0_0 - 1.999999999999993e-01*G9_0_0_0_1 - 1.999999999999994e-01*G9_0_0_0_2 + 1.999999999999993e-01*G9_0_1_0_0 + 1.999999999999993e-01*G9_0_2_0_1 + 1.999999999999993e-01*G9_0_3_0_2 - 3.999999999999986e-01*G9_1_0_0_0 - 3.999999999999987e-01*G9_1_0_0_1 - 3.999999999999987e-01*G9_1_0_0_2 + 3.999999999999986e-01*G9_1_1_0_0 + 3.999999999999987e-01*G9_1_2_0_1 + 3.999999999999987e-01*G9_1_3_0_2 - 1.999999999999994e-01*G9_2_0_0_0 - 1.999999999999994e-01*G9_2_0_0_1 - 1.999999999999994e-01*G9_2_0_0_2 + 1.999999999999994e-01*G9_2_1_0_0 + 1.999999999999994e-01*G9_2_2_0_1 + 1.999999999999994e-01*G9_2_3_0_2 - 1.999999999999994e-01*G9_3_0_0_0 - 1.999999999999994e-01*G9_3_0_0_1 - 1.999999999999995e-01*G9_3_0_0_2 + 1.999999999999994e-01*G9_3_1_0_0 + 1.999999999999994e-01*G9_3_2_0_1 + 1.999999999999994e-01*G9_3_3_0_2 + 4.999999999999993e-01*G10_0_0_0 + 4.999999999999993e-01*G10_0_0_1 + 4.999999999999993e-01*G10_0_0_2 - 4.999999999999993e-01*G10_1_0_0 - 4.999999999999993e-01*G10_2_0_1 - 4.999999999999993e-01*G10_3_0_2;
    block[10] = 8.333333333333311e-03*G0_ + 3.333333333333324e-02*G1_0_0_0_1 + 1.666666666666661e-02*G1_0_1_0_1 + 1.666666666666661e-02*G1_0_2_0_1 + 1.666666666666662e-02*G1_0_3_0_1 + 1.666666666666661e-02*G1_1_0_0_1 + 3.333333333333323e-02*G1_1_1_0_1 + 1.666666666666662e-02*G1_1_2_0_1 + 1.666666666666662e-02*G1_1_3_0_1 + 1.666666666666661e-02*G1_2_0_0_1 + 1.666666666666662e-02*G1_2_1_0_1 + 3.333333333333324e-02*G1_2_2_0_1 + 1.666666666666662e-02*G1_2_3_0_1 + 1.666666666666662e-02*G1_3_0_0_1 + 1.666666666666662e-02*G1_3_1_0_1 + 1.666666666666662e-02*G1_3_2_0_1 + 3.333333333333324e-02*G1_3_3_0_1 - 8.333333333333322e-02*G2_0_0_1 - 8.333333333333322e-02*G2_1_0_1 - 8.333333333333322e-02*G2_2_0_1 - 8.333333333333322e-02*G2_3_0_1 + 3.333333333333329e-01*G3_0_1 + 1.333333333333329e-01*G4_0_0_0_1 + 6.666666666666646e-02*G4_0_1_0_1 + 6.666666666666644e-02*G4_0_2_0_1 + 6.666666666666647e-02*G4_0_3_0_1 + 6.666666666666646e-02*G4_1_0_0_1 + 1.333333333333329e-01*G4_1_1_0_1 + 6.666666666666647e-02*G4_1_2_0_1 + 6.666666666666649e-02*G4_1_3_0_1 + 6.666666666666644e-02*G4_2_0_0_1 + 6.666666666666647e-02*G4_2_1_0_1 + 1.333333333333329e-01*G4_2_2_0_1 + 6.666666666666649e-02*G4_2_3_0_1 + 6.666666666666649e-02*G4_3_0_0_1 + 6.666666666666649e-02*G4_3_1_0_1 + 6.666666666666649e-02*G4_3_2_0_1 + 1.333333333333329e-01*G4_3_3_0_1 - 3.333333333333329e-01*G5_0_0_1 - 3.333333333333329e-01*G5_1_0_1 - 3.333333333333329e-01*G5_2_0_1 - 3.333333333333329e-01*G5_3_0_1 - 1.999999999999993e-01*G9_0_0_0_0 - 1.999999999999993e-01*G9_0_0_0_1 - 1.999999999999994e-01*G9_0_0_0_2 + 1.999999999999993e-01*G9_0_1_0_0 + 1.999999999999993e-01*G9_0_2_0_1 + 1.999999999999993e-01*G9_0_3_0_2 - 1.999999999999994e-01*G9_1_0_0_0 - 1.999999999999994e-01*G9_1_0_0_1 - 1.999999999999994e-01*G9_1_0_0_2 + 1.999999999999994e-01*G9_1_1_0_0 + 1.999999999999994e-01*G9_1_2_0_1 + 1.999999999999994e-01*G9_1_3_0_2 - 3.999999999999987e-01*G9_2_0_0_0 - 3.999999999999987e-01*G9_2_0_0_1 - 3.999999999999987e-01*G9_2_0_0_2 + 3.999999999999987e-01*G9_2_1_0_0 + 3.999999999999987e-01*G9_2_2_0_1 + 3.999999999999987e-01*G9_2_3_0_2 - 1.999999999999994e-01*G9_3_0_0_0 - 1.999999999999995e-01*G9_3_0_0_1 - 1.999999999999995e-01*G9_3_0_0_2 + 1.999999999999994e-01*G9_3_1_0_0 + 1.999999999999995e-01*G9_3_2_0_1 + 1.999999999999995e-01*G9_3_3_0_2 + 4.999999999999993e-01*G10_0_0_0 + 4.999999999999993e-01*G10_0_0_1 + 4.999999999999993e-01*G10_0_0_2 - 4.999999999999993e-01*G10_1_0_0 - 4.999999999999993e-01*G10_2_0_1 - 4.999999999999993e-01*G10_3_0_2;
    block[11] = 8.333333333333312e-03*G0_ + 3.333333333333324e-02*G1_0_0_0_2 + 1.666666666666661e-02*G1_0_1_0_2 + 1.666666666666661e-02*G1_0_2_0_2 + 1.666666666666662e-02*G1_0_3_0_2 + 1.666666666666661e-02*G1_1_0_0_2 + 3.333333333333323e-02*G1_1_1_0_2 + 1.666666666666662e-02*G1_1_2_0_2 + 1.666666666666662e-02*G1_1_3_0_2 + 1.666666666666661e-02*G1_2_0_0_2 + 1.666666666666662e-02*G1_2_1_0_2 + 3.333333333333324e-02*G1_2_2_0_2 + 1.666666666666662e-02*G1_2_3_0_2 + 1.666666666666662e-02*G1_3_0_0_2 + 1.666666666666662e-02*G1_3_1_0_2 + 1.666666666666662e-02*G1_3_2_0_2 + 3.333333333333324e-02*G1_3_3_0_2 - 8.333333333333322e-02*G2_0_0_2 - 8.333333333333322e-02*G2_1_0_2 - 8.333333333333322e-02*G2_2_0_2 - 8.333333333333322e-02*G2_3_0_2 + 3.333333333333329e-01*G3_0_2 + 1.333333333333329e-01*G4_0_0_0_2 + 6.666666666666646e-02*G4_0_1_0_2 + 6.666666666666644e-02*G4_0_2_0_2 + 6.666666666666647e-02*G4_0_3_0_2 + 6.666666666666646e-02*G4_1_0_0_2 + 1.333333333333329e-01*G4_1_1_0_2 + 6.666666666666647e-02*G4_1_2_0_2 + 6.666666666666649e-02*G4_1_3_0_2 + 6.666666666666644e-02*G4_2_0_0_2 + 6.666666666666647e-02*G4_2_1_0_2 + 1.333333333333329e-01*G4_2_2_0_2 + 6.666666666666649e-02*G4_2_3_0_2 + 6.666666666666649e-02*G4_3_0_0_2 + 6.666666666666649e-02*G4_3_1_0_2 + 6.666666666666649e-02*G4_3_2_0_2 + 1.333333333333329e-01*G4_3_3_0_2 - 3.333333333333329e-01*G5_0_0_2 - 3.333333333333329e-01*G5_1_0_2 - 3.333333333333329e-01*G5_2_0_2 - 3.333333333333329e-01*G5_3_0_2 - 1.999999999999994e-01*G9_0_0_0_0 - 1.999999999999994e-01*G9_0_0_0_1 - 1.999999999999994e-01*G9_0_0_0_2 + 1.999999999999994e-01*G9_0_1_0_0 + 1.999999999999994e-01*G9_0_2_0_1 + 1.999999999999994e-01*G9_0_3_0_2 - 1.999999999999994e-01*G9_1_0_0_0 - 1.999999999999994e-01*G9_1_0_0_1 - 1.999999999999995e-01*G9_1_0_0_2 + 1.999999999999994e-01*G9_1_1_0_0 + 1.999999999999994e-01*G9_1_2_0_1 + 1.999999999999994e-01*G9_1_3_0_2 - 1.999999999999994e-01*G9_2_0_0_0 - 1.999999999999995e-01*G9_2_0_0_1 - 1.999999999999995e-01*G9_2_0_0_2 + 1.999999999999994e-01*G9_2_1_0_0 + 1.999999999999995e-01*G9_2_2_0_1 + 1.999999999999995e-01*G9_2_3_0_2 - 3.999999999999988e-01*G9_3_0_0_0 - 3.999999999999988e-01*G9_3_0_0_1 - 3.999999999999989e-01*G9_3_0_0_2 + 3.999999999999988e-01*G9_3_1_0_0 + 3.999999999999988e-01*G9_3_2_0_1 + 3.999999999999988e-01*G9_3_3_0_2 + 4.999999999999993e-01*G10_0_0_0 + 4.999999999999993e-01*G10_0_0_1 + 4.999999999999993e-01*G10_0_0_2 - 4.999999999999993e-01*G10_1_0_0 - 4.999999999999993e-01*G10_2_0_1 - 4.999999999999993e-01*G10_3_0_2;
    block[12] = 1.666666666666664e-01*G11_0_0 + 1.666666666666664e-01*G11_0_1 + 1.666666666666664e-01*G11_0_2;
    block[13] = -1.666666666666664e-01*G11_0_0;
    block[14] = -1.666666666666664e-01*G11_0_1;
    block[15] = -1.666666666666664e-01*G11_0_2;
    block[16] = 8.333333333333307e-03*G0_ - 3.333333333333324e-02*G1_0_0_1_0 - 3.333333333333324e-02*G1_0_0_1_1 - 3.333333333333324e-02*G1_0_0_1_2 - 1.666666666666661e-02*G1_0_1_1_0 - 1.666666666666662e-02*G1_0_1_1_1 - 1.666666666666662e-02*G1_0_1_1_2 - 1.666666666666661e-02*G1_0_2_1_0 - 1.666666666666661e-02*G1_0_2_1_1 - 1.666666666666662e-02*G1_0_2_1_2 - 1.666666666666662e-02*G1_0_3_1_0 - 1.666666666666662e-02*G1_0_3_1_1 - 1.666666666666663e-02*G1_0_3_1_2 - 1.666666666666661e-02*G1_1_0_1_0 - 1.666666666666662e-02*G1_1_0_1_1 - 1.666666666666662e-02*G1_1_0_1_2 - 3.333333333333323e-02*G1_1_1_1_0 - 3.333333333333324e-02*G1_1_1_1_1 - 3.333333333333324e-02*G1_1_1_1_2 - 1.666666666666662e-02*G1_1_2_1_0 - 1.666666666666662e-02*G1_1_2_1_1 - 1.666666666666662e-02*G1_1_2_1_2 - 1.666666666666662e-02*G1_1_3_1_0 - 1.666666666666662e-02*G1_1_3_1_1 - 1.666666666666662e-02*G1_1_3_1_2 - 1.666666666666661e-02*G1_2_0_1_0 - 1.666666666666661e-02*G1_2_0_1_1 - 1.666666666666661e-02*G1_2_0_1_2 - 1.666666666666662e-02*G1_2_1_1_0 - 1.666666666666662e-02*G1_2_1_1_1 - 1.666666666666662e-02*G1_2_1_1_2 - 3.333333333333324e-02*G1_2_2_1_0 - 3.333333333333324e-02*G1_2_2_1_1 - 3.333333333333324e-02*G1_2_2_1_2 - 1.666666666666662e-02*G1_2_3_1_0 - 1.666666666666662e-02*G1_2_3_1_1 - 1.666666666666663e-02*G1_2_3_1_2 - 1.666666666666662e-02*G1_3_0_1_0 - 1.666666666666662e-02*G1_3_0_1_1 - 1.666666666666663e-02*G1_3_0_1_2 - 1.666666666666662e-02*G1_3_1_1_0 - 1.666666666666662e-02*G1_3_1_1_1 - 1.666666666666662e-02*G1_3_1_1_2 - 1.666666666666662e-02*G1_3_2_1_0 - 1.666666666666662e-02*G1_3_2_1_1 - 1.666666666666663e-02*G1_3_2_1_2 - 3.333333333333324e-02*G1_3_3_1_0 - 3.333333333333324e-02*G1_3_3_1_1 - 3.333333333333324e-02*G1_3_3_1_2 + 8.333333333333322e-02*G2_0_1_0 + 8.333333333333323e-02*G2_0_1_1 + 8.333333333333323e-02*G2_0_1_2 + 8.333333333333322e-02*G2_1_1_0 + 8.333333333333323e-02*G2_1_1_1 + 8.333333333333323e-02*G2_1_1_2 + 8.333333333333322e-02*G2_2_1_0 + 8.333333333333323e-02*G2_2_1_1 + 8.333333333333323e-02*G2_2_1_2 + 8.333333333333322e-02*G2_3_1_0 + 8.333333333333323e-02*G2_3_1_1 + 8.333333333333323e-02*G2_3_1_2 - 3.333333333333329e-01*G3_1_0 - 3.333333333333329e-01*G3_1_1 - 3.333333333333329e-01*G3_1_2 - 1.333333333333329e-01*G4_0_0_1_0 - 1.333333333333329e-01*G4_0_0_1_1 - 1.333333333333330e-01*G4_0_0_1_2 - 6.666666666666646e-02*G4_0_1_1_0 - 6.666666666666647e-02*G4_0_1_1_1 - 6.666666666666647e-02*G4_0_1_1_2 - 6.666666666666644e-02*G4_0_2_1_0 - 6.666666666666646e-02*G4_0_2_1_1 - 6.666666666666647e-02*G4_0_2_1_2 - 6.666666666666647e-02*G4_0_3_1_0 - 6.666666666666650e-02*G4_0_3_1_1 - 6.666666666666651e-02*G4_0_3_1_2 - 6.666666666666646e-02*G4_1_0_1_0 - 6.666666666666647e-02*G4_1_0_1_1 - 6.666666666666647e-02*G4_1_0_1_2 - 1.333333333333329e-01*G4_1_1_1_0 - 1.333333333333329e-01*G4_1_1_1_1 - 1.333333333333329e-01*G4_1_1_1_2 - 6.666666666666647e-02*G4_1_2_1_0 - 6.666666666666649e-02*G4_1_2_1_1 - 6.666666666666649e-02*G4_1_2_1_2 - 6.666666666666649e-02*G4_1_3_1_0 - 6.666666666666650e-02*G4_1_3_1_1 - 6.666666666666650e-02*G4_1_3_1_2 - 6.666666666666644e-02*G4_2_0_1_0 - 6.666666666666646e-02*G4_2_0_1_1 - 6.666666666666646e-02*G4_2_0_1_2 - 6.666666666666647e-02*G4_2_1_1_0 - 6.666666666666649e-02*G4_2_1_1_1 - 6.666666666666649e-02*G4_2_1_1_2 - 1.333333333333329e-01*G4_2_2_1_0 - 1.333333333333330e-01*G4_2_2_1_1 - 1.333333333333330e-01*G4_2_2_1_2 - 6.666666666666649e-02*G4_2_3_1_0 - 6.666666666666650e-02*G4_2_3_1_1 - 6.666666666666651e-02*G4_2_3_1_2 - 6.666666666666649e-02*G4_3_0_1_0 - 6.666666666666650e-02*G4_3_0_1_1 - 6.666666666666651e-02*G4_3_0_1_2 - 6.666666666666649e-02*G4_3_1_1_0 - 6.666666666666650e-02*G4_3_1_1_1 - 6.666666666666650e-02*G4_3_1_1_2 - 6.666666666666649e-02*G4_3_2_1_0 - 6.666666666666649e-02*G4_3_2_1_1 - 6.666666666666651e-02*G4_3_2_1_2 - 1.333333333333329e-01*G4_3_3_1_0 - 1.333333333333330e-01*G4_3_3_1_1 - 1.333333333333330e-01*G4_3_3_1_2 + 3.333333333333329e-01*G5_0_1_0 + 3.333333333333329e-01*G5_0_1_1 + 3.333333333333329e-01*G5_0_1_2 + 3.333333333333329e-01*G5_1_1_0 + 3.333333333333329e-01*G5_1_1_1 + 3.333333333333329e-01*G5_1_1_2 + 3.333333333333329e-01*G5_2_1_0 + 3.333333333333329e-01*G5_2_1_1 + 3.333333333333329e-01*G5_2_1_2 + 3.333333333333329e-01*G5_3_1_0 + 3.333333333333329e-01*G5_3_1_1 + 3.333333333333329e-01*G5_3_1_2 - 3.999999999999987e-01*G9_0_0_1_0 - 3.999999999999988e-01*G9_0_0_1_1 - 3.999999999999989e-01*G9_0_0_1_2 + 3.999999999999987e-01*G9_0_1_1_0 + 3.999999999999988e-01*G9_0_2_1_1 + 3.999999999999988e-01*G9_0_3_1_2 - 1.999999999999993e-01*G9_1_0_1_0 - 1.999999999999994e-01*G9_1_0_1_1 - 1.999999999999994e-01*G9_1_0_1_2 + 1.999999999999993e-01*G9_1_1_1_0 + 1.999999999999994e-01*G9_1_2_1_1 + 1.999999999999994e-01*G9_1_3_1_2 - 1.999999999999993e-01*G9_2_0_1_0 - 1.999999999999994e-01*G9_2_0_1_1 - 1.999999999999994e-01*G9_2_0_1_2 + 1.999999999999993e-01*G9_2_1_1_0 + 1.999999999999994e-01*G9_2_2_1_1 + 1.999999999999994e-01*G9_2_3_1_2 - 1.999999999999994e-01*G9_3_0_1_0 - 1.999999999999995e-01*G9_3_0_1_1 - 1.999999999999995e-01*G9_3_0_1_2 + 1.999999999999994e-01*G9_3_1_1_0 + 1.999999999999995e-01*G9_3_2_1_1 + 1.999999999999995e-01*G9_3_3_1_2 + 4.999999999999993e-01*G10_0_1_0 + 4.999999999999994e-01*G10_0_1_1 + 4.999999999999994e-01*G10_0_1_2 - 4.999999999999993e-01*G10_1_1_0 - 4.999999999999994e-01*G10_2_1_1 - 4.999999999999994e-01*G10_3_1_2;
    block[17] = 8.333333333333311e-03*G0_ + 3.333333333333324e-02*G1_0_0_1_0 + 1.666666666666661e-02*G1_0_1_1_0 + 1.666666666666661e-02*G1_0_2_1_0 + 1.666666666666662e-02*G1_0_3_1_0 + 1.666666666666661e-02*G1_1_0_1_0 + 3.333333333333323e-02*G1_1_1_1_0 + 1.666666666666662e-02*G1_1_2_1_0 + 1.666666666666662e-02*G1_1_3_1_0 + 1.666666666666661e-02*G1_2_0_1_0 + 1.666666666666662e-02*G1_2_1_1_0 + 3.333333333333324e-02*G1_2_2_1_0 + 1.666666666666662e-02*G1_2_3_1_0 + 1.666666666666662e-02*G1_3_0_1_0 + 1.666666666666662e-02*G1_3_1_1_0 + 1.666666666666662e-02*G1_3_2_1_0 + 3.333333333333324e-02*G1_3_3_1_0 - 8.333333333333322e-02*G2_0_1_0 - 8.333333333333322e-02*G2_1_1_0 - 8.333333333333322e-02*G2_2_1_0 - 8.333333333333322e-02*G2_3_1_0 + 3.333333333333329e-01*G3_1_0 + 1.333333333333329e-01*G4_0_0_1_0 + 6.666666666666646e-02*G4_0_1_1_0 + 6.666666666666644e-02*G4_0_2_1_0 + 6.666666666666647e-02*G4_0_3_1_0 + 6.666666666666646e-02*G4_1_0_1_0 + 1.333333333333329e-01*G4_1_1_1_0 + 6.666666666666647e-02*G4_1_2_1_0 + 6.666666666666649e-02*G4_1_3_1_0 + 6.666666666666644e-02*G4_2_0_1_0 + 6.666666666666647e-02*G4_2_1_1_0 + 1.333333333333329e-01*G4_2_2_1_0 + 6.666666666666649e-02*G4_2_3_1_0 + 6.666666666666649e-02*G4_3_0_1_0 + 6.666666666666649e-02*G4_3_1_1_0 + 6.666666666666649e-02*G4_3_2_1_0 + 1.333333333333329e-01*G4_3_3_1_0 - 3.333333333333329e-01*G5_0_1_0 - 3.333333333333329e-01*G5_1_1_0 - 3.333333333333329e-01*G5_2_1_0 - 3.333333333333329e-01*G5_3_1_0 - 1.999999999999993e-01*G9_0_0_1_0 - 1.999999999999994e-01*G9_0_0_1_1 - 1.999999999999994e-01*G9_0_0_1_2 + 1.999999999999993e-01*G9_0_1_1_0 + 1.999999999999994e-01*G9_0_2_1_1 + 1.999999999999994e-01*G9_0_3_1_2 - 3.999999999999987e-01*G9_1_0_1_0 - 3.999999999999989e-01*G9_1_0_1_1 - 3.999999999999989e-01*G9_1_0_1_2 + 3.999999999999987e-01*G9_1_1_1_0 + 3.999999999999989e-01*G9_1_2_1_1 + 3.999999999999989e-01*G9_1_3_1_2 - 1.999999999999994e-01*G9_2_0_1_0 - 1.999999999999995e-01*G9_2_0_1_1 - 1.999999999999995e-01*G9_2_0_1_2 + 1.999999999999994e-01*G9_2_1_1_0 + 1.999999999999995e-01*G9_2_2_1_1 + 1.999999999999995e-01*G9_2_3_1_2 - 1.999999999999994e-01*G9_3_0_1_0 - 1.999999999999995e-01*G9_3_0_1_1 - 1.999999999999995e-01*G9_3_0_1_2 + 1.999999999999994e-01*G9_3_1_1_0 + 1.999999999999995e-01*G9_3_2_1_1 + 1.999999999999995e-01*G9_3_3_1_2 + 4.999999999999993e-01*G10_0_1_0 + 4.999999999999994e-01*G10_0_1_1 + 4.999999999999994e-01*G10_0_1_2 - 4.999999999999993e-01*G10_1_1_0 - 4.999999999999994e-01*G10_2_1_1 - 4.999999999999994e-01*G10_3_1_2;
    block[18] = 1.666666666666662e-02*G0_ + 3.333333333333324e-02*G1_0_0_1_1 + 1.666666666666662e-02*G1_0_1_1_1 + 1.666666666666661e-02*G1_0_2_1_1 + 1.666666666666662e-02*G1_0_3_1_1 + 1.666666666666662e-02*G1_1_0_1_1 + 3.333333333333324e-02*G1_1_1_1_1 + 1.666666666666662e-02*G1_1_2_1_1 + 1.666666666666662e-02*G1_1_3_1_1 + 1.666666666666661e-02*G1_2_0_1_1 + 1.666666666666662e-02*G1_2_1_1_1 + 3.333333333333324e-02*G1_2_2_1_1 + 1.666666666666662e-02*G1_2_3_1_1 + 1.666666666666662e-02*G1_3_0_1_1 + 1.666666666666662e-02*G1_3_1_1_1 + 1.666666666666662e-02*G1_3_2_1_1 + 3.333333333333324e-02*G1_3_3_1_1 - 8.333333333333323e-02*G2_0_1_1 - 8.333333333333323e-02*G2_1_1_1 - 8.333333333333323e-02*G2_2_1_1 - 8.333333333333323e-02*G2_3_1_1 + 3.333333333333329e-01*G3_1_1 + 1.333333333333329e-01*G4_0_0_1_1 + 6.666666666666647e-02*G4_0_1_1_1 + 6.666666666666646e-02*G4_0_2_1_1 + 6.666666666666650e-02*G4_0_3_1_1 + 6.666666666666647e-02*G4_1_0_1_1 + 1.333333333333329e-01*G4_1_1_1_1 + 6.666666666666649e-02*G4_1_2_1_1 + 6.666666666666650e-02*G4_1_3_1_1 + 6.666666666666646e-02*G4_2_0_1_1 + 6.666666666666649e-02*G4_2_1_1_1 + 1.333333333333330e-01*G4_2_2_1_1 + 6.666666666666650e-02*G4_2_3_1_1 + 6.666666666666650e-02*G4_3_0_1_1 + 6.666666666666650e-02*G4_3_1_1_1 + 6.666666666666649e-02*G4_3_2_1_1 + 1.333333333333330e-01*G4_3_3_1_1 - 3.333333333333329e-01*G5_0_1_1 - 3.333333333333329e-01*G5_1_1_1 - 3.333333333333329e-01*G5_2_1_1 - 3.333333333333329e-01*G5_3_1_1 - 1.999999999999993e-01*G9_0_0_1_0 - 1.999999999999994e-01*G9_0_0_1_1 - 1.999999999999994e-01*G9_0_0_1_2 + 1.999999999999993e-01*G9_0_1_1_0 + 1.999999999999994e-01*G9_0_2_1_1 + 1.999999999999994e-01*G9_0_3_1_2 - 1.999999999999994e-01*G9_1_0_1_0 - 1.999999999999995e-01*G9_1_0_1_1 - 1.999999999999995e-01*G9_1_0_1_2 + 1.999999999999994e-01*G9_1_1_1_0 + 1.999999999999995e-01*G9_1_2_1_1 + 1.999999999999995e-01*G9_1_3_1_2 - 3.999999999999987e-01*G9_2_0_1_0 - 3.999999999999989e-01*G9_2_0_1_1 - 3.999999999999989e-01*G9_2_0_1_2 + 3.999999999999987e-01*G9_2_1_1_0 + 3.999999999999989e-01*G9_2_2_1_1 + 3.999999999999989e-01*G9_2_3_1_2 - 1.999999999999995e-01*G9_3_0_1_0 - 1.999999999999995e-01*G9_3_0_1_1 - 1.999999999999995e-01*G9_3_0_1_2 + 1.999999999999995e-01*G9_3_1_1_0 + 1.999999999999995e-01*G9_3_2_1_1 + 1.999999999999995e-01*G9_3_3_1_2 + 4.999999999999993e-01*G10_0_1_0 + 4.999999999999994e-01*G10_0_1_1 + 4.999999999999994e-01*G10_0_1_2 - 4.999999999999993e-01*G10_1_1_0 - 4.999999999999994e-01*G10_2_1_1 - 4.999999999999994e-01*G10_3_1_2;
    block[19] = 8.333333333333312e-03*G0_ + 3.333333333333324e-02*G1_0_0_1_2 + 1.666666666666662e-02*G1_0_1_1_2 + 1.666666666666661e-02*G1_0_2_1_2 + 1.666666666666662e-02*G1_0_3_1_2 + 1.666666666666662e-02*G1_1_0_1_2 + 3.333333333333324e-02*G1_1_1_1_2 + 1.666666666666662e-02*G1_1_2_1_2 + 1.666666666666662e-02*G1_1_3_1_2 + 1.666666666666661e-02*G1_2_0_1_2 + 1.666666666666662e-02*G1_2_1_1_2 + 3.333333333333324e-02*G1_2_2_1_2 + 1.666666666666662e-02*G1_2_3_1_2 + 1.666666666666662e-02*G1_3_0_1_2 + 1.666666666666662e-02*G1_3_1_1_2 + 1.666666666666662e-02*G1_3_2_1_2 + 3.333333333333324e-02*G1_3_3_1_2 - 8.333333333333323e-02*G2_0_1_2 - 8.333333333333323e-02*G2_1_1_2 - 8.333333333333323e-02*G2_2_1_2 - 8.333333333333323e-02*G2_3_1_2 + 3.333333333333329e-01*G3_1_2 + 1.333333333333329e-01*G4_0_0_1_2 + 6.666666666666647e-02*G4_0_1_1_2 + 6.666666666666646e-02*G4_0_2_1_2 + 6.666666666666650e-02*G4_0_3_1_2 + 6.666666666666647e-02*G4_1_0_1_2 + 1.333333333333329e-01*G4_1_1_1_2 + 6.666666666666649e-02*G4_1_2_1_2 + 6.666666666666650e-02*G4_1_3_1_2 + 6.666666666666646e-02*G4_2_0_1_2 + 6.666666666666649e-02*G4_2_1_1_2 + 1.333333333333330e-01*G4_2_2_1_2 + 6.666666666666650e-02*G4_2_3_1_2 + 6.666666666666650e-02*G4_3_0_1_2 + 6.666666666666650e-02*G4_3_1_1_2 + 6.666666666666649e-02*G4_3_2_1_2 + 1.333333333333330e-01*G4_3_3_1_2 - 3.333333333333329e-01*G5_0_1_2 - 3.333333333333329e-01*G5_1_1_2 - 3.333333333333329e-01*G5_2_1_2 - 3.333333333333329e-01*G5_3_1_2 - 1.999999999999994e-01*G9_0_0_1_0 - 1.999999999999995e-01*G9_0_0_1_1 - 1.999999999999995e-01*G9_0_0_1_2 + 1.999999999999994e-01*G9_0_1_1_0 + 1.999999999999995e-01*G9_0_2_1_1 + 1.999999999999995e-01*G9_0_3_1_2 - 1.999999999999994e-01*G9_1_0_1_0 - 1.999999999999995e-01*G9_1_0_1_1 - 1.999999999999995e-01*G9_1_0_1_2 + 1.999999999999994e-01*G9_1_1_1_0 + 1.999999999999995e-01*G9_1_2_1_1 + 1.999999999999995e-01*G9_1_3_1_2 - 1.999999999999995e-01*G9_2_0_1_0 - 1.999999999999995e-01*G9_2_0_1_1 - 1.999999999999995e-01*G9_2_0_1_2 + 1.999999999999995e-01*G9_2_1_1_0 + 1.999999999999995e-01*G9_2_2_1_1 + 1.999999999999995e-01*G9_2_3_1_2 - 3.999999999999988e-01*G9_3_0_1_0 - 3.999999999999989e-01*G9_3_0_1_1 - 3.999999999999989e-01*G9_3_0_1_2 + 3.999999999999988e-01*G9_3_1_1_0 + 3.999999999999989e-01*G9_3_2_1_1 + 3.999999999999989e-01*G9_3_3_1_2 + 4.999999999999993e-01*G10_0_1_0 + 4.999999999999994e-01*G10_0_1_1 + 4.999999999999994e-01*G10_0_1_2 - 4.999999999999993e-01*G10_1_1_0 - 4.999999999999994e-01*G10_2_1_1 - 4.999999999999994e-01*G10_3_1_2;
    block[20] = 1.666666666666664e-01*G11_1_0 + 1.666666666666665e-01*G11_1_1 + 1.666666666666665e-01*G11_1_2;
    block[21] = -1.666666666666664e-01*G11_1_0;
    block[22] = -1.666666666666665e-01*G11_1_1;
    block[23] = -1.666666666666665e-01*G11_1_2;
    block[24] = 8.333333333333312e-03*G0_ - 3.333333333333324e-02*G1_0_0_2_0 - 3.333333333333324e-02*G1_0_0_2_1 - 3.333333333333324e-02*G1_0_0_2_2 - 1.666666666666661e-02*G1_0_1_2_0 - 1.666666666666662e-02*G1_0_1_2_1 - 1.666666666666662e-02*G1_0_1_2_2 - 1.666666666666661e-02*G1_0_2_2_0 - 1.666666666666661e-02*G1_0_2_2_1 - 1.666666666666662e-02*G1_0_2_2_2 - 1.666666666666662e-02*G1_0_3_2_0 - 1.666666666666662e-02*G1_0_3_2_1 - 1.666666666666663e-02*G1_0_3_2_2 - 1.666666666666661e-02*G1_1_0_2_0 - 1.666666666666662e-02*G1_1_0_2_1 - 1.666666666666662e-02*G1_1_0_2_2 - 3.333333333333323e-02*G1_1_1_2_0 - 3.333333333333324e-02*G1_1_1_2_1 - 3.333333333333324e-02*G1_1_1_2_2 - 1.666666666666662e-02*G1_1_2_2_0 - 1.666666666666662e-02*G1_1_2_2_1 - 1.666666666666662e-02*G1_1_2_2_2 - 1.666666666666662e-02*G1_1_3_2_0 - 1.666666666666662e-02*G1_1_3_2_1 - 1.666666666666662e-02*G1_1_3_2_2 - 1.666666666666661e-02*G1_2_0_2_0 - 1.666666666666661e-02*G1_2_0_2_1 - 1.666666666666661e-02*G1_2_0_2_2 - 1.666666666666662e-02*G1_2_1_2_0 - 1.666666666666662e-02*G1_2_1_2_1 - 1.666666666666662e-02*G1_2_1_2_2 - 3.333333333333324e-02*G1_2_2_2_0 - 3.333333333333324e-02*G1_2_2_2_1 - 3.333333333333324e-02*G1_2_2_2_2 - 1.666666666666662e-02*G1_2_3_2_0 - 1.666666666666662e-02*G1_2_3_2_1 - 1.666666666666663e-02*G1_2_3_2_2 - 1.666666666666662e-02*G1_3_0_2_0 - 1.666666666666662e-02*G1_3_0_2_1 - 1.666666666666663e-02*G1_3_0_2_2 - 1.666666666666662e-02*G1_3_1_2_0 - 1.666666666666662e-02*G1_3_1_2_1 - 1.666666666666662e-02*G1_3_1_2_2 - 1.666666666666662e-02*G1_3_2_2_0 - 1.666666666666662e-02*G1_3_2_2_1 - 1.666666666666663e-02*G1_3_2_2_2 - 3.333333333333324e-02*G1_3_3_2_0 - 3.333333333333324e-02*G1_3_3_2_1 - 3.333333333333324e-02*G1_3_3_2_2 + 8.333333333333322e-02*G2_0_2_0 + 8.333333333333323e-02*G2_0_2_1 + 8.333333333333323e-02*G2_0_2_2 + 8.333333333333322e-02*G2_1_2_0 + 8.333333333333323e-02*G2_1_2_1 + 8.333333333333323e-02*G2_1_2_2 + 8.333333333333322e-02*G2_2_2_0 + 8.333333333333323e-02*G2_2_2_1 + 8.333333333333323e-02*G2_2_2_2 + 8.333333333333322e-02*G2_3_2_0 + 8.333333333333323e-02*G2_3_2_1 + 8.333333333333323e-02*G2_3_2_2 - 3.333333333333329e-01*G3_2_0 - 3.333333333333329e-01*G3_2_1 - 3.333333333333329e-01*G3_2_2 - 1.333333333333329e-01*G4_0_0_2_0 - 1.333333333333329e-01*G4_0_0_2_1 - 1.333333333333330e-01*G4_0_0_2_2 - 6.666666666666646e-02*G4_0_1_2_0 - 6.666666666666647e-02*G4_0_1_2_1 - 6.666666666666647e-02*G4_0_1_2_2 - 6.666666666666644e-02*G4_0_2_2_0 - 6.666666666666646e-02*G4_0_2_2_1 - 6.666666666666647e-02*G4_0_2_2_2 - 6.666666666666647e-02*G4_0_3_2_0 - 6.666666666666650e-02*G4_0_3_2_1 - 6.666666666666651e-02*G4_0_3_2_2 - 6.666666666666646e-02*G4_1_0_2_0 - 6.666666666666647e-02*G4_1_0_2_1 - 6.666666666666647e-02*G4_1_0_2_2 - 1.333333333333329e-01*G4_1_1_2_0 - 1.333333333333329e-01*G4_1_1_2_1 - 1.333333333333329e-01*G4_1_1_2_2 - 6.666666666666647e-02*G4_1_2_2_0 - 6.666666666666649e-02*G4_1_2_2_1 - 6.666666666666649e-02*G4_1_2_2_2 - 6.666666666666649e-02*G4_1_3_2_0 - 6.666666666666650e-02*G4_1_3_2_1 - 6.666666666666650e-02*G4_1_3_2_2 - 6.666666666666644e-02*G4_2_0_2_0 - 6.666666666666646e-02*G4_2_0_2_1 - 6.666666666666646e-02*G4_2_0_2_2 - 6.666666666666647e-02*G4_2_1_2_0 - 6.666666666666649e-02*G4_2_1_2_1 - 6.666666666666649e-02*G4_2_1_2_2 - 1.333333333333329e-01*G4_2_2_2_0 - 1.333333333333330e-01*G4_2_2_2_1 - 1.333333333333330e-01*G4_2_2_2_2 - 6.666666666666649e-02*G4_2_3_2_0 - 6.666666666666650e-02*G4_2_3_2_1 - 6.666666666666651e-02*G4_2_3_2_2 - 6.666666666666649e-02*G4_3_0_2_0 - 6.666666666666650e-02*G4_3_0_2_1 - 6.666666666666651e-02*G4_3_0_2_2 - 6.666666666666649e-02*G4_3_1_2_0 - 6.666666666666650e-02*G4_3_1_2_1 - 6.666666666666650e-02*G4_3_1_2_2 - 6.666666666666649e-02*G4_3_2_2_0 - 6.666666666666649e-02*G4_3_2_2_1 - 6.666666666666651e-02*G4_3_2_2_2 - 1.333333333333329e-01*G4_3_3_2_0 - 1.333333333333330e-01*G4_3_3_2_1 - 1.333333333333330e-01*G4_3_3_2_2 + 3.333333333333329e-01*G5_0_2_0 + 3.333333333333329e-01*G5_0_2_1 + 3.333333333333329e-01*G5_0_2_2 + 3.333333333333329e-01*G5_1_2_0 + 3.333333333333329e-01*G5_1_2_1 + 3.333333333333329e-01*G5_1_2_2 + 3.333333333333329e-01*G5_2_2_0 + 3.333333333333329e-01*G5_2_2_1 + 3.333333333333329e-01*G5_2_2_2 + 3.333333333333329e-01*G5_3_2_0 + 3.333333333333329e-01*G5_3_2_1 + 3.333333333333329e-01*G5_3_2_2 - 3.999999999999987e-01*G9_0_0_2_0 - 3.999999999999988e-01*G9_0_0_2_1 - 3.999999999999989e-01*G9_0_0_2_2 + 3.999999999999987e-01*G9_0_1_2_0 + 3.999999999999988e-01*G9_0_2_2_1 + 3.999999999999988e-01*G9_0_3_2_2 - 1.999999999999993e-01*G9_1_0_2_0 - 1.999999999999994e-01*G9_1_0_2_1 - 1.999999999999994e-01*G9_1_0_2_2 + 1.999999999999993e-01*G9_1_1_2_0 + 1.999999999999994e-01*G9_1_2_2_1 + 1.999999999999994e-01*G9_1_3_2_2 - 1.999999999999993e-01*G9_2_0_2_0 - 1.999999999999994e-01*G9_2_0_2_1 - 1.999999999999994e-01*G9_2_0_2_2 + 1.999999999999993e-01*G9_2_1_2_0 + 1.999999999999994e-01*G9_2_2_2_1 + 1.999999999999994e-01*G9_2_3_2_2 - 1.999999999999994e-01*G9_3_0_2_0 - 1.999999999999995e-01*G9_3_0_2_1 - 1.999999999999995e-01*G9_3_0_2_2 + 1.999999999999994e-01*G9_3_1_2_0 + 1.999999999999995e-01*G9_3_2_2_1 + 1.999999999999995e-01*G9_3_3_2_2 + 4.999999999999993e-01*G10_0_2_0 + 4.999999999999994e-01*G10_0_2_1 + 4.999999999999994e-01*G10_0_2_2 - 4.999999999999993e-01*G10_1_2_0 - 4.999999999999994e-01*G10_2_2_1 - 4.999999999999994e-01*G10_3_2_2;
    block[25] = 8.333333333333312e-03*G0_ + 3.333333333333324e-02*G1_0_0_2_0 + 1.666666666666661e-02*G1_0_1_2_0 + 1.666666666666661e-02*G1_0_2_2_0 + 1.666666666666662e-02*G1_0_3_2_0 + 1.666666666666661e-02*G1_1_0_2_0 + 3.333333333333323e-02*G1_1_1_2_0 + 1.666666666666662e-02*G1_1_2_2_0 + 1.666666666666662e-02*G1_1_3_2_0 + 1.666666666666661e-02*G1_2_0_2_0 + 1.666666666666662e-02*G1_2_1_2_0 + 3.333333333333324e-02*G1_2_2_2_0 + 1.666666666666662e-02*G1_2_3_2_0 + 1.666666666666662e-02*G1_3_0_2_0 + 1.666666666666662e-02*G1_3_1_2_0 + 1.666666666666662e-02*G1_3_2_2_0 + 3.333333333333324e-02*G1_3_3_2_0 - 8.333333333333322e-02*G2_0_2_0 - 8.333333333333322e-02*G2_1_2_0 - 8.333333333333322e-02*G2_2_2_0 - 8.333333333333322e-02*G2_3_2_0 + 3.333333333333329e-01*G3_2_0 + 1.333333333333329e-01*G4_0_0_2_0 + 6.666666666666646e-02*G4_0_1_2_0 + 6.666666666666644e-02*G4_0_2_2_0 + 6.666666666666647e-02*G4_0_3_2_0 + 6.666666666666646e-02*G4_1_0_2_0 + 1.333333333333329e-01*G4_1_1_2_0 + 6.666666666666647e-02*G4_1_2_2_0 + 6.666666666666649e-02*G4_1_3_2_0 + 6.666666666666644e-02*G4_2_0_2_0 + 6.666666666666647e-02*G4_2_1_2_0 + 1.333333333333329e-01*G4_2_2_2_0 + 6.666666666666649e-02*G4_2_3_2_0 + 6.666666666666649e-02*G4_3_0_2_0 + 6.666666666666649e-02*G4_3_1_2_0 + 6.666666666666649e-02*G4_3_2_2_0 + 1.333333333333329e-01*G4_3_3_2_0 - 3.333333333333329e-01*G5_0_2_0 - 3.333333333333329e-01*G5_1_2_0 - 3.333333333333329e-01*G5_2_2_0 - 3.333333333333329e-01*G5_3_2_0 - 1.999999999999993e-01*G9_0_0_2_0 - 1.999999999999994e-01*G9_0_0_2_1 - 1.999999999999994e-01*G9_0_0_2_2 + 1.999999999999993e-01*G9_0_1_2_0 + 1.999999999999994e-01*G9_0_2_2_1 + 1.999999999999994e-01*G9_0_3_2_2 - 3.999999999999987e-01*G9_1_0_2_0 - 3.999999999999989e-01*G9_1_0_2_1 - 3.999999999999989e-01*G9_1_0_2_2 + 3.999999999999987e-01*G9_1_1_2_0 + 3.999999999999989e-01*G9_1_2_2_1 + 3.999999999999989e-01*G9_1_3_2_2 - 1.999999999999994e-01*G9_2_0_2_0 - 1.999999999999995e-01*G9_2_0_2_1 - 1.999999999999995e-01*G9_2_0_2_2 + 1.999999999999994e-01*G9_2_1_2_0 + 1.999999999999995e-01*G9_2_2_2_1 + 1.999999999999995e-01*G9_2_3_2_2 - 1.999999999999994e-01*G9_3_0_2_0 - 1.999999999999995e-01*G9_3_0_2_1 - 1.999999999999995e-01*G9_3_0_2_2 + 1.999999999999994e-01*G9_3_1_2_0 + 1.999999999999995e-01*G9_3_2_2_1 + 1.999999999999995e-01*G9_3_3_2_2 + 4.999999999999993e-01*G10_0_2_0 + 4.999999999999994e-01*G10_0_2_1 + 4.999999999999994e-01*G10_0_2_2 - 4.999999999999993e-01*G10_1_2_0 - 4.999999999999994e-01*G10_2_2_1 - 4.999999999999994e-01*G10_3_2_2;
    block[26] = 8.333333333333311e-03*G0_ + 3.333333333333324e-02*G1_0_0_2_1 + 1.666666666666662e-02*G1_0_1_2_1 + 1.666666666666661e-02*G1_0_2_2_1 + 1.666666666666662e-02*G1_0_3_2_1 + 1.666666666666662e-02*G1_1_0_2_1 + 3.333333333333324e-02*G1_1_1_2_1 + 1.666666666666662e-02*G1_1_2_2_1 + 1.666666666666662e-02*G1_1_3_2_1 + 1.666666666666661e-02*G1_2_0_2_1 + 1.666666666666662e-02*G1_2_1_2_1 + 3.333333333333324e-02*G1_2_2_2_1 + 1.666666666666662e-02*G1_2_3_2_1 + 1.666666666666662e-02*G1_3_0_2_1 + 1.666666666666662e-02*G1_3_1_2_1 + 1.666666666666662e-02*G1_3_2_2_1 + 3.333333333333324e-02*G1_3_3_2_1 - 8.333333333333323e-02*G2_0_2_1 - 8.333333333333323e-02*G2_1_2_1 - 8.333333333333323e-02*G2_2_2_1 - 8.333333333333323e-02*G2_3_2_1 + 3.333333333333329e-01*G3_2_1 + 1.333333333333329e-01*G4_0_0_2_1 + 6.666666666666647e-02*G4_0_1_2_1 + 6.666666666666646e-02*G4_0_2_2_1 + 6.666666666666650e-02*G4_0_3_2_1 + 6.666666666666647e-02*G4_1_0_2_1 + 1.333333333333329e-01*G4_1_1_2_1 + 6.666666666666649e-02*G4_1_2_2_1 + 6.666666666666650e-02*G4_1_3_2_1 + 6.666666666666646e-02*G4_2_0_2_1 + 6.666666666666649e-02*G4_2_1_2_1 + 1.333333333333330e-01*G4_2_2_2_1 + 6.666666666666650e-02*G4_2_3_2_1 + 6.666666666666650e-02*G4_3_0_2_1 + 6.666666666666650e-02*G4_3_1_2_1 + 6.666666666666649e-02*G4_3_2_2_1 + 1.333333333333330e-01*G4_3_3_2_1 - 3.333333333333329e-01*G5_0_2_1 - 3.333333333333329e-01*G5_1_2_1 - 3.333333333333329e-01*G5_2_2_1 - 3.333333333333329e-01*G5_3_2_1 - 1.999999999999993e-01*G9_0_0_2_0 - 1.999999999999994e-01*G9_0_0_2_1 - 1.999999999999994e-01*G9_0_0_2_2 + 1.999999999999993e-01*G9_0_1_2_0 + 1.999999999999994e-01*G9_0_2_2_1 + 1.999999999999994e-01*G9_0_3_2_2 - 1.999999999999994e-01*G9_1_0_2_0 - 1.999999999999995e-01*G9_1_0_2_1 - 1.999999999999995e-01*G9_1_0_2_2 + 1.999999999999994e-01*G9_1_1_2_0 + 1.999999999999995e-01*G9_1_2_2_1 + 1.999999999999995e-01*G9_1_3_2_2 - 3.999999999999987e-01*G9_2_0_2_0 - 3.999999999999989e-01*G9_2_0_2_1 - 3.999999999999989e-01*G9_2_0_2_2 + 3.999999999999987e-01*G9_2_1_2_0 + 3.999999999999989e-01*G9_2_2_2_1 + 3.999999999999989e-01*G9_2_3_2_2 - 1.999999999999995e-01*G9_3_0_2_0 - 1.999999999999995e-01*G9_3_0_2_1 - 1.999999999999995e-01*G9_3_0_2_2 + 1.999999999999995e-01*G9_3_1_2_0 + 1.999999999999995e-01*G9_3_2_2_1 + 1.999999999999995e-01*G9_3_3_2_2 + 4.999999999999993e-01*G10_0_2_0 + 4.999999999999994e-01*G10_0_2_1 + 4.999999999999994e-01*G10_0_2_2 - 4.999999999999993e-01*G10_1_2_0 - 4.999999999999994e-01*G10_2_2_1 - 4.999999999999994e-01*G10_3_2_2;
    block[27] = 1.666666666666662e-02*G0_ + 3.333333333333324e-02*G1_0_0_2_2 + 1.666666666666662e-02*G1_0_1_2_2 + 1.666666666666661e-02*G1_0_2_2_2 + 1.666666666666662e-02*G1_0_3_2_2 + 1.666666666666662e-02*G1_1_0_2_2 + 3.333333333333324e-02*G1_1_1_2_2 + 1.666666666666662e-02*G1_1_2_2_2 + 1.666666666666662e-02*G1_1_3_2_2 + 1.666666666666661e-02*G1_2_0_2_2 + 1.666666666666662e-02*G1_2_1_2_2 + 3.333333333333324e-02*G1_2_2_2_2 + 1.666666666666662e-02*G1_2_3_2_2 + 1.666666666666662e-02*G1_3_0_2_2 + 1.666666666666662e-02*G1_3_1_2_2 + 1.666666666666662e-02*G1_3_2_2_2 + 3.333333333333324e-02*G1_3_3_2_2 - 8.333333333333323e-02*G2_0_2_2 - 8.333333333333323e-02*G2_1_2_2 - 8.333333333333323e-02*G2_2_2_2 - 8.333333333333323e-02*G2_3_2_2 + 3.333333333333329e-01*G3_2_2 + 1.333333333333329e-01*G4_0_0_2_2 + 6.666666666666647e-02*G4_0_1_2_2 + 6.666666666666646e-02*G4_0_2_2_2 + 6.666666666666650e-02*G4_0_3_2_2 + 6.666666666666647e-02*G4_1_0_2_2 + 1.333333333333329e-01*G4_1_1_2_2 + 6.666666666666649e-02*G4_1_2_2_2 + 6.666666666666650e-02*G4_1_3_2_2 + 6.666666666666646e-02*G4_2_0_2_2 + 6.666666666666649e-02*G4_2_1_2_2 + 1.333333333333330e-01*G4_2_2_2_2 + 6.666666666666650e-02*G4_2_3_2_2 + 6.666666666666650e-02*G4_3_0_2_2 + 6.666666666666650e-02*G4_3_1_2_2 + 6.666666666666649e-02*G4_3_2_2_2 + 1.333333333333330e-01*G4_3_3_2_2 - 3.333333333333329e-01*G5_0_2_2 - 3.333333333333329e-01*G5_1_2_2 - 3.333333333333329e-01*G5_2_2_2 - 3.333333333333329e-01*G5_3_2_2 - 1.999999999999994e-01*G9_0_0_2_0 - 1.999999999999995e-01*G9_0_0_2_1 - 1.999999999999995e-01*G9_0_0_2_2 + 1.999999999999994e-01*G9_0_1_2_0 + 1.999999999999995e-01*G9_0_2_2_1 + 1.999999999999995e-01*G9_0_3_2_2 - 1.999999999999994e-01*G9_1_0_2_0 - 1.999999999999995e-01*G9_1_0_2_1 - 1.999999999999995e-01*G9_1_0_2_2 + 1.999999999999994e-01*G9_1_1_2_0 + 1.999999999999995e-01*G9_1_2_2_1 + 1.999999999999995e-01*G9_1_3_2_2 - 1.999999999999995e-01*G9_2_0_2_0 - 1.999999999999995e-01*G9_2_0_2_1 - 1.999999999999995e-01*G9_2_0_2_2 + 1.999999999999995e-01*G9_2_1_2_0 + 1.999999999999995e-01*G9_2_2_2_1 + 1.999999999999995e-01*G9_2_3_2_2 - 3.999999999999988e-01*G9_3_0_2_0 - 3.999999999999989e-01*G9_3_0_2_1 - 3.999999999999989e-01*G9_3_0_2_2 + 3.999999999999988e-01*G9_3_1_2_0 + 3.999999999999989e-01*G9_3_2_2_1 + 3.999999999999989e-01*G9_3_3_2_2 + 4.999999999999993e-01*G10_0_2_0 + 4.999999999999994e-01*G10_0_2_1 + 4.999999999999994e-01*G10_0_2_2 - 4.999999999999993e-01*G10_1_2_0 - 4.999999999999994e-01*G10_2_2_1 - 4.999999999999994e-01*G10_3_2_2;
    block[28] = 1.666666666666664e-01*G11_2_0 + 1.666666666666665e-01*G11_2_1 + 1.666666666666665e-01*G11_2_2;
    block[29] = -1.666666666666664e-01*G11_2_0;
    block[30] = -1.666666666666665e-01*G11_2_1;
    block[31] = -1.666666666666665e-01*G11_2_2;
    block[32] = 1.666666666666664e-01*G13_0_0 + 1.666666666666664e-01*G13_0_1 + 1.666666666666664e-01*G13_0_2 + 1.666666666666664e-01*G13_1_0 + 1.666666666666665e-01*G13_1_1 + 1.666666666666665e-01*G13_1_2 + 1.666666666666664e-01*G13_2_0 + 1.666666666666665e-01*G13_2_1 + 1.666666666666665e-01*G13_2_2;
    block[33] = -1.666666666666664e-01*G13_0_0 - 1.666666666666664e-01*G13_1_0 - 1.666666666666664e-01*G13_2_0;
    block[34] = -1.666666666666664e-01*G13_0_1 - 1.666666666666665e-01*G13_1_1 - 1.666666666666665e-01*G13_2_1;
    block[35] = -1.666666666666664e-01*G13_0_2 - 1.666666666666665e-01*G13_1_2 - 1.666666666666665e-01*G13_2_2;
    block[36] = 1.666666666666662e-02*G12_;
    block[37] = 8.333333333333309e-03*G12_;
    block[38] = 8.333333333333307e-03*G12_;
    block[39] = 8.333333333333312e-03*G12_;
    block[40] = -1.666666666666664e-01*G13_0_0 - 1.666666666666664e-01*G13_0_1 - 1.666666666666664e-01*G13_0_2;
    block[41] = 1.666666666666664e-01*G13_0_0;
    block[42] = 1.666666666666664e-01*G13_0_1;
    block[43] = 1.666666666666664e-01*G13_0_2;
    block[44] = 8.333333333333309e-03*G12_;
    block[45] = 1.666666666666662e-02*G12_;
    block[46] = 8.333333333333311e-03*G12_;
    block[47] = 8.333333333333312e-03*G12_;
    block[48] = -1.666666666666664e-01*G13_1_0 - 1.666666666666665e-01*G13_1_1 - 1.666666666666665e-01*G13_1_2;
    block[49] = 1.666666666666664e-01*G13_1_0;
    block[50] = 1.666666666666665e-01*G13_1_1;
    block[51] = 1.666666666666665e-01*G13_1_2;
    block[52] = 8.333333333333307e-03*G12_;
    block[53] = 8.333333333333311e-03*G12_;
    block[54] = 1.666666666666662e-02*G12_;
    block[55] = 8.333333333333312e-03*G12_;
    block[56] = -1.666666666666664e-01*G13_2_0 - 1.666666666666665e-01*G13_2_1 - 1.666666666666665e-01*G13_2_2;
    block[57] = 1.666666666666664e-01*G13_2_0;
    block[58] = 1.666666666666665e-01*G13_2_1;
    block[59] = 1.666666666666665e-01*G13_2_2;
    block[60] = 8.333333333333312e-03*G12_;
    block[61] = 8.333333333333312e-03*G12_;
    block[62] = 8.333333333333311e-03*G12_;
    block[63] = 1.666666666666662e-02*G12_;
  }

  // No contribution from the boundary
  void eval(real block[], const AffineMap& map, unsigned int facet) const {}   

private:

  const real& c0;  const real& c1;  const real& c2;  const real& c3;

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 2;
  
      subelements = new FiniteElement* [2];
      subelements[0] = new SubElement_0();
      subelements[1] = new SubElement_1();
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 8;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 2;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      nodes[3] = cell.vertexID(3);
      int offset = mesh.numVertices();
      nodes[4] = offset + cell.vertexID(0);
      nodes[5] = offset + cell.vertexID(1);
      nodes[6] = offset + cell.vertexID(2);
      nodes[7] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
      int offset = mesh.numVertices();
      vertex_nodes[1] = offset + vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *subelements[i];
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *subelements[i];
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("mixed");
      return s;
    }
    
  private:
    
    class SubElement_0 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_0()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
      
    class SubElement_1 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_1() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_1()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
    
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 2;
  
      subelements = new FiniteElement* [2];
      subelements[0] = new SubElement_0();
      subelements[1] = new SubElement_1();
    }
  
    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 8;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 2;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      nodes[3] = cell.vertexID(3);
      int offset = mesh.numVertices();
      nodes[4] = offset + cell.vertexID(0);
      nodes[5] = offset + cell.vertexID(1);
      nodes[6] = offset + cell.vertexID(2);
      nodes[7] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
      int offset = mesh.numVertices();
      vertex_nodes[1] = offset + vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *subelements[i];
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *subelements[i];
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("mixed");
      return s;
    }
    
  private:
    
    class SubElement_0 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_0()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
      
    class SubElement_1 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_1() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_1()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
      {
        nodes[0] = cell.vertexID(0);
        nodes[1] = cell.vertexID(1);
        nodes[2] = cell.vertexID(2);
        nodes[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        vertex_nodes[0] = vertex;
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
    
      FiniteElementSpec spec() const
      {
        FiniteElementSpec s("Lagrange", "tetrahedron", 1);
        return s;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
    
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class FunctionElement_1 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_1() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~FunctionElement_1()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 4;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      nodes[3] = cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("Lagrange", "tetrahedron", 1);
      return s;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class FunctionElement_2 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_2() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~FunctionElement_2()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 4;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      nodes[3] = cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("Lagrange", "tetrahedron", 1);
      return s;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  LinearForm(Function& w0, Function& w1, Function& w2, const real& c0, const real& c1, const real& c2, const real& c3) : dolfin::LinearForm(3), c0(c0), c1(c1), c2(c2), c3(c3)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Add functions
    add(w0, new FunctionElement_0());
    add(w1, new FunctionElement_1());
    add(w2, new FunctionElement_2());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute coefficients
    const real c0_0 = c[0][0];
    const real c0_1 = c[0][1];
    const real c0_2 = c[0][2];
    const real c0_3 = c[0][3];
    const real c0_4 = c[0][4];
    const real c0_5 = c[0][5];
    const real c0_6 = c[0][6];
    const real c0_7 = c[0][7];
    const real c1_0 = c[1][0];
    const real c1_1 = c[1][1];
    const real c1_2 = c[1][2];
    const real c1_3 = c[1][3];
    const real c2_0 = c[2][0];
    const real c2_1 = c[2][1];
    const real c2_2 = c[2][2];
    const real c2_3 = c[2][3];

    // Compute geometry tensors
    const real G0_0_0_0_0_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g02*map.g02;
    const real G0_0_0_0_0_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g02*map.g12;
    const real G0_0_0_0_0_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g02*map.g22;
    const real G0_0_0_0_1_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g12*map.g02;
    const real G0_0_0_0_1_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g12*map.g12;
    const real G0_0_0_0_1_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g12*map.g22;
    const real G0_0_0_0_2_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g22*map.g02;
    const real G0_0_0_0_2_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g22*map.g12;
    const real G0_0_0_0_2_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g22*map.g22;
    const real G0_0_0_1_0_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g02*map.g02;
    const real G0_0_0_1_1_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g12*map.g02;
    const real G0_0_0_1_2_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g22*map.g02;
    const real G0_0_0_2_0_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g02*map.g12;
    const real G0_0_0_2_1_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g12*map.g12;
    const real G0_0_0_2_2_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g22*map.g12;
    const real G0_0_0_3_0_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g02*map.g22;
    const real G0_0_0_3_1_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g12*map.g22;
    const real G0_0_0_3_2_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g22*map.g22;
    const real G0_0_1_0_0_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g02*map.g02;
    const real G0_0_1_0_0_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g02*map.g12;
    const real G0_0_1_0_0_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g02*map.g22;
    const real G0_0_1_0_1_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g12*map.g02;
    const real G0_0_1_0_1_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g12*map.g12;
    const real G0_0_1_0_1_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g12*map.g22;
    const real G0_0_1_0_2_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g22*map.g02;
    const real G0_0_1_0_2_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g22*map.g12;
    const real G0_0_1_0_2_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g22*map.g22;
    const real G0_0_1_1_0_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g02*map.g02;
    const real G0_0_1_1_1_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g12*map.g02;
    const real G0_0_1_1_2_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g22*map.g02;
    const real G0_0_1_2_0_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g02*map.g12;
    const real G0_0_1_2_1_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g12*map.g12;
    const real G0_0_1_2_2_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g22*map.g12;
    const real G0_0_1_3_0_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g02*map.g22;
    const real G0_0_1_3_1_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g12*map.g22;
    const real G0_0_1_3_2_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g22*map.g22;
    const real G0_0_2_0_0_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g02*map.g02;
    const real G0_0_2_0_0_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g02*map.g12;
    const real G0_0_2_0_0_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g02*map.g22;
    const real G0_0_2_0_1_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g12*map.g02;
    const real G0_0_2_0_1_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g12*map.g12;
    const real G0_0_2_0_1_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g12*map.g22;
    const real G0_0_2_0_2_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g22*map.g02;
    const real G0_0_2_0_2_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g22*map.g12;
    const real G0_0_2_0_2_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g22*map.g22;
    const real G0_0_2_1_0_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g02*map.g02;
    const real G0_0_2_1_1_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g12*map.g02;
    const real G0_0_2_1_2_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g22*map.g02;
    const real G0_0_2_2_0_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g02*map.g12;
    const real G0_0_2_2_1_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g12*map.g12;
    const real G0_0_2_2_2_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g22*map.g12;
    const real G0_0_2_3_0_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g02*map.g22;
    const real G0_0_2_3_1_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g12*map.g22;
    const real G0_0_2_3_2_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g22*map.g22;
    const real G0_0_3_0_0_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g02*map.g02;
    const real G0_0_3_0_0_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g02*map.g12;
    const real G0_0_3_0_0_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g02*map.g22;
    const real G0_0_3_0_1_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g12*map.g02;
    const real G0_0_3_0_1_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g12*map.g12;
    const real G0_0_3_0_1_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g12*map.g22;
    const real G0_0_3_0_2_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g22*map.g02;
    const real G0_0_3_0_2_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g22*map.g12;
    const real G0_0_3_0_2_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g22*map.g22;
    const real G0_0_3_1_0_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g02*map.g02;
    const real G0_0_3_1_1_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g12*map.g02;
    const real G0_0_3_1_2_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g22*map.g02;
    const real G0_0_3_2_0_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g02*map.g12;
    const real G0_0_3_2_1_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g12*map.g12;
    const real G0_0_3_2_2_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g22*map.g12;
    const real G0_0_3_3_0_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g02*map.g22;
    const real G0_0_3_3_1_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g12*map.g22;
    const real G0_0_3_3_2_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g22*map.g22;
    const real G0_1_0_0_0_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g02*map.g02;
    const real G0_1_0_0_0_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g02*map.g12;
    const real G0_1_0_0_0_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g02*map.g22;
    const real G0_1_0_0_1_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g12*map.g02;
    const real G0_1_0_0_1_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g12*map.g12;
    const real G0_1_0_0_1_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g12*map.g22;
    const real G0_1_0_0_2_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g22*map.g02;
    const real G0_1_0_0_2_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g22*map.g12;
    const real G0_1_0_0_2_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g22*map.g22;
    const real G0_1_0_1_0_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g02*map.g02;
    const real G0_1_0_1_1_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g12*map.g02;
    const real G0_1_0_1_2_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g22*map.g02;
    const real G0_1_0_2_0_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g02*map.g12;
    const real G0_1_0_2_1_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g12*map.g12;
    const real G0_1_0_2_2_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g22*map.g12;
    const real G0_1_0_3_0_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g02*map.g22;
    const real G0_1_0_3_1_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g12*map.g22;
    const real G0_1_0_3_2_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g22*map.g22;
    const real G0_1_1_0_0_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g02*map.g02;
    const real G0_1_1_0_0_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g02*map.g12;
    const real G0_1_1_0_0_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g02*map.g22;
    const real G0_1_1_0_1_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g12*map.g02;
    const real G0_1_1_0_1_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g12*map.g12;
    const real G0_1_1_0_1_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g12*map.g22;
    const real G0_1_1_0_2_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g22*map.g02;
    const real G0_1_1_0_2_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g22*map.g12;
    const real G0_1_1_0_2_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g22*map.g22;
    const real G0_1_1_1_0_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g02*map.g02;
    const real G0_1_1_1_1_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g12*map.g02;
    const real G0_1_1_1_2_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g22*map.g02;
    const real G0_1_1_2_0_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g02*map.g12;
    const real G0_1_1_2_1_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g12*map.g12;
    const real G0_1_1_2_2_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g22*map.g12;
    const real G0_1_1_3_0_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g02*map.g22;
    const real G0_1_1_3_1_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g12*map.g22;
    const real G0_1_1_3_2_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g22*map.g22;
    const real G0_1_2_0_0_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g02*map.g02;
    const real G0_1_2_0_0_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g02*map.g12;
    const real G0_1_2_0_0_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g02*map.g22;
    const real G0_1_2_0_1_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g12*map.g02;
    const real G0_1_2_0_1_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g12*map.g12;
    const real G0_1_2_0_1_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g12*map.g22;
    const real G0_1_2_0_2_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g22*map.g02;
    const real G0_1_2_0_2_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g22*map.g12;
    const real G0_1_2_0_2_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g22*map.g22;
    const real G0_1_2_1_0_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g02*map.g02;
    const real G0_1_2_1_1_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g12*map.g02;
    const real G0_1_2_1_2_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g22*map.g02;
    const real G0_1_2_2_0_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g02*map.g12;
    const real G0_1_2_2_1_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g12*map.g12;
    const real G0_1_2_2_2_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g22*map.g12;
    const real G0_1_2_3_0_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g02*map.g22;
    const real G0_1_2_3_1_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g12*map.g22;
    const real G0_1_2_3_2_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g22*map.g22;
    const real G0_1_3_0_0_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g02*map.g02;
    const real G0_1_3_0_0_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g02*map.g12;
    const real G0_1_3_0_0_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g02*map.g22;
    const real G0_1_3_0_1_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g12*map.g02;
    const real G0_1_3_0_1_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g12*map.g12;
    const real G0_1_3_0_1_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g12*map.g22;
    const real G0_1_3_0_2_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g22*map.g02;
    const real G0_1_3_0_2_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g22*map.g12;
    const real G0_1_3_0_2_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g22*map.g22;
    const real G0_1_3_1_0_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g02*map.g02;
    const real G0_1_3_1_1_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g12*map.g02;
    const real G0_1_3_1_2_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g22*map.g02;
    const real G0_1_3_2_0_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g02*map.g12;
    const real G0_1_3_2_1_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g12*map.g12;
    const real G0_1_3_2_2_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g22*map.g12;
    const real G0_1_3_3_0_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g02*map.g22;
    const real G0_1_3_3_1_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g12*map.g22;
    const real G0_1_3_3_2_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g22*map.g22;
    const real G0_2_0_0_0_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g02*map.g02;
    const real G0_2_0_0_0_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g02*map.g12;
    const real G0_2_0_0_0_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g02*map.g22;
    const real G0_2_0_0_1_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g12*map.g02;
    const real G0_2_0_0_1_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g12*map.g12;
    const real G0_2_0_0_1_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g12*map.g22;
    const real G0_2_0_0_2_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g22*map.g02;
    const real G0_2_0_0_2_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g22*map.g12;
    const real G0_2_0_0_2_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g22*map.g22;
    const real G0_2_0_1_0_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g02*map.g02;
    const real G0_2_0_1_1_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g12*map.g02;
    const real G0_2_0_1_2_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g22*map.g02;
    const real G0_2_0_2_0_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g02*map.g12;
    const real G0_2_0_2_1_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g12*map.g12;
    const real G0_2_0_2_2_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g22*map.g12;
    const real G0_2_0_3_0_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g02*map.g22;
    const real G0_2_0_3_1_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g12*map.g22;
    const real G0_2_0_3_2_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g22*map.g22;
    const real G0_2_1_0_0_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g02*map.g02;
    const real G0_2_1_0_0_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g02*map.g12;
    const real G0_2_1_0_0_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g02*map.g22;
    const real G0_2_1_0_1_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g12*map.g02;
    const real G0_2_1_0_1_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g12*map.g12;
    const real G0_2_1_0_1_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g12*map.g22;
    const real G0_2_1_0_2_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g22*map.g02;
    const real G0_2_1_0_2_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g22*map.g12;
    const real G0_2_1_0_2_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g22*map.g22;
    const real G0_2_1_1_0_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g02*map.g02;
    const real G0_2_1_1_1_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g12*map.g02;
    const real G0_2_1_1_2_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g22*map.g02;
    const real G0_2_1_2_0_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g02*map.g12;
    const real G0_2_1_2_1_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g12*map.g12;
    const real G0_2_1_2_2_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g22*map.g12;
    const real G0_2_1_3_0_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g02*map.g22;
    const real G0_2_1_3_1_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g12*map.g22;
    const real G0_2_1_3_2_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g22*map.g22;
    const real G0_2_2_0_0_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g02*map.g02;
    const real G0_2_2_0_0_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g02*map.g12;
    const real G0_2_2_0_0_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g02*map.g22;
    const real G0_2_2_0_1_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g12*map.g02;
    const real G0_2_2_0_1_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g12*map.g12;
    const real G0_2_2_0_1_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g12*map.g22;
    const real G0_2_2_0_2_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g22*map.g02;
    const real G0_2_2_0_2_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g22*map.g12;
    const real G0_2_2_0_2_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g22*map.g22;
    const real G0_2_2_1_0_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g02*map.g02;
    const real G0_2_2_1_1_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g12*map.g02;
    const real G0_2_2_1_2_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g22*map.g02;
    const real G0_2_2_2_0_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g02*map.g12;
    const real G0_2_2_2_1_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g12*map.g12;
    const real G0_2_2_2_2_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g22*map.g12;
    const real G0_2_2_3_0_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g02*map.g22;
    const real G0_2_2_3_1_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g12*map.g22;
    const real G0_2_2_3_2_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g22*map.g22;
    const real G0_2_3_0_0_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g02*map.g02;
    const real G0_2_3_0_0_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g02*map.g12;
    const real G0_2_3_0_0_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g02*map.g22;
    const real G0_2_3_0_1_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g12*map.g02;
    const real G0_2_3_0_1_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g12*map.g12;
    const real G0_2_3_0_1_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g12*map.g22;
    const real G0_2_3_0_2_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g22*map.g02;
    const real G0_2_3_0_2_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g22*map.g12;
    const real G0_2_3_0_2_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g22*map.g22;
    const real G0_2_3_1_0_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g02*map.g02;
    const real G0_2_3_1_1_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g12*map.g02;
    const real G0_2_3_1_2_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g22*map.g02;
    const real G0_2_3_2_0_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g02*map.g12;
    const real G0_2_3_2_1_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g12*map.g12;
    const real G0_2_3_2_2_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g22*map.g12;
    const real G0_2_3_3_0_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g02*map.g22;
    const real G0_2_3_3_1_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g12*map.g22;
    const real G0_2_3_3_2_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g22*map.g22;
    const real G0_3_0_0_0_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g02*map.g02;
    const real G0_3_0_0_0_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g02*map.g12;
    const real G0_3_0_0_0_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g02*map.g22;
    const real G0_3_0_0_1_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g12*map.g02;
    const real G0_3_0_0_1_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g12*map.g12;
    const real G0_3_0_0_1_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g12*map.g22;
    const real G0_3_0_0_2_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g22*map.g02;
    const real G0_3_0_0_2_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g22*map.g12;
    const real G0_3_0_0_2_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g22*map.g22;
    const real G0_3_0_1_0_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g02*map.g02;
    const real G0_3_0_1_1_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g12*map.g02;
    const real G0_3_0_1_2_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g22*map.g02;
    const real G0_3_0_2_0_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g02*map.g12;
    const real G0_3_0_2_1_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g12*map.g12;
    const real G0_3_0_2_2_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g22*map.g12;
    const real G0_3_0_3_0_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g02*map.g22;
    const real G0_3_0_3_1_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g12*map.g22;
    const real G0_3_0_3_2_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g22*map.g22;
    const real G0_3_1_0_0_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g02*map.g02;
    const real G0_3_1_0_0_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g02*map.g12;
    const real G0_3_1_0_0_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g02*map.g22;
    const real G0_3_1_0_1_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g12*map.g02;
    const real G0_3_1_0_1_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g12*map.g12;
    const real G0_3_1_0_1_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g12*map.g22;
    const real G0_3_1_0_2_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g22*map.g02;
    const real G0_3_1_0_2_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g22*map.g12;
    const real G0_3_1_0_2_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g22*map.g22;
    const real G0_3_1_1_0_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g02*map.g02;
    const real G0_3_1_1_1_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g12*map.g02;
    const real G0_3_1_1_2_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g22*map.g02;
    const real G0_3_1_2_0_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g02*map.g12;
    const real G0_3_1_2_1_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g12*map.g12;
    const real G0_3_1_2_2_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g22*map.g12;
    const real G0_3_1_3_0_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g02*map.g22;
    const real G0_3_1_3_1_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g12*map.g22;
    const real G0_3_1_3_2_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g22*map.g22;
    const real G0_3_2_0_0_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g02*map.g02;
    const real G0_3_2_0_0_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g02*map.g12;
    const real G0_3_2_0_0_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g02*map.g22;
    const real G0_3_2_0_1_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g12*map.g02;
    const real G0_3_2_0_1_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g12*map.g12;
    const real G0_3_2_0_1_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g12*map.g22;
    const real G0_3_2_0_2_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g22*map.g02;
    const real G0_3_2_0_2_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g22*map.g12;
    const real G0_3_2_0_2_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g22*map.g22;
    const real G0_3_2_1_0_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g02*map.g02;
    const real G0_3_2_1_1_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g12*map.g02;
    const real G0_3_2_1_2_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g22*map.g02;
    const real G0_3_2_2_0_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g02*map.g12;
    const real G0_3_2_2_1_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g12*map.g12;
    const real G0_3_2_2_2_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g22*map.g12;
    const real G0_3_2_3_0_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g02*map.g22;
    const real G0_3_2_3_1_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g12*map.g22;
    const real G0_3_2_3_2_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g22*map.g22;
    const real G0_3_3_0_0_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g02*map.g02;
    const real G0_3_3_0_0_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g02*map.g12;
    const real G0_3_3_0_0_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g02*map.g22;
    const real G0_3_3_0_1_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g12*map.g02;
    const real G0_3_3_0_1_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g12*map.g12;
    const real G0_3_3_0_1_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g12*map.g22;
    const real G0_3_3_0_2_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g22*map.g02;
    const real G0_3_3_0_2_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g22*map.g12;
    const real G0_3_3_0_2_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g22*map.g22;
    const real G0_3_3_1_0_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g02*map.g02;
    const real G0_3_3_1_1_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g12*map.g02;
    const real G0_3_3_1_2_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g22*map.g02;
    const real G0_3_3_2_0_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g02*map.g12;
    const real G0_3_3_2_1_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g12*map.g12;
    const real G0_3_3_2_2_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g22*map.g12;
    const real G0_3_3_3_0_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g02*map.g22;
    const real G0_3_3_3_1_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g12*map.g22;
    const real G0_3_3_3_2_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g22*map.g22;
    const real G1_0_0_0_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g02;
    const real G1_0_0_0_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g12;
    const real G1_0_0_0_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g22;
    const real G1_0_0_1_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g02;
    const real G1_0_0_1_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g12;
    const real G1_0_0_1_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g22;
    const real G1_0_0_2_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g02;
    const real G1_0_0_2_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g12;
    const real G1_0_0_2_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g22;
    const real G1_0_1_0_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g02;
    const real G1_0_1_1_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g02;
    const real G1_0_1_2_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g02;
    const real G1_0_2_0_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g12;
    const real G1_0_2_1_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g12;
    const real G1_0_2_2_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g12;
    const real G1_0_3_0_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g22;
    const real G1_0_3_1_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g22;
    const real G1_0_3_2_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g22;
    const real G1_1_0_0_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g02;
    const real G1_1_0_0_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g12;
    const real G1_1_0_0_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g22;
    const real G1_1_0_1_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g02;
    const real G1_1_0_1_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g12;
    const real G1_1_0_1_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g22;
    const real G1_1_0_2_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g02;
    const real G1_1_0_2_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g12;
    const real G1_1_0_2_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g22;
    const real G1_1_1_0_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g02;
    const real G1_1_1_1_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g02;
    const real G1_1_1_2_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g02;
    const real G1_1_2_0_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g12;
    const real G1_1_2_1_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g12;
    const real G1_1_2_2_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g12;
    const real G1_1_3_0_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g22;
    const real G1_1_3_1_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g22;
    const real G1_1_3_2_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g22;
    const real G1_2_0_0_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g02;
    const real G1_2_0_0_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g12;
    const real G1_2_0_0_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g22;
    const real G1_2_0_1_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g02;
    const real G1_2_0_1_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g12;
    const real G1_2_0_1_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g22;
    const real G1_2_0_2_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g02;
    const real G1_2_0_2_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g12;
    const real G1_2_0_2_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g22;
    const real G1_2_1_0_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g02;
    const real G1_2_1_1_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g02;
    const real G1_2_1_2_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g02;
    const real G1_2_2_0_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g12;
    const real G1_2_2_1_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g12;
    const real G1_2_2_2_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g12;
    const real G1_2_3_0_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g22;
    const real G1_2_3_1_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g22;
    const real G1_2_3_2_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g22;
    const real G1_3_0_0_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g02;
    const real G1_3_0_0_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g12;
    const real G1_3_0_0_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g22;
    const real G1_3_0_1_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g02;
    const real G1_3_0_1_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g12;
    const real G1_3_0_1_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g22;
    const real G1_3_0_2_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g02;
    const real G1_3_0_2_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g12;
    const real G1_3_0_2_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g22;
    const real G1_3_1_0_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g02;
    const real G1_3_1_1_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g02;
    const real G1_3_1_2_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g02 + map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g02;
    const real G1_3_2_0_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g12;
    const real G1_3_2_1_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g12;
    const real G1_3_2_2_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g12 + map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g12;
    const real G1_3_3_0_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g22;
    const real G1_3_3_1_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g22;
    const real G1_3_3_2_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g22 + map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g22;
    const real G2_0_0_0 = map.det*c3*c2*c1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*map.g02*map.g02;
    const real G2_0_0_1 = map.det*c3*c2*c1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*map.g02*map.g12;
    const real G2_0_0_2 = map.det*c3*c2*c1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*map.g02*map.g22;
    const real G2_0_1_0 = map.det*c3*c2*c1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*map.g12*map.g02;
    const real G2_0_1_1 = map.det*c3*c2*c1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*map.g12*map.g12;
    const real G2_0_1_2 = map.det*c3*c2*c1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*map.g12*map.g22;
    const real G2_0_2_0 = map.det*c3*c2*c1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*map.g22*map.g02;
    const real G2_0_2_1 = map.det*c3*c2*c1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*map.g22*map.g12;
    const real G2_0_2_2 = map.det*c3*c2*c1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*map.g22*map.g22;
    const real G2_1_0_0 = map.det*c3*c2*c1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*map.g02*map.g02;
    const real G2_1_1_0 = map.det*c3*c2*c1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*map.g12*map.g02;
    const real G2_1_2_0 = map.det*c3*c2*c1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*map.g22*map.g02;
    const real G2_2_0_1 = map.det*c3*c2*c1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*map.g02*map.g12;
    const real G2_2_1_1 = map.det*c3*c2*c1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*map.g12*map.g12;
    const real G2_2_2_1 = map.det*c3*c2*c1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*map.g22*map.g12;
    const real G2_3_0_2 = map.det*c3*c2*c1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*map.g02*map.g22;
    const real G2_3_1_2 = map.det*c3*c2*c1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*map.g12*map.g22;
    const real G2_3_2_2 = map.det*c3*c2*c1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*map.g22*map.g22;
    const real G3_0_0_0_0_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g02*map.g02;
    const real G3_0_0_0_0_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g02*map.g12;
    const real G3_0_0_0_0_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g02*map.g22;
    const real G3_0_0_0_1_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g12*map.g02;
    const real G3_0_0_0_1_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g12*map.g12;
    const real G3_0_0_0_1_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g12*map.g22;
    const real G3_0_0_0_2_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g22*map.g02;
    const real G3_0_0_0_2_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g22*map.g12;
    const real G3_0_0_0_2_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_0*map.g22*map.g22;
    const real G3_0_0_1_0_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g02*map.g02;
    const real G3_0_0_1_1_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g12*map.g02;
    const real G3_0_0_1_2_0 = map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*c0_1*map.g22*map.g02;
    const real G3_0_0_2_0_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g02*map.g12;
    const real G3_0_0_2_1_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g12*map.g12;
    const real G3_0_0_2_2_1 = map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*c0_2*map.g22*map.g12;
    const real G3_0_0_3_0_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g02*map.g22;
    const real G3_0_0_3_1_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g12*map.g22;
    const real G3_0_0_3_2_2 = map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*c0_3*map.g22*map.g22;
    const real G3_0_1_0_0_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g02*map.g02;
    const real G3_0_1_0_0_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g02*map.g12;
    const real G3_0_1_0_0_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g02*map.g22;
    const real G3_0_1_0_1_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g12*map.g02;
    const real G3_0_1_0_1_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g12*map.g12;
    const real G3_0_1_0_1_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g12*map.g22;
    const real G3_0_1_0_2_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g22*map.g02;
    const real G3_0_1_0_2_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g22*map.g12;
    const real G3_0_1_0_2_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_0*map.g22*map.g22;
    const real G3_0_1_1_0_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g02*map.g02;
    const real G3_0_1_1_1_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g12*map.g02;
    const real G3_0_1_1_2_0 = map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*c0_1*map.g22*map.g02;
    const real G3_0_1_2_0_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g02*map.g12;
    const real G3_0_1_2_1_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g12*map.g12;
    const real G3_0_1_2_2_1 = map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_1*c0_2*map.g22*map.g12;
    const real G3_0_1_3_0_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g02*map.g22;
    const real G3_0_1_3_1_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g12*map.g22;
    const real G3_0_1_3_2_2 = map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_1*c0_3*map.g22*map.g22;
    const real G3_0_2_0_0_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g02*map.g02;
    const real G3_0_2_0_0_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g02*map.g12;
    const real G3_0_2_0_0_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g02*map.g22;
    const real G3_0_2_0_1_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g12*map.g02;
    const real G3_0_2_0_1_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g12*map.g12;
    const real G3_0_2_0_1_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g12*map.g22;
    const real G3_0_2_0_2_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g22*map.g02;
    const real G3_0_2_0_2_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g22*map.g12;
    const real G3_0_2_0_2_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_0*map.g22*map.g22;
    const real G3_0_2_1_0_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g02*map.g02;
    const real G3_0_2_1_1_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g12*map.g02;
    const real G3_0_2_1_2_0 = map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_2*c0_1*map.g22*map.g02;
    const real G3_0_2_2_0_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g02*map.g12;
    const real G3_0_2_2_1_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g12*map.g12;
    const real G3_0_2_2_2_1 = map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*c0_2*map.g22*map.g12;
    const real G3_0_2_3_0_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g02*map.g22;
    const real G3_0_2_3_1_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g12*map.g22;
    const real G3_0_2_3_2_2 = map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_2*c0_3*map.g22*map.g22;
    const real G3_0_3_0_0_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g02*map.g02;
    const real G3_0_3_0_0_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g02*map.g12;
    const real G3_0_3_0_0_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g02*map.g22;
    const real G3_0_3_0_1_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g12*map.g02;
    const real G3_0_3_0_1_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g12*map.g12;
    const real G3_0_3_0_1_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g12*map.g22;
    const real G3_0_3_0_2_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g22*map.g02;
    const real G3_0_3_0_2_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g22*map.g12;
    const real G3_0_3_0_2_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_0*map.g22*map.g22;
    const real G3_0_3_1_0_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g02*map.g02;
    const real G3_0_3_1_1_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g12*map.g02;
    const real G3_0_3_1_2_0 = map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_3*c0_1*map.g22*map.g02;
    const real G3_0_3_2_0_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g02*map.g12;
    const real G3_0_3_2_1_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g12*map.g12;
    const real G3_0_3_2_2_1 = map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_3*c0_2*map.g22*map.g12;
    const real G3_0_3_3_0_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g02*map.g22;
    const real G3_0_3_3_1_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g12*map.g22;
    const real G3_0_3_3_2_2 = map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*c0_3*map.g22*map.g22;
    const real G3_1_0_0_0_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g02*map.g02;
    const real G3_1_0_0_0_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g02*map.g12;
    const real G3_1_0_0_0_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g02*map.g22;
    const real G3_1_0_0_1_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g12*map.g02;
    const real G3_1_0_0_1_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g12*map.g12;
    const real G3_1_0_0_1_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g12*map.g22;
    const real G3_1_0_0_2_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g22*map.g02;
    const real G3_1_0_0_2_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g22*map.g12;
    const real G3_1_0_0_2_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_0*map.g22*map.g22;
    const real G3_1_0_1_0_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g02*map.g02;
    const real G3_1_0_1_1_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g12*map.g02;
    const real G3_1_0_1_2_0 = map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*c0_1*map.g22*map.g02;
    const real G3_1_0_2_0_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g02*map.g12;
    const real G3_1_0_2_1_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g12*map.g12;
    const real G3_1_0_2_2_1 = map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*c0_2*map.g22*map.g12;
    const real G3_1_0_3_0_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g02*map.g22;
    const real G3_1_0_3_1_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g12*map.g22;
    const real G3_1_0_3_2_2 = map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*c0_3*map.g22*map.g22;
    const real G3_1_1_0_0_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g02*map.g02;
    const real G3_1_1_0_0_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g02*map.g12;
    const real G3_1_1_0_0_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g02*map.g22;
    const real G3_1_1_0_1_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g12*map.g02;
    const real G3_1_1_0_1_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g12*map.g12;
    const real G3_1_1_0_1_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g12*map.g22;
    const real G3_1_1_0_2_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g22*map.g02;
    const real G3_1_1_0_2_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g22*map.g12;
    const real G3_1_1_0_2_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_0*map.g22*map.g22;
    const real G3_1_1_1_0_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g02*map.g02;
    const real G3_1_1_1_1_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g12*map.g02;
    const real G3_1_1_1_2_0 = map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*c0_1*map.g22*map.g02;
    const real G3_1_1_2_0_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g02*map.g12;
    const real G3_1_1_2_1_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g12*map.g12;
    const real G3_1_1_2_2_1 = map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_1*c0_2*map.g22*map.g12;
    const real G3_1_1_3_0_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g02*map.g22;
    const real G3_1_1_3_1_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g12*map.g22;
    const real G3_1_1_3_2_2 = map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_1*c0_3*map.g22*map.g22;
    const real G3_1_2_0_0_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g02*map.g02;
    const real G3_1_2_0_0_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g02*map.g12;
    const real G3_1_2_0_0_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g02*map.g22;
    const real G3_1_2_0_1_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g12*map.g02;
    const real G3_1_2_0_1_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g12*map.g12;
    const real G3_1_2_0_1_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g12*map.g22;
    const real G3_1_2_0_2_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g22*map.g02;
    const real G3_1_2_0_2_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g22*map.g12;
    const real G3_1_2_0_2_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_0*map.g22*map.g22;
    const real G3_1_2_1_0_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g02*map.g02;
    const real G3_1_2_1_1_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g12*map.g02;
    const real G3_1_2_1_2_0 = map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_2*c0_1*map.g22*map.g02;
    const real G3_1_2_2_0_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g02*map.g12;
    const real G3_1_2_2_1_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g12*map.g12;
    const real G3_1_2_2_2_1 = map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*c0_2*map.g22*map.g12;
    const real G3_1_2_3_0_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g02*map.g22;
    const real G3_1_2_3_1_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g12*map.g22;
    const real G3_1_2_3_2_2 = map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_2*c0_3*map.g22*map.g22;
    const real G3_1_3_0_0_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g02*map.g02;
    const real G3_1_3_0_0_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g02*map.g12;
    const real G3_1_3_0_0_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g02*map.g22;
    const real G3_1_3_0_1_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g12*map.g02;
    const real G3_1_3_0_1_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g12*map.g12;
    const real G3_1_3_0_1_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g12*map.g22;
    const real G3_1_3_0_2_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g22*map.g02;
    const real G3_1_3_0_2_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g22*map.g12;
    const real G3_1_3_0_2_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_0*map.g22*map.g22;
    const real G3_1_3_1_0_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g02*map.g02;
    const real G3_1_3_1_1_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g12*map.g02;
    const real G3_1_3_1_2_0 = map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_3*c0_1*map.g22*map.g02;
    const real G3_1_3_2_0_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g02*map.g12;
    const real G3_1_3_2_1_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g12*map.g12;
    const real G3_1_3_2_2_1 = map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_3*c0_2*map.g22*map.g12;
    const real G3_1_3_3_0_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g02*map.g22;
    const real G3_1_3_3_1_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g12*map.g22;
    const real G3_1_3_3_2_2 = map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*c0_3*map.g22*map.g22;
    const real G3_2_0_0_0_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g02*map.g02;
    const real G3_2_0_0_0_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g02*map.g12;
    const real G3_2_0_0_0_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g02*map.g22;
    const real G3_2_0_0_1_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g12*map.g02;
    const real G3_2_0_0_1_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g12*map.g12;
    const real G3_2_0_0_1_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g12*map.g22;
    const real G3_2_0_0_2_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g22*map.g02;
    const real G3_2_0_0_2_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g22*map.g12;
    const real G3_2_0_0_2_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_0*map.g22*map.g22;
    const real G3_2_0_1_0_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g02*map.g02;
    const real G3_2_0_1_1_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g12*map.g02;
    const real G3_2_0_1_2_0 = map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*c0_1*map.g22*map.g02;
    const real G3_2_0_2_0_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g02*map.g12;
    const real G3_2_0_2_1_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g12*map.g12;
    const real G3_2_0_2_2_1 = map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*c0_2*map.g22*map.g12;
    const real G3_2_0_3_0_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g02*map.g22;
    const real G3_2_0_3_1_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g12*map.g22;
    const real G3_2_0_3_2_2 = map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*c0_3*map.g22*map.g22;
    const real G3_2_1_0_0_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g02*map.g02;
    const real G3_2_1_0_0_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g02*map.g12;
    const real G3_2_1_0_0_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g02*map.g22;
    const real G3_2_1_0_1_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g12*map.g02;
    const real G3_2_1_0_1_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g12*map.g12;
    const real G3_2_1_0_1_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g12*map.g22;
    const real G3_2_1_0_2_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g22*map.g02;
    const real G3_2_1_0_2_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g22*map.g12;
    const real G3_2_1_0_2_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_0*map.g22*map.g22;
    const real G3_2_1_1_0_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g02*map.g02;
    const real G3_2_1_1_1_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g12*map.g02;
    const real G3_2_1_1_2_0 = map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*c0_1*map.g22*map.g02;
    const real G3_2_1_2_0_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g02*map.g12;
    const real G3_2_1_2_1_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g12*map.g12;
    const real G3_2_1_2_2_1 = map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_1*c0_2*map.g22*map.g12;
    const real G3_2_1_3_0_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g02*map.g22;
    const real G3_2_1_3_1_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g12*map.g22;
    const real G3_2_1_3_2_2 = map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_1*c0_3*map.g22*map.g22;
    const real G3_2_2_0_0_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g02*map.g02;
    const real G3_2_2_0_0_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g02*map.g12;
    const real G3_2_2_0_0_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g02*map.g22;
    const real G3_2_2_0_1_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g12*map.g02;
    const real G3_2_2_0_1_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g12*map.g12;
    const real G3_2_2_0_1_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g12*map.g22;
    const real G3_2_2_0_2_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g22*map.g02;
    const real G3_2_2_0_2_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g22*map.g12;
    const real G3_2_2_0_2_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_0*map.g22*map.g22;
    const real G3_2_2_1_0_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g02*map.g02;
    const real G3_2_2_1_1_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g12*map.g02;
    const real G3_2_2_1_2_0 = map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_2*c0_1*map.g22*map.g02;
    const real G3_2_2_2_0_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g02*map.g12;
    const real G3_2_2_2_1_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g12*map.g12;
    const real G3_2_2_2_2_1 = map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*c0_2*map.g22*map.g12;
    const real G3_2_2_3_0_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g02*map.g22;
    const real G3_2_2_3_1_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g12*map.g22;
    const real G3_2_2_3_2_2 = map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_2*c0_3*map.g22*map.g22;
    const real G3_2_3_0_0_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g02*map.g02;
    const real G3_2_3_0_0_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g02*map.g12;
    const real G3_2_3_0_0_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g02*map.g22;
    const real G3_2_3_0_1_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g12*map.g02;
    const real G3_2_3_0_1_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g12*map.g12;
    const real G3_2_3_0_1_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g12*map.g22;
    const real G3_2_3_0_2_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g22*map.g02;
    const real G3_2_3_0_2_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g22*map.g12;
    const real G3_2_3_0_2_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_0*map.g22*map.g22;
    const real G3_2_3_1_0_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g02*map.g02;
    const real G3_2_3_1_1_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g12*map.g02;
    const real G3_2_3_1_2_0 = map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_3*c0_1*map.g22*map.g02;
    const real G3_2_3_2_0_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g02*map.g12;
    const real G3_2_3_2_1_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g12*map.g12;
    const real G3_2_3_2_2_1 = map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_3*c0_2*map.g22*map.g12;
    const real G3_2_3_3_0_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g02*map.g22;
    const real G3_2_3_3_1_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g12*map.g22;
    const real G3_2_3_3_2_2 = map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*c0_3*map.g22*map.g22;
    const real G3_3_0_0_0_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g02*map.g02;
    const real G3_3_0_0_0_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g02*map.g12;
    const real G3_3_0_0_0_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g02*map.g22;
    const real G3_3_0_0_1_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g12*map.g02;
    const real G3_3_0_0_1_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g12*map.g12;
    const real G3_3_0_0_1_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g12*map.g22;
    const real G3_3_0_0_2_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g22*map.g02;
    const real G3_3_0_0_2_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g22*map.g12;
    const real G3_3_0_0_2_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_0*map.g22*map.g22;
    const real G3_3_0_1_0_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g02*map.g02;
    const real G3_3_0_1_1_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g12*map.g02;
    const real G3_3_0_1_2_0 = map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*c0_1*map.g22*map.g02;
    const real G3_3_0_2_0_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g02*map.g12;
    const real G3_3_0_2_1_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g12*map.g12;
    const real G3_3_0_2_2_1 = map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*c0_2*map.g22*map.g12;
    const real G3_3_0_3_0_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g02*map.g22;
    const real G3_3_0_3_1_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g12*map.g22;
    const real G3_3_0_3_2_2 = map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*c0_3*map.g22*map.g22;
    const real G3_3_1_0_0_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g02*map.g02;
    const real G3_3_1_0_0_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g02*map.g12;
    const real G3_3_1_0_0_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g02*map.g22;
    const real G3_3_1_0_1_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g12*map.g02;
    const real G3_3_1_0_1_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g12*map.g12;
    const real G3_3_1_0_1_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g12*map.g22;
    const real G3_3_1_0_2_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g22*map.g02;
    const real G3_3_1_0_2_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g22*map.g12;
    const real G3_3_1_0_2_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_0*map.g22*map.g22;
    const real G3_3_1_1_0_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g02*map.g02;
    const real G3_3_1_1_1_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g12*map.g02;
    const real G3_3_1_1_2_0 = map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*c0_1*map.g22*map.g02;
    const real G3_3_1_2_0_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g02*map.g12;
    const real G3_3_1_2_1_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g12*map.g12;
    const real G3_3_1_2_2_1 = map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_1*c0_2*map.g22*map.g12;
    const real G3_3_1_3_0_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g02*map.g22;
    const real G3_3_1_3_1_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g12*map.g22;
    const real G3_3_1_3_2_2 = map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_1*c0_3*map.g22*map.g22;
    const real G3_3_2_0_0_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g02*map.g02;
    const real G3_3_2_0_0_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g02*map.g12;
    const real G3_3_2_0_0_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g02*map.g22;
    const real G3_3_2_0_1_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g12*map.g02;
    const real G3_3_2_0_1_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g12*map.g12;
    const real G3_3_2_0_1_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g12*map.g22;
    const real G3_3_2_0_2_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g22*map.g02;
    const real G3_3_2_0_2_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g22*map.g12;
    const real G3_3_2_0_2_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_0*map.g22*map.g22;
    const real G3_3_2_1_0_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g02*map.g02;
    const real G3_3_2_1_1_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g12*map.g02;
    const real G3_3_2_1_2_0 = map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_2*c0_1*map.g22*map.g02;
    const real G3_3_2_2_0_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g02*map.g12;
    const real G3_3_2_2_1_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g12*map.g12;
    const real G3_3_2_2_2_1 = map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*c0_2*map.g22*map.g12;
    const real G3_3_2_3_0_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g02*map.g22;
    const real G3_3_2_3_1_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g12*map.g22;
    const real G3_3_2_3_2_2 = map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_2*c0_3*map.g22*map.g22;
    const real G3_3_3_0_0_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g02*map.g02;
    const real G3_3_3_0_0_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g02*map.g12;
    const real G3_3_3_0_0_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g02*map.g22;
    const real G3_3_3_0_1_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g12*map.g02;
    const real G3_3_3_0_1_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g12*map.g12;
    const real G3_3_3_0_1_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g12*map.g22;
    const real G3_3_3_0_2_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g22*map.g02;
    const real G3_3_3_0_2_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g22*map.g12;
    const real G3_3_3_0_2_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_0*map.g22*map.g22;
    const real G3_3_3_1_0_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g02*map.g02;
    const real G3_3_3_1_1_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g12*map.g02;
    const real G3_3_3_1_2_0 = map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_3*c0_1*map.g22*map.g02;
    const real G3_3_3_2_0_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g02*map.g12;
    const real G3_3_3_2_1_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g12*map.g12;
    const real G3_3_3_2_2_1 = map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_3*c0_2*map.g22*map.g12;
    const real G3_3_3_3_0_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g02*map.g22;
    const real G3_3_3_3_1_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g12*map.g22;
    const real G3_3_3_3_2_2 = map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*c0_3*map.g22*map.g22;
    const real G4_0_0_0_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g02;
    const real G4_0_0_0_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g12;
    const real G4_0_0_0_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g02*map.g22;
    const real G4_0_0_1_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g02;
    const real G4_0_0_1_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g12;
    const real G4_0_0_1_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g12*map.g22;
    const real G4_0_0_2_0 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g02;
    const real G4_0_0_2_1 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g12;
    const real G4_0_0_2_2 = map.det*c3*c2*c1*c0_0*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_0*map.g22*map.g22;
    const real G4_0_1_0_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g02*map.g02;
    const real G4_0_1_1_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g12*map.g02;
    const real G4_0_1_2_0 = map.det*c3*c2*c1*c0_0*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_0*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_0*c0_1*map.g22*map.g02;
    const real G4_0_2_0_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g02*map.g12;
    const real G4_0_2_1_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g12*map.g12;
    const real G4_0_2_2_1 = map.det*c3*c2*c1*c0_0*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_0*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_0*c0_2*map.g22*map.g12;
    const real G4_0_3_0_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g02*map.g22;
    const real G4_0_3_1_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g12*map.g22;
    const real G4_0_3_2_2 = map.det*c3*c2*c1*c0_0*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_0*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_0*c0_3*map.g22*map.g22;
    const real G4_1_0_0_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g02;
    const real G4_1_0_0_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g12;
    const real G4_1_0_0_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g02*map.g22;
    const real G4_1_0_1_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g02;
    const real G4_1_0_1_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g12;
    const real G4_1_0_1_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g12*map.g22;
    const real G4_1_0_2_0 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g02;
    const real G4_1_0_2_1 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g12;
    const real G4_1_0_2_2 = map.det*c3*c2*c1*c0_1*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_0*map.g22*map.g22;
    const real G4_1_1_0_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g02*map.g02;
    const real G4_1_1_1_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g12*map.g02;
    const real G4_1_1_2_0 = map.det*c3*c2*c1*c0_1*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_1*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_1*c0_1*map.g22*map.g02;
    const real G4_1_2_0_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g02*map.g12;
    const real G4_1_2_1_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g12*map.g12;
    const real G4_1_2_2_1 = map.det*c3*c2*c1*c0_1*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_1*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_1*c0_2*map.g22*map.g12;
    const real G4_1_3_0_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g02*map.g22;
    const real G4_1_3_1_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g12*map.g22;
    const real G4_1_3_2_2 = map.det*c3*c2*c1*c0_1*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_1*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_1*c0_3*map.g22*map.g22;
    const real G4_2_0_0_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g02;
    const real G4_2_0_0_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g12;
    const real G4_2_0_0_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g02*map.g22;
    const real G4_2_0_1_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g02;
    const real G4_2_0_1_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g12;
    const real G4_2_0_1_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g12*map.g22;
    const real G4_2_0_2_0 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g02;
    const real G4_2_0_2_1 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g12;
    const real G4_2_0_2_2 = map.det*c3*c2*c1*c0_2*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_0*map.g22*map.g22;
    const real G4_2_1_0_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g02*map.g02;
    const real G4_2_1_1_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g12*map.g02;
    const real G4_2_1_2_0 = map.det*c3*c2*c1*c0_2*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_2*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_2*c0_1*map.g22*map.g02;
    const real G4_2_2_0_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g02*map.g12;
    const real G4_2_2_1_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g12*map.g12;
    const real G4_2_2_2_1 = map.det*c3*c2*c1*c0_2*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_2*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_2*c0_2*map.g22*map.g12;
    const real G4_2_3_0_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g02*map.g22;
    const real G4_2_3_1_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g12*map.g22;
    const real G4_2_3_2_2 = map.det*c3*c2*c1*c0_2*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_2*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_2*c0_3*map.g22*map.g22;
    const real G4_3_0_0_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g02;
    const real G4_3_0_0_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g12;
    const real G4_3_0_0_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g02*map.g22;
    const real G4_3_0_1_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g02;
    const real G4_3_0_1_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g12;
    const real G4_3_0_1_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g12*map.g22;
    const real G4_3_0_2_0 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g02;
    const real G4_3_0_2_1 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g12;
    const real G4_3_0_2_2 = map.det*c3*c2*c1*c0_3*c0_0*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_0*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_0*map.g22*map.g22;
    const real G4_3_1_0_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g00*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g01*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g02*map.g02;
    const real G4_3_1_1_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g10*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g11*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g12*map.g02;
    const real G4_3_1_2_0 = map.det*c3*c2*c1*c0_3*c0_1*map.g20*map.g00 + map.det*c3*c2*c1*c0_3*c0_1*map.g21*map.g01 + map.det*c3*c2*c1*c0_3*c0_1*map.g22*map.g02;
    const real G4_3_2_0_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g00*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g01*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g02*map.g12;
    const real G4_3_2_1_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g10*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g11*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g12*map.g12;
    const real G4_3_2_2_1 = map.det*c3*c2*c1*c0_3*c0_2*map.g20*map.g10 + map.det*c3*c2*c1*c0_3*c0_2*map.g21*map.g11 + map.det*c3*c2*c1*c0_3*c0_2*map.g22*map.g12;
    const real G4_3_3_0_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g00*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g01*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g02*map.g22;
    const real G4_3_3_1_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g10*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g11*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g12*map.g22;
    const real G4_3_3_2_2 = map.det*c3*c2*c1*c0_3*c0_3*map.g20*map.g20 + map.det*c3*c2*c1*c0_3*c0_3*map.g21*map.g21 + map.det*c3*c2*c1*c0_3*c0_3*map.g22*map.g22;
    const real G5_4_0_0 = map.det*c3*c2*c0_4*map.g00*map.g00 + map.det*c3*c2*c0_4*map.g01*map.g01 + map.det*c3*c2*c0_4*map.g02*map.g02;
    const real G5_4_0_1 = map.det*c3*c2*c0_4*map.g00*map.g10 + map.det*c3*c2*c0_4*map.g01*map.g11 + map.det*c3*c2*c0_4*map.g02*map.g12;
    const real G5_4_0_2 = map.det*c3*c2*c0_4*map.g00*map.g20 + map.det*c3*c2*c0_4*map.g01*map.g21 + map.det*c3*c2*c0_4*map.g02*map.g22;
    const real G5_4_1_0 = map.det*c3*c2*c0_4*map.g10*map.g00 + map.det*c3*c2*c0_4*map.g11*map.g01 + map.det*c3*c2*c0_4*map.g12*map.g02;
    const real G5_4_1_1 = map.det*c3*c2*c0_4*map.g10*map.g10 + map.det*c3*c2*c0_4*map.g11*map.g11 + map.det*c3*c2*c0_4*map.g12*map.g12;
    const real G5_4_1_2 = map.det*c3*c2*c0_4*map.g10*map.g20 + map.det*c3*c2*c0_4*map.g11*map.g21 + map.det*c3*c2*c0_4*map.g12*map.g22;
    const real G5_4_2_0 = map.det*c3*c2*c0_4*map.g20*map.g00 + map.det*c3*c2*c0_4*map.g21*map.g01 + map.det*c3*c2*c0_4*map.g22*map.g02;
    const real G5_4_2_1 = map.det*c3*c2*c0_4*map.g20*map.g10 + map.det*c3*c2*c0_4*map.g21*map.g11 + map.det*c3*c2*c0_4*map.g22*map.g12;
    const real G5_4_2_2 = map.det*c3*c2*c0_4*map.g20*map.g20 + map.det*c3*c2*c0_4*map.g21*map.g21 + map.det*c3*c2*c0_4*map.g22*map.g22;
    const real G5_5_0_0 = map.det*c3*c2*c0_5*map.g00*map.g00 + map.det*c3*c2*c0_5*map.g01*map.g01 + map.det*c3*c2*c0_5*map.g02*map.g02;
    const real G5_5_1_0 = map.det*c3*c2*c0_5*map.g10*map.g00 + map.det*c3*c2*c0_5*map.g11*map.g01 + map.det*c3*c2*c0_5*map.g12*map.g02;
    const real G5_5_2_0 = map.det*c3*c2*c0_5*map.g20*map.g00 + map.det*c3*c2*c0_5*map.g21*map.g01 + map.det*c3*c2*c0_5*map.g22*map.g02;
    const real G5_6_0_1 = map.det*c3*c2*c0_6*map.g00*map.g10 + map.det*c3*c2*c0_6*map.g01*map.g11 + map.det*c3*c2*c0_6*map.g02*map.g12;
    const real G5_6_1_1 = map.det*c3*c2*c0_6*map.g10*map.g10 + map.det*c3*c2*c0_6*map.g11*map.g11 + map.det*c3*c2*c0_6*map.g12*map.g12;
    const real G5_6_2_1 = map.det*c3*c2*c0_6*map.g20*map.g10 + map.det*c3*c2*c0_6*map.g21*map.g11 + map.det*c3*c2*c0_6*map.g22*map.g12;
    const real G5_7_0_2 = map.det*c3*c2*c0_7*map.g00*map.g20 + map.det*c3*c2*c0_7*map.g01*map.g21 + map.det*c3*c2*c0_7*map.g02*map.g22;
    const real G5_7_1_2 = map.det*c3*c2*c0_7*map.g10*map.g20 + map.det*c3*c2*c0_7*map.g11*map.g21 + map.det*c3*c2*c0_7*map.g12*map.g22;
    const real G5_7_2_2 = map.det*c3*c2*c0_7*map.g20*map.g20 + map.det*c3*c2*c0_7*map.g21*map.g21 + map.det*c3*c2*c0_7*map.g22*map.g22;
    const real G6_0 = map.det*c3*c2*(1.0/c2)*(1.0/c3)*c0_0;
    const real G6_1 = map.det*c3*c2*(1.0/c2)*(1.0/c3)*c0_1;
    const real G6_2 = map.det*c3*c2*(1.0/c2)*(1.0/c3)*c0_2;
    const real G6_3 = map.det*c3*c2*(1.0/c2)*(1.0/c3)*c0_3;
    const real G7_0 = map.det*c3*c2*(1.0/c2)*(1.0/c3)*c1_0 + map.det*c3*c2*(1.0/c3)*c2_0;
    const real G7_1 = map.det*c3*c2*(1.0/c2)*(1.0/c3)*c1_1 + map.det*c3*c2*(1.0/c3)*c2_1;
    const real G7_2 = map.det*c3*c2*(1.0/c2)*(1.0/c3)*c1_2 + map.det*c3*c2*(1.0/c3)*c2_2;
    const real G7_3 = map.det*c3*c2*(1.0/c2)*(1.0/c3)*c1_3 + map.det*c3*c2*(1.0/c3)*c2_3;
    const real G8_0 = map.det*c3*c2*c3*(1.0/c3)*c2_0;
    const real G8_1 = map.det*c3*c2*c3*(1.0/c3)*c2_1;
    const real G8_2 = map.det*c3*c2*c3*(1.0/c3)*c2_2;
    const real G8_3 = map.det*c3*c2*c3*(1.0/c3)*c2_3;
    const real G9_4 = map.det*c0_4;
    const real G9_5 = map.det*c0_5;
    const real G9_6 = map.det*c0_6;
    const real G9_7 = map.det*c0_7;
    const real G10_0_0_0 = map.det*c0*c0_0*map.g00*map.g00 + map.det*c0*c0_0*map.g01*map.g01 + map.det*c0*c0_0*map.g02*map.g02;
    const real G10_0_0_1 = map.det*c0*c0_0*map.g00*map.g10 + map.det*c0*c0_0*map.g01*map.g11 + map.det*c0*c0_0*map.g02*map.g12;
    const real G10_0_0_2 = map.det*c0*c0_0*map.g00*map.g20 + map.det*c0*c0_0*map.g01*map.g21 + map.det*c0*c0_0*map.g02*map.g22;
    const real G10_0_1_0 = map.det*c0*c0_0*map.g10*map.g00 + map.det*c0*c0_0*map.g11*map.g01 + map.det*c0*c0_0*map.g12*map.g02;
    const real G10_0_1_1 = map.det*c0*c0_0*map.g10*map.g10 + map.det*c0*c0_0*map.g11*map.g11 + map.det*c0*c0_0*map.g12*map.g12;
    const real G10_0_1_2 = map.det*c0*c0_0*map.g10*map.g20 + map.det*c0*c0_0*map.g11*map.g21 + map.det*c0*c0_0*map.g12*map.g22;
    const real G10_0_2_0 = map.det*c0*c0_0*map.g20*map.g00 + map.det*c0*c0_0*map.g21*map.g01 + map.det*c0*c0_0*map.g22*map.g02;
    const real G10_0_2_1 = map.det*c0*c0_0*map.g20*map.g10 + map.det*c0*c0_0*map.g21*map.g11 + map.det*c0*c0_0*map.g22*map.g12;
    const real G10_0_2_2 = map.det*c0*c0_0*map.g20*map.g20 + map.det*c0*c0_0*map.g21*map.g21 + map.det*c0*c0_0*map.g22*map.g22;
    const real G10_1_0_0 = map.det*c0*c0_1*map.g00*map.g00 + map.det*c0*c0_1*map.g01*map.g01 + map.det*c0*c0_1*map.g02*map.g02;
    const real G10_1_1_0 = map.det*c0*c0_1*map.g10*map.g00 + map.det*c0*c0_1*map.g11*map.g01 + map.det*c0*c0_1*map.g12*map.g02;
    const real G10_1_2_0 = map.det*c0*c0_1*map.g20*map.g00 + map.det*c0*c0_1*map.g21*map.g01 + map.det*c0*c0_1*map.g22*map.g02;
    const real G10_2_0_1 = map.det*c0*c0_2*map.g00*map.g10 + map.det*c0*c0_2*map.g01*map.g11 + map.det*c0*c0_2*map.g02*map.g12;
    const real G10_2_1_1 = map.det*c0*c0_2*map.g10*map.g10 + map.det*c0*c0_2*map.g11*map.g11 + map.det*c0*c0_2*map.g12*map.g12;
    const real G10_2_2_1 = map.det*c0*c0_2*map.g20*map.g10 + map.det*c0*c0_2*map.g21*map.g11 + map.det*c0*c0_2*map.g22*map.g12;
    const real G10_3_0_2 = map.det*c0*c0_3*map.g00*map.g20 + map.det*c0*c0_3*map.g01*map.g21 + map.det*c0*c0_3*map.g02*map.g22;
    const real G10_3_1_2 = map.det*c0*c0_3*map.g10*map.g20 + map.det*c0*c0_3*map.g11*map.g21 + map.det*c0*c0_3*map.g12*map.g22;
    const real G10_3_2_2 = map.det*c0*c0_3*map.g20*map.g20 + map.det*c0*c0_3*map.g21*map.g21 + map.det*c0*c0_3*map.g22*map.g22;

    // Compute element tensor
    block[0] = -3.333333333333323e-02*G0_0_0_0_0_0 - 3.333333333333324e-02*G0_0_0_0_0_1 - 3.333333333333324e-02*G0_0_0_0_0_2 - 3.333333333333324e-02*G0_0_0_0_1_0 - 3.333333333333324e-02*G0_0_0_0_1_1 - 3.333333333333324e-02*G0_0_0_0_1_2 - 3.333333333333324e-02*G0_0_0_0_2_0 - 3.333333333333324e-02*G0_0_0_0_2_1 - 3.333333333333325e-02*G0_0_0_0_2_2 + 3.333333333333323e-02*G0_0_0_1_0_0 + 3.333333333333324e-02*G0_0_0_1_1_0 + 3.333333333333324e-02*G0_0_0_1_2_0 + 3.333333333333324e-02*G0_0_0_2_0_1 + 3.333333333333324e-02*G0_0_0_2_1_1 + 3.333333333333324e-02*G0_0_0_2_2_1 + 3.333333333333324e-02*G0_0_0_3_0_2 + 3.333333333333324e-02*G0_0_0_3_1_2 + 3.333333333333324e-02*G0_0_0_3_2_2 - 1.666666666666661e-02*G0_0_1_0_0_0 - 1.666666666666661e-02*G0_0_1_0_0_1 - 1.666666666666662e-02*G0_0_1_0_0_2 - 1.666666666666661e-02*G0_0_1_0_1_0 - 1.666666666666662e-02*G0_0_1_0_1_1 - 1.666666666666662e-02*G0_0_1_0_1_2 - 1.666666666666662e-02*G0_0_1_0_2_0 - 1.666666666666662e-02*G0_0_1_0_2_1 - 1.666666666666662e-02*G0_0_1_0_2_2 + 1.666666666666661e-02*G0_0_1_1_0_0 + 1.666666666666661e-02*G0_0_1_1_1_0 + 1.666666666666662e-02*G0_0_1_1_2_0 + 1.666666666666661e-02*G0_0_1_2_0_1 + 1.666666666666662e-02*G0_0_1_2_1_1 + 1.666666666666662e-02*G0_0_1_2_2_1 + 1.666666666666661e-02*G0_0_1_3_0_2 + 1.666666666666662e-02*G0_0_1_3_1_2 + 1.666666666666662e-02*G0_0_1_3_2_2 - 1.666666666666661e-02*G0_0_2_0_0_0 - 1.666666666666661e-02*G0_0_2_0_0_1 - 1.666666666666661e-02*G0_0_2_0_0_2 - 1.666666666666661e-02*G0_0_2_0_1_0 - 1.666666666666661e-02*G0_0_2_0_1_1 - 1.666666666666662e-02*G0_0_2_0_1_2 - 1.666666666666661e-02*G0_0_2_0_2_0 - 1.666666666666662e-02*G0_0_2_0_2_1 - 1.666666666666662e-02*G0_0_2_0_2_2 + 1.666666666666661e-02*G0_0_2_1_0_0 + 1.666666666666661e-02*G0_0_2_1_1_0 + 1.666666666666661e-02*G0_0_2_1_2_0 + 1.666666666666661e-02*G0_0_2_2_0_1 + 1.666666666666661e-02*G0_0_2_2_1_1 + 1.666666666666662e-02*G0_0_2_2_2_1 + 1.666666666666661e-02*G0_0_2_3_0_2 + 1.666666666666661e-02*G0_0_2_3_1_2 + 1.666666666666662e-02*G0_0_2_3_2_2 - 1.666666666666661e-02*G0_0_3_0_0_0 - 1.666666666666662e-02*G0_0_3_0_0_1 - 1.666666666666662e-02*G0_0_3_0_0_2 - 1.666666666666662e-02*G0_0_3_0_1_0 - 1.666666666666662e-02*G0_0_3_0_1_1 - 1.666666666666663e-02*G0_0_3_0_1_2 - 1.666666666666662e-02*G0_0_3_0_2_0 - 1.666666666666663e-02*G0_0_3_0_2_1 - 1.666666666666663e-02*G0_0_3_0_2_2 + 1.666666666666661e-02*G0_0_3_1_0_0 + 1.666666666666662e-02*G0_0_3_1_1_0 + 1.666666666666662e-02*G0_0_3_1_2_0 + 1.666666666666662e-02*G0_0_3_2_0_1 + 1.666666666666662e-02*G0_0_3_2_1_1 + 1.666666666666663e-02*G0_0_3_2_2_1 + 1.666666666666662e-02*G0_0_3_3_0_2 + 1.666666666666662e-02*G0_0_3_3_1_2 + 1.666666666666663e-02*G0_0_3_3_2_2 - 1.666666666666661e-02*G0_1_0_0_0_0 - 1.666666666666661e-02*G0_1_0_0_0_1 - 1.666666666666662e-02*G0_1_0_0_0_2 - 1.666666666666661e-02*G0_1_0_0_1_0 - 1.666666666666662e-02*G0_1_0_0_1_1 - 1.666666666666662e-02*G0_1_0_0_1_2 - 1.666666666666662e-02*G0_1_0_0_2_0 - 1.666666666666662e-02*G0_1_0_0_2_1 - 1.666666666666662e-02*G0_1_0_0_2_2 + 1.666666666666661e-02*G0_1_0_1_0_0 + 1.666666666666661e-02*G0_1_0_1_1_0 + 1.666666666666662e-02*G0_1_0_1_2_0 + 1.666666666666661e-02*G0_1_0_2_0_1 + 1.666666666666662e-02*G0_1_0_2_1_1 + 1.666666666666662e-02*G0_1_0_2_2_1 + 1.666666666666661e-02*G0_1_0_3_0_2 + 1.666666666666662e-02*G0_1_0_3_1_2 + 1.666666666666662e-02*G0_1_0_3_2_2 - 3.333333333333323e-02*G0_1_1_0_0_0 - 3.333333333333323e-02*G0_1_1_0_0_1 - 3.333333333333323e-02*G0_1_1_0_0_2 - 3.333333333333323e-02*G0_1_1_0_1_0 - 3.333333333333324e-02*G0_1_1_0_1_1 - 3.333333333333324e-02*G0_1_1_0_1_2 - 3.333333333333323e-02*G0_1_1_0_2_0 - 3.333333333333324e-02*G0_1_1_0_2_1 - 3.333333333333324e-02*G0_1_1_0_2_2 + 3.333333333333323e-02*G0_1_1_1_0_0 + 3.333333333333323e-02*G0_1_1_1_1_0 + 3.333333333333323e-02*G0_1_1_1_2_0 + 3.333333333333323e-02*G0_1_1_2_0_1 + 3.333333333333324e-02*G0_1_1_2_1_1 + 3.333333333333324e-02*G0_1_1_2_2_1 + 3.333333333333323e-02*G0_1_1_3_0_2 + 3.333333333333324e-02*G0_1_1_3_1_2 + 3.333333333333324e-02*G0_1_1_3_2_2 - 1.666666666666662e-02*G0_1_2_0_0_0 - 1.666666666666662e-02*G0_1_2_0_0_1 - 1.666666666666662e-02*G0_1_2_0_0_2 - 1.666666666666662e-02*G0_1_2_0_1_0 - 1.666666666666662e-02*G0_1_2_0_1_1 - 1.666666666666662e-02*G0_1_2_0_1_2 - 1.666666666666662e-02*G0_1_2_0_2_0 - 1.666666666666662e-02*G0_1_2_0_2_1 - 1.666666666666662e-02*G0_1_2_0_2_2 + 1.666666666666662e-02*G0_1_2_1_0_0 + 1.666666666666662e-02*G0_1_2_1_1_0 + 1.666666666666662e-02*G0_1_2_1_2_0 + 1.666666666666662e-02*G0_1_2_2_0_1 + 1.666666666666662e-02*G0_1_2_2_1_1 + 1.666666666666662e-02*G0_1_2_2_2_1 + 1.666666666666662e-02*G0_1_2_3_0_2 + 1.666666666666662e-02*G0_1_2_3_1_2 + 1.666666666666662e-02*G0_1_2_3_2_2 - 1.666666666666662e-02*G0_1_3_0_0_0 - 1.666666666666662e-02*G0_1_3_0_0_1 - 1.666666666666662e-02*G0_1_3_0_0_2 - 1.666666666666662e-02*G0_1_3_0_1_0 - 1.666666666666662e-02*G0_1_3_0_1_1 - 1.666666666666662e-02*G0_1_3_0_1_2 - 1.666666666666662e-02*G0_1_3_0_2_0 - 1.666666666666662e-02*G0_1_3_0_2_1 - 1.666666666666662e-02*G0_1_3_0_2_2 + 1.666666666666662e-02*G0_1_3_1_0_0 + 1.666666666666662e-02*G0_1_3_1_1_0 + 1.666666666666662e-02*G0_1_3_1_2_0 + 1.666666666666662e-02*G0_1_3_2_0_1 + 1.666666666666662e-02*G0_1_3_2_1_1 + 1.666666666666662e-02*G0_1_3_2_2_1 + 1.666666666666662e-02*G0_1_3_3_0_2 + 1.666666666666662e-02*G0_1_3_3_1_2 + 1.666666666666662e-02*G0_1_3_3_2_2 - 1.666666666666661e-02*G0_2_0_0_0_0 - 1.666666666666661e-02*G0_2_0_0_0_1 - 1.666666666666661e-02*G0_2_0_0_0_2 - 1.666666666666661e-02*G0_2_0_0_1_0 - 1.666666666666661e-02*G0_2_0_0_1_1 - 1.666666666666661e-02*G0_2_0_0_1_2 - 1.666666666666661e-02*G0_2_0_0_2_0 - 1.666666666666661e-02*G0_2_0_0_2_1 - 1.666666666666662e-02*G0_2_0_0_2_2 + 1.666666666666661e-02*G0_2_0_1_0_0 + 1.666666666666661e-02*G0_2_0_1_1_0 + 1.666666666666661e-02*G0_2_0_1_2_0 + 1.666666666666661e-02*G0_2_0_2_0_1 + 1.666666666666661e-02*G0_2_0_2_1_1 + 1.666666666666661e-02*G0_2_0_2_2_1 + 1.666666666666661e-02*G0_2_0_3_0_2 + 1.666666666666661e-02*G0_2_0_3_1_2 + 1.666666666666661e-02*G0_2_0_3_2_2 - 1.666666666666662e-02*G0_2_1_0_0_0 - 1.666666666666662e-02*G0_2_1_0_0_1 - 1.666666666666662e-02*G0_2_1_0_0_2 - 1.666666666666662e-02*G0_2_1_0_1_0 - 1.666666666666662e-02*G0_2_1_0_1_1 - 1.666666666666662e-02*G0_2_1_0_1_2 - 1.666666666666662e-02*G0_2_1_0_2_0 - 1.666666666666662e-02*G0_2_1_0_2_1 - 1.666666666666662e-02*G0_2_1_0_2_2 + 1.666666666666662e-02*G0_2_1_1_0_0 + 1.666666666666662e-02*G0_2_1_1_1_0 + 1.666666666666662e-02*G0_2_1_1_2_0 + 1.666666666666662e-02*G0_2_1_2_0_1 + 1.666666666666662e-02*G0_2_1_2_1_1 + 1.666666666666662e-02*G0_2_1_2_2_1 + 1.666666666666662e-02*G0_2_1_3_0_2 + 1.666666666666662e-02*G0_2_1_3_1_2 + 1.666666666666662e-02*G0_2_1_3_2_2 - 3.333333333333323e-02*G0_2_2_0_0_0 - 3.333333333333324e-02*G0_2_2_0_0_1 - 3.333333333333324e-02*G0_2_2_0_0_2 - 3.333333333333324e-02*G0_2_2_0_1_0 - 3.333333333333324e-02*G0_2_2_0_1_1 - 3.333333333333324e-02*G0_2_2_0_1_2 - 3.333333333333324e-02*G0_2_2_0_2_0 - 3.333333333333324e-02*G0_2_2_0_2_1 - 3.333333333333324e-02*G0_2_2_0_2_2 + 3.333333333333323e-02*G0_2_2_1_0_0 + 3.333333333333324e-02*G0_2_2_1_1_0 + 3.333333333333324e-02*G0_2_2_1_2_0 + 3.333333333333324e-02*G0_2_2_2_0_1 + 3.333333333333324e-02*G0_2_2_2_1_1 + 3.333333333333324e-02*G0_2_2_2_2_1 + 3.333333333333324e-02*G0_2_2_3_0_2 + 3.333333333333324e-02*G0_2_2_3_1_2 + 3.333333333333324e-02*G0_2_2_3_2_2 - 1.666666666666662e-02*G0_2_3_0_0_0 - 1.666666666666662e-02*G0_2_3_0_0_1 - 1.666666666666662e-02*G0_2_3_0_0_2 - 1.666666666666662e-02*G0_2_3_0_1_0 - 1.666666666666662e-02*G0_2_3_0_1_1 - 1.666666666666663e-02*G0_2_3_0_1_2 - 1.666666666666662e-02*G0_2_3_0_2_0 - 1.666666666666663e-02*G0_2_3_0_2_1 - 1.666666666666663e-02*G0_2_3_0_2_2 + 1.666666666666662e-02*G0_2_3_1_0_0 + 1.666666666666662e-02*G0_2_3_1_1_0 + 1.666666666666662e-02*G0_2_3_1_2_0 + 1.666666666666662e-02*G0_2_3_2_0_1 + 1.666666666666662e-02*G0_2_3_2_1_1 + 1.666666666666663e-02*G0_2_3_2_2_1 + 1.666666666666662e-02*G0_2_3_3_0_2 + 1.666666666666662e-02*G0_2_3_3_1_2 + 1.666666666666663e-02*G0_2_3_3_2_2 - 1.666666666666662e-02*G0_3_0_0_0_0 - 1.666666666666662e-02*G0_3_0_0_0_1 - 1.666666666666662e-02*G0_3_0_0_0_2 - 1.666666666666662e-02*G0_3_0_0_1_0 - 1.666666666666662e-02*G0_3_0_0_1_1 - 1.666666666666663e-02*G0_3_0_0_1_2 - 1.666666666666662e-02*G0_3_0_0_2_0 - 1.666666666666663e-02*G0_3_0_0_2_1 - 1.666666666666663e-02*G0_3_0_0_2_2 + 1.666666666666662e-02*G0_3_0_1_0_0 + 1.666666666666662e-02*G0_3_0_1_1_0 + 1.666666666666662e-02*G0_3_0_1_2_0 + 1.666666666666662e-02*G0_3_0_2_0_1 + 1.666666666666662e-02*G0_3_0_2_1_1 + 1.666666666666663e-02*G0_3_0_2_2_1 + 1.666666666666662e-02*G0_3_0_3_0_2 + 1.666666666666662e-02*G0_3_0_3_1_2 + 1.666666666666663e-02*G0_3_0_3_2_2 - 1.666666666666662e-02*G0_3_1_0_0_0 - 1.666666666666662e-02*G0_3_1_0_0_1 - 1.666666666666662e-02*G0_3_1_0_0_2 - 1.666666666666662e-02*G0_3_1_0_1_0 - 1.666666666666662e-02*G0_3_1_0_1_1 - 1.666666666666662e-02*G0_3_1_0_1_2 - 1.666666666666662e-02*G0_3_1_0_2_0 - 1.666666666666662e-02*G0_3_1_0_2_1 - 1.666666666666662e-02*G0_3_1_0_2_2 + 1.666666666666662e-02*G0_3_1_1_0_0 + 1.666666666666662e-02*G0_3_1_1_1_0 + 1.666666666666662e-02*G0_3_1_1_2_0 + 1.666666666666662e-02*G0_3_1_2_0_1 + 1.666666666666662e-02*G0_3_1_2_1_1 + 1.666666666666662e-02*G0_3_1_2_2_1 + 1.666666666666662e-02*G0_3_1_3_0_2 + 1.666666666666662e-02*G0_3_1_3_1_2 + 1.666666666666662e-02*G0_3_1_3_2_2 - 1.666666666666662e-02*G0_3_2_0_0_0 - 1.666666666666662e-02*G0_3_2_0_0_1 - 1.666666666666662e-02*G0_3_2_0_0_2 - 1.666666666666662e-02*G0_3_2_0_1_0 - 1.666666666666662e-02*G0_3_2_0_1_1 - 1.666666666666663e-02*G0_3_2_0_1_2 - 1.666666666666662e-02*G0_3_2_0_2_0 - 1.666666666666663e-02*G0_3_2_0_2_1 - 1.666666666666663e-02*G0_3_2_0_2_2 + 1.666666666666662e-02*G0_3_2_1_0_0 + 1.666666666666662e-02*G0_3_2_1_1_0 + 1.666666666666662e-02*G0_3_2_1_2_0 + 1.666666666666662e-02*G0_3_2_2_0_1 + 1.666666666666662e-02*G0_3_2_2_1_1 + 1.666666666666663e-02*G0_3_2_2_2_1 + 1.666666666666662e-02*G0_3_2_3_0_2 + 1.666666666666662e-02*G0_3_2_3_1_2 + 1.666666666666663e-02*G0_3_2_3_2_2 - 3.333333333333323e-02*G0_3_3_0_0_0 - 3.333333333333324e-02*G0_3_3_0_0_1 - 3.333333333333324e-02*G0_3_3_0_0_2 - 3.333333333333324e-02*G0_3_3_0_1_0 - 3.333333333333324e-02*G0_3_3_0_1_1 - 3.333333333333324e-02*G0_3_3_0_1_2 - 3.333333333333324e-02*G0_3_3_0_2_0 - 3.333333333333324e-02*G0_3_3_0_2_1 - 3.333333333333325e-02*G0_3_3_0_2_2 + 3.333333333333323e-02*G0_3_3_1_0_0 + 3.333333333333324e-02*G0_3_3_1_1_0 + 3.333333333333324e-02*G0_3_3_1_2_0 + 3.333333333333324e-02*G0_3_3_2_0_1 + 3.333333333333324e-02*G0_3_3_2_1_1 + 3.333333333333324e-02*G0_3_3_2_2_1 + 3.333333333333324e-02*G0_3_3_3_0_2 + 3.333333333333324e-02*G0_3_3_3_1_2 + 3.333333333333324e-02*G0_3_3_3_2_2 + 8.333333333333320e-02*G1_0_0_0_0 + 8.333333333333322e-02*G1_0_0_0_1 + 8.333333333333322e-02*G1_0_0_0_2 + 8.333333333333322e-02*G1_0_0_1_0 + 8.333333333333323e-02*G1_0_0_1_1 + 8.333333333333323e-02*G1_0_0_1_2 + 8.333333333333322e-02*G1_0_0_2_0 + 8.333333333333323e-02*G1_0_0_2_1 + 8.333333333333323e-02*G1_0_0_2_2 - 8.333333333333320e-02*G1_0_1_0_0 - 8.333333333333322e-02*G1_0_1_1_0 - 8.333333333333322e-02*G1_0_1_2_0 - 8.333333333333322e-02*G1_0_2_0_1 - 8.333333333333323e-02*G1_0_2_1_1 - 8.333333333333323e-02*G1_0_2_2_1 - 8.333333333333322e-02*G1_0_3_0_2 - 8.333333333333323e-02*G1_0_3_1_2 - 8.333333333333323e-02*G1_0_3_2_2 + 8.333333333333320e-02*G1_1_0_0_0 + 8.333333333333322e-02*G1_1_0_0_1 + 8.333333333333322e-02*G1_1_0_0_2 + 8.333333333333322e-02*G1_1_0_1_0 + 8.333333333333323e-02*G1_1_0_1_1 + 8.333333333333323e-02*G1_1_0_1_2 + 8.333333333333322e-02*G1_1_0_2_0 + 8.333333333333323e-02*G1_1_0_2_1 + 8.333333333333323e-02*G1_1_0_2_2 - 8.333333333333320e-02*G1_1_1_0_0 - 8.333333333333322e-02*G1_1_1_1_0 - 8.333333333333322e-02*G1_1_1_2_0 - 8.333333333333322e-02*G1_1_2_0_1 - 8.333333333333323e-02*G1_1_2_1_1 - 8.333333333333323e-02*G1_1_2_2_1 - 8.333333333333322e-02*G1_1_3_0_2 - 8.333333333333323e-02*G1_1_3_1_2 - 8.333333333333323e-02*G1_1_3_2_2 + 8.333333333333320e-02*G1_2_0_0_0 + 8.333333333333322e-02*G1_2_0_0_1 + 8.333333333333322e-02*G1_2_0_0_2 + 8.333333333333322e-02*G1_2_0_1_0 + 8.333333333333323e-02*G1_2_0_1_1 + 8.333333333333323e-02*G1_2_0_1_2 + 8.333333333333322e-02*G1_2_0_2_0 + 8.333333333333323e-02*G1_2_0_2_1 + 8.333333333333323e-02*G1_2_0_2_2 - 8.333333333333320e-02*G1_2_1_0_0 - 8.333333333333322e-02*G1_2_1_1_0 - 8.333333333333322e-02*G1_2_1_2_0 - 8.333333333333322e-02*G1_2_2_0_1 - 8.333333333333323e-02*G1_2_2_1_1 - 8.333333333333323e-02*G1_2_2_2_1 - 8.333333333333322e-02*G1_2_3_0_2 - 8.333333333333323e-02*G1_2_3_1_2 - 8.333333333333323e-02*G1_2_3_2_2 + 8.333333333333320e-02*G1_3_0_0_0 + 8.333333333333322e-02*G1_3_0_0_1 + 8.333333333333322e-02*G1_3_0_0_2 + 8.333333333333322e-02*G1_3_0_1_0 + 8.333333333333323e-02*G1_3_0_1_1 + 8.333333333333323e-02*G1_3_0_1_2 + 8.333333333333322e-02*G1_3_0_2_0 + 8.333333333333323e-02*G1_3_0_2_1 + 8.333333333333323e-02*G1_3_0_2_2 - 8.333333333333320e-02*G1_3_1_0_0 - 8.333333333333322e-02*G1_3_1_1_0 - 8.333333333333322e-02*G1_3_1_2_0 - 8.333333333333322e-02*G1_3_2_0_1 - 8.333333333333323e-02*G1_3_2_1_1 - 8.333333333333323e-02*G1_3_2_2_1 - 8.333333333333322e-02*G1_3_3_0_2 - 8.333333333333323e-02*G1_3_3_1_2 - 8.333333333333323e-02*G1_3_3_2_2 - 3.333333333333328e-01*G2_0_0_0 - 3.333333333333329e-01*G2_0_0_1 - 3.333333333333329e-01*G2_0_0_2 - 3.333333333333329e-01*G2_0_1_0 - 3.333333333333329e-01*G2_0_1_1 - 3.333333333333329e-01*G2_0_1_2 - 3.333333333333329e-01*G2_0_2_0 - 3.333333333333329e-01*G2_0_2_1 - 3.333333333333329e-01*G2_0_2_2 + 3.333333333333328e-01*G2_1_0_0 + 3.333333333333329e-01*G2_1_1_0 + 3.333333333333329e-01*G2_1_2_0 + 3.333333333333329e-01*G2_2_0_1 + 3.333333333333329e-01*G2_2_1_1 + 3.333333333333329e-01*G2_2_2_1 + 3.333333333333329e-01*G2_3_0_2 + 3.333333333333329e-01*G2_3_1_2 + 3.333333333333329e-01*G2_3_2_2 - 1.333333333333329e-01*G3_0_0_0_0_0 - 1.333333333333329e-01*G3_0_0_0_0_1 - 1.333333333333330e-01*G3_0_0_0_0_2 - 1.333333333333329e-01*G3_0_0_0_1_0 - 1.333333333333329e-01*G3_0_0_0_1_1 - 1.333333333333330e-01*G3_0_0_0_1_2 - 1.333333333333330e-01*G3_0_0_0_2_0 - 1.333333333333330e-01*G3_0_0_0_2_1 - 1.333333333333330e-01*G3_0_0_0_2_2 + 1.333333333333329e-01*G3_0_0_1_0_0 + 1.333333333333329e-01*G3_0_0_1_1_0 + 1.333333333333330e-01*G3_0_0_1_2_0 + 1.333333333333329e-01*G3_0_0_2_0_1 + 1.333333333333329e-01*G3_0_0_2_1_1 + 1.333333333333330e-01*G3_0_0_2_2_1 + 1.333333333333329e-01*G3_0_0_3_0_2 + 1.333333333333329e-01*G3_0_0_3_1_2 + 1.333333333333330e-01*G3_0_0_3_2_2 - 6.666666666666646e-02*G3_0_1_0_0_0 - 6.666666666666646e-02*G3_0_1_0_0_1 - 6.666666666666647e-02*G3_0_1_0_0_2 - 6.666666666666646e-02*G3_0_1_0_1_0 - 6.666666666666647e-02*G3_0_1_0_1_1 - 6.666666666666647e-02*G3_0_1_0_1_2 - 6.666666666666647e-02*G3_0_1_0_2_0 - 6.666666666666647e-02*G3_0_1_0_2_1 - 6.666666666666649e-02*G3_0_1_0_2_2 + 6.666666666666646e-02*G3_0_1_1_0_0 + 6.666666666666646e-02*G3_0_1_1_1_0 + 6.666666666666647e-02*G3_0_1_1_2_0 + 6.666666666666646e-02*G3_0_1_2_0_1 + 6.666666666666647e-02*G3_0_1_2_1_1 + 6.666666666666647e-02*G3_0_1_2_2_1 + 6.666666666666646e-02*G3_0_1_3_0_2 + 6.666666666666647e-02*G3_0_1_3_1_2 + 6.666666666666647e-02*G3_0_1_3_2_2 - 6.666666666666644e-02*G3_0_2_0_0_0 - 6.666666666666644e-02*G3_0_2_0_0_1 - 6.666666666666646e-02*G3_0_2_0_0_2 - 6.666666666666644e-02*G3_0_2_0_1_0 - 6.666666666666646e-02*G3_0_2_0_1_1 - 6.666666666666647e-02*G3_0_2_0_1_2 - 6.666666666666646e-02*G3_0_2_0_2_0 - 6.666666666666647e-02*G3_0_2_0_2_1 - 6.666666666666647e-02*G3_0_2_0_2_2 + 6.666666666666644e-02*G3_0_2_1_0_0 + 6.666666666666644e-02*G3_0_2_1_1_0 + 6.666666666666646e-02*G3_0_2_1_2_0 + 6.666666666666644e-02*G3_0_2_2_0_1 + 6.666666666666646e-02*G3_0_2_2_1_1 + 6.666666666666647e-02*G3_0_2_2_2_1 + 6.666666666666644e-02*G3_0_2_3_0_2 + 6.666666666666646e-02*G3_0_2_3_1_2 + 6.666666666666647e-02*G3_0_2_3_2_2 - 6.666666666666644e-02*G3_0_3_0_0_0 - 6.666666666666647e-02*G3_0_3_0_0_1 - 6.666666666666647e-02*G3_0_3_0_0_2 - 6.666666666666647e-02*G3_0_3_0_1_0 - 6.666666666666650e-02*G3_0_3_0_1_1 - 6.666666666666651e-02*G3_0_3_0_1_2 - 6.666666666666647e-02*G3_0_3_0_2_0 - 6.666666666666651e-02*G3_0_3_0_2_1 - 6.666666666666651e-02*G3_0_3_0_2_2 + 6.666666666666644e-02*G3_0_3_1_0_0 + 6.666666666666647e-02*G3_0_3_1_1_0 + 6.666666666666647e-02*G3_0_3_1_2_0 + 6.666666666666647e-02*G3_0_3_2_0_1 + 6.666666666666650e-02*G3_0_3_2_1_1 + 6.666666666666651e-02*G3_0_3_2_2_1 + 6.666666666666647e-02*G3_0_3_3_0_2 + 6.666666666666650e-02*G3_0_3_3_1_2 + 6.666666666666651e-02*G3_0_3_3_2_2 - 6.666666666666646e-02*G3_1_0_0_0_0 - 6.666666666666646e-02*G3_1_0_0_0_1 - 6.666666666666647e-02*G3_1_0_0_0_2 - 6.666666666666646e-02*G3_1_0_0_1_0 - 6.666666666666647e-02*G3_1_0_0_1_1 - 6.666666666666647e-02*G3_1_0_0_1_2 - 6.666666666666647e-02*G3_1_0_0_2_0 - 6.666666666666647e-02*G3_1_0_0_2_1 - 6.666666666666649e-02*G3_1_0_0_2_2 + 6.666666666666646e-02*G3_1_0_1_0_0 + 6.666666666666646e-02*G3_1_0_1_1_0 + 6.666666666666647e-02*G3_1_0_1_2_0 + 6.666666666666646e-02*G3_1_0_2_0_1 + 6.666666666666647e-02*G3_1_0_2_1_1 + 6.666666666666647e-02*G3_1_0_2_2_1 + 6.666666666666646e-02*G3_1_0_3_0_2 + 6.666666666666647e-02*G3_1_0_3_1_2 + 6.666666666666647e-02*G3_1_0_3_2_2 - 1.333333333333329e-01*G3_1_1_0_0_0 - 1.333333333333329e-01*G3_1_1_0_0_1 - 1.333333333333329e-01*G3_1_1_0_0_2 - 1.333333333333329e-01*G3_1_1_0_1_0 - 1.333333333333329e-01*G3_1_1_0_1_1 - 1.333333333333329e-01*G3_1_1_0_1_2 - 1.333333333333329e-01*G3_1_1_0_2_0 - 1.333333333333329e-01*G3_1_1_0_2_1 - 1.333333333333329e-01*G3_1_1_0_2_2 + 1.333333333333329e-01*G3_1_1_1_0_0 + 1.333333333333329e-01*G3_1_1_1_1_0 + 1.333333333333329e-01*G3_1_1_1_2_0 + 1.333333333333329e-01*G3_1_1_2_0_1 + 1.333333333333329e-01*G3_1_1_2_1_1 + 1.333333333333329e-01*G3_1_1_2_2_1 + 1.333333333333329e-01*G3_1_1_3_0_2 + 1.333333333333329e-01*G3_1_1_3_1_2 + 1.333333333333329e-01*G3_1_1_3_2_2 - 6.666666666666647e-02*G3_1_2_0_0_0 - 6.666666666666647e-02*G3_1_2_0_0_1 - 6.666666666666647e-02*G3_1_2_0_0_2 - 6.666666666666647e-02*G3_1_2_0_1_0 - 6.666666666666649e-02*G3_1_2_0_1_1 - 6.666666666666649e-02*G3_1_2_0_1_2 - 6.666666666666647e-02*G3_1_2_0_2_0 - 6.666666666666649e-02*G3_1_2_0_2_1 - 6.666666666666649e-02*G3_1_2_0_2_2 + 6.666666666666647e-02*G3_1_2_1_0_0 + 6.666666666666647e-02*G3_1_2_1_1_0 + 6.666666666666647e-02*G3_1_2_1_2_0 + 6.666666666666647e-02*G3_1_2_2_0_1 + 6.666666666666649e-02*G3_1_2_2_1_1 + 6.666666666666649e-02*G3_1_2_2_2_1 + 6.666666666666647e-02*G3_1_2_3_0_2 + 6.666666666666649e-02*G3_1_2_3_1_2 + 6.666666666666649e-02*G3_1_2_3_2_2 - 6.666666666666649e-02*G3_1_3_0_0_0 - 6.666666666666649e-02*G3_1_3_0_0_1 - 6.666666666666650e-02*G3_1_3_0_0_2 - 6.666666666666649e-02*G3_1_3_0_1_0 - 6.666666666666650e-02*G3_1_3_0_1_1 - 6.666666666666650e-02*G3_1_3_0_1_2 - 6.666666666666650e-02*G3_1_3_0_2_0 - 6.666666666666650e-02*G3_1_3_0_2_1 - 6.666666666666650e-02*G3_1_3_0_2_2 + 6.666666666666649e-02*G3_1_3_1_0_0 + 6.666666666666649e-02*G3_1_3_1_1_0 + 6.666666666666650e-02*G3_1_3_1_2_0 + 6.666666666666649e-02*G3_1_3_2_0_1 + 6.666666666666650e-02*G3_1_3_2_1_1 + 6.666666666666650e-02*G3_1_3_2_2_1 + 6.666666666666649e-02*G3_1_3_3_0_2 + 6.666666666666650e-02*G3_1_3_3_1_2 + 6.666666666666650e-02*G3_1_3_3_2_2 - 6.666666666666643e-02*G3_2_0_0_0_0 - 6.666666666666644e-02*G3_2_0_0_0_1 - 6.666666666666646e-02*G3_2_0_0_0_2 - 6.666666666666644e-02*G3_2_0_0_1_0 - 6.666666666666646e-02*G3_2_0_0_1_1 - 6.666666666666646e-02*G3_2_0_0_1_2 - 6.666666666666646e-02*G3_2_0_0_2_0 - 6.666666666666646e-02*G3_2_0_0_2_1 - 6.666666666666647e-02*G3_2_0_0_2_2 + 6.666666666666643e-02*G3_2_0_1_0_0 + 6.666666666666644e-02*G3_2_0_1_1_0 + 6.666666666666646e-02*G3_2_0_1_2_0 + 6.666666666666644e-02*G3_2_0_2_0_1 + 6.666666666666646e-02*G3_2_0_2_1_1 + 6.666666666666646e-02*G3_2_0_2_2_1 + 6.666666666666644e-02*G3_2_0_3_0_2 + 6.666666666666646e-02*G3_2_0_3_1_2 + 6.666666666666646e-02*G3_2_0_3_2_2 - 6.666666666666647e-02*G3_2_1_0_0_0 - 6.666666666666647e-02*G3_2_1_0_0_1 - 6.666666666666647e-02*G3_2_1_0_0_2 - 6.666666666666647e-02*G3_2_1_0_1_0 - 6.666666666666649e-02*G3_2_1_0_1_1 - 6.666666666666649e-02*G3_2_1_0_1_2 - 6.666666666666647e-02*G3_2_1_0_2_0 - 6.666666666666649e-02*G3_2_1_0_2_1 - 6.666666666666649e-02*G3_2_1_0_2_2 + 6.666666666666647e-02*G3_2_1_1_0_0 + 6.666666666666647e-02*G3_2_1_1_1_0 + 6.666666666666647e-02*G3_2_1_1_2_0 + 6.666666666666647e-02*G3_2_1_2_0_1 + 6.666666666666649e-02*G3_2_1_2_1_1 + 6.666666666666649e-02*G3_2_1_2_2_1 + 6.666666666666647e-02*G3_2_1_3_0_2 + 6.666666666666649e-02*G3_2_1_3_1_2 + 6.666666666666649e-02*G3_2_1_3_2_2 - 1.333333333333329e-01*G3_2_2_0_0_0 - 1.333333333333329e-01*G3_2_2_0_0_1 - 1.333333333333329e-01*G3_2_2_0_0_2 - 1.333333333333329e-01*G3_2_2_0_1_0 - 1.333333333333330e-01*G3_2_2_0_1_1 - 1.333333333333330e-01*G3_2_2_0_1_2 - 1.333333333333329e-01*G3_2_2_0_2_0 - 1.333333333333330e-01*G3_2_2_0_2_1 - 1.333333333333330e-01*G3_2_2_0_2_2 + 1.333333333333329e-01*G3_2_2_1_0_0 + 1.333333333333329e-01*G3_2_2_1_1_0 + 1.333333333333329e-01*G3_2_2_1_2_0 + 1.333333333333329e-01*G3_2_2_2_0_1 + 1.333333333333330e-01*G3_2_2_2_1_1 + 1.333333333333330e-01*G3_2_2_2_2_1 + 1.333333333333329e-01*G3_2_2_3_0_2 + 1.333333333333330e-01*G3_2_2_3_1_2 + 1.333333333333330e-01*G3_2_2_3_2_2 - 6.666666666666647e-02*G3_2_3_0_0_0 - 6.666666666666649e-02*G3_2_3_0_0_1 - 6.666666666666649e-02*G3_2_3_0_0_2 - 6.666666666666649e-02*G3_2_3_0_1_0 - 6.666666666666650e-02*G3_2_3_0_1_1 - 6.666666666666651e-02*G3_2_3_0_1_2 - 6.666666666666649e-02*G3_2_3_0_2_0 - 6.666666666666651e-02*G3_2_3_0_2_1 - 6.666666666666651e-02*G3_2_3_0_2_2 + 6.666666666666647e-02*G3_2_3_1_0_0 + 6.666666666666649e-02*G3_2_3_1_1_0 + 6.666666666666649e-02*G3_2_3_1_2_0 + 6.666666666666649e-02*G3_2_3_2_0_1 + 6.666666666666650e-02*G3_2_3_2_1_1 + 6.666666666666651e-02*G3_2_3_2_2_1 + 6.666666666666649e-02*G3_2_3_3_0_2 + 6.666666666666650e-02*G3_2_3_3_1_2 + 6.666666666666651e-02*G3_2_3_3_2_2 - 6.666666666666647e-02*G3_3_0_0_0_0 - 6.666666666666649e-02*G3_3_0_0_0_1 - 6.666666666666649e-02*G3_3_0_0_0_2 - 6.666666666666649e-02*G3_3_0_0_1_0 - 6.666666666666650e-02*G3_3_0_0_1_1 - 6.666666666666651e-02*G3_3_0_0_1_2 - 6.666666666666649e-02*G3_3_0_0_2_0 - 6.666666666666651e-02*G3_3_0_0_2_1 - 6.666666666666651e-02*G3_3_0_0_2_2 + 6.666666666666647e-02*G3_3_0_1_0_0 + 6.666666666666649e-02*G3_3_0_1_1_0 + 6.666666666666649e-02*G3_3_0_1_2_0 + 6.666666666666649e-02*G3_3_0_2_0_1 + 6.666666666666650e-02*G3_3_0_2_1_1 + 6.666666666666651e-02*G3_3_0_2_2_1 + 6.666666666666649e-02*G3_3_0_3_0_2 + 6.666666666666650e-02*G3_3_0_3_1_2 + 6.666666666666651e-02*G3_3_0_3_2_2 - 6.666666666666649e-02*G3_3_1_0_0_0 - 6.666666666666649e-02*G3_3_1_0_0_1 - 6.666666666666650e-02*G3_3_1_0_0_2 - 6.666666666666649e-02*G3_3_1_0_1_0 - 6.666666666666650e-02*G3_3_1_0_1_1 - 6.666666666666650e-02*G3_3_1_0_1_2 - 6.666666666666650e-02*G3_3_1_0_2_0 - 6.666666666666650e-02*G3_3_1_0_2_1 - 6.666666666666650e-02*G3_3_1_0_2_2 + 6.666666666666649e-02*G3_3_1_1_0_0 + 6.666666666666649e-02*G3_3_1_1_1_0 + 6.666666666666650e-02*G3_3_1_1_2_0 + 6.666666666666649e-02*G3_3_1_2_0_1 + 6.666666666666650e-02*G3_3_1_2_1_1 + 6.666666666666650e-02*G3_3_1_2_2_1 + 6.666666666666649e-02*G3_3_1_3_0_2 + 6.666666666666650e-02*G3_3_1_3_1_2 + 6.666666666666650e-02*G3_3_1_3_2_2 - 6.666666666666647e-02*G3_3_2_0_0_0 - 6.666666666666649e-02*G3_3_2_0_0_1 - 6.666666666666649e-02*G3_3_2_0_0_2 - 6.666666666666649e-02*G3_3_2_0_1_0 - 6.666666666666649e-02*G3_3_2_0_1_1 - 6.666666666666651e-02*G3_3_2_0_1_2 - 6.666666666666649e-02*G3_3_2_0_2_0 - 6.666666666666651e-02*G3_3_2_0_2_1 - 6.666666666666651e-02*G3_3_2_0_2_2 + 6.666666666666647e-02*G3_3_2_1_0_0 + 6.666666666666649e-02*G3_3_2_1_1_0 + 6.666666666666649e-02*G3_3_2_1_2_0 + 6.666666666666649e-02*G3_3_2_2_0_1 + 6.666666666666649e-02*G3_3_2_2_1_1 + 6.666666666666651e-02*G3_3_2_2_2_1 + 6.666666666666649e-02*G3_3_2_3_0_2 + 6.666666666666649e-02*G3_3_2_3_1_2 + 6.666666666666651e-02*G3_3_2_3_2_2 - 1.333333333333329e-01*G3_3_3_0_0_0 - 1.333333333333329e-01*G3_3_3_0_0_1 - 1.333333333333330e-01*G3_3_3_0_0_2 - 1.333333333333329e-01*G3_3_3_0_1_0 - 1.333333333333330e-01*G3_3_3_0_1_1 - 1.333333333333330e-01*G3_3_3_0_1_2 - 1.333333333333330e-01*G3_3_3_0_2_0 - 1.333333333333330e-01*G3_3_3_0_2_1 - 1.333333333333330e-01*G3_3_3_0_2_2 + 1.333333333333329e-01*G3_3_3_1_0_0 + 1.333333333333329e-01*G3_3_3_1_1_0 + 1.333333333333330e-01*G3_3_3_1_2_0 + 1.333333333333329e-01*G3_3_3_2_0_1 + 1.333333333333330e-01*G3_3_3_2_1_1 + 1.333333333333330e-01*G3_3_3_2_2_1 + 1.333333333333329e-01*G3_3_3_3_0_2 + 1.333333333333330e-01*G3_3_3_3_1_2 + 1.333333333333330e-01*G3_3_3_3_2_2 + 3.333333333333328e-01*G4_0_0_0_0 + 3.333333333333329e-01*G4_0_0_0_1 + 3.333333333333329e-01*G4_0_0_0_2 + 3.333333333333329e-01*G4_0_0_1_0 + 3.333333333333329e-01*G4_0_0_1_1 + 3.333333333333329e-01*G4_0_0_1_2 + 3.333333333333329e-01*G4_0_0_2_0 + 3.333333333333329e-01*G4_0_0_2_1 + 3.333333333333329e-01*G4_0_0_2_2 - 3.333333333333328e-01*G4_0_1_0_0 - 3.333333333333329e-01*G4_0_1_1_0 - 3.333333333333329e-01*G4_0_1_2_0 - 3.333333333333329e-01*G4_0_2_0_1 - 3.333333333333329e-01*G4_0_2_1_1 - 3.333333333333329e-01*G4_0_2_2_1 - 3.333333333333329e-01*G4_0_3_0_2 - 3.333333333333329e-01*G4_0_3_1_2 - 3.333333333333329e-01*G4_0_3_2_2 + 3.333333333333328e-01*G4_1_0_0_0 + 3.333333333333329e-01*G4_1_0_0_1 + 3.333333333333329e-01*G4_1_0_0_2 + 3.333333333333329e-01*G4_1_0_1_0 + 3.333333333333329e-01*G4_1_0_1_1 + 3.333333333333329e-01*G4_1_0_1_2 + 3.333333333333329e-01*G4_1_0_2_0 + 3.333333333333329e-01*G4_1_0_2_1 + 3.333333333333329e-01*G4_1_0_2_2 - 3.333333333333328e-01*G4_1_1_0_0 - 3.333333333333329e-01*G4_1_1_1_0 - 3.333333333333329e-01*G4_1_1_2_0 - 3.333333333333329e-01*G4_1_2_0_1 - 3.333333333333329e-01*G4_1_2_1_1 - 3.333333333333329e-01*G4_1_2_2_1 - 3.333333333333329e-01*G4_1_3_0_2 - 3.333333333333329e-01*G4_1_3_1_2 - 3.333333333333329e-01*G4_1_3_2_2 + 3.333333333333328e-01*G4_2_0_0_0 + 3.333333333333329e-01*G4_2_0_0_1 + 3.333333333333329e-01*G4_2_0_0_2 + 3.333333333333329e-01*G4_2_0_1_0 + 3.333333333333329e-01*G4_2_0_1_1 + 3.333333333333329e-01*G4_2_0_1_2 + 3.333333333333329e-01*G4_2_0_2_0 + 3.333333333333329e-01*G4_2_0_2_1 + 3.333333333333329e-01*G4_2_0_2_2 - 3.333333333333328e-01*G4_2_1_0_0 - 3.333333333333329e-01*G4_2_1_1_0 - 3.333333333333329e-01*G4_2_1_2_0 - 3.333333333333329e-01*G4_2_2_0_1 - 3.333333333333329e-01*G4_2_2_1_1 - 3.333333333333329e-01*G4_2_2_2_1 - 3.333333333333329e-01*G4_2_3_0_2 - 3.333333333333329e-01*G4_2_3_1_2 - 3.333333333333329e-01*G4_2_3_2_2 + 3.333333333333328e-01*G4_3_0_0_0 + 3.333333333333329e-01*G4_3_0_0_1 + 3.333333333333329e-01*G4_3_0_0_2 + 3.333333333333329e-01*G4_3_0_1_0 + 3.333333333333329e-01*G4_3_0_1_1 + 3.333333333333329e-01*G4_3_0_1_2 + 3.333333333333329e-01*G4_3_0_2_0 + 3.333333333333329e-01*G4_3_0_2_1 + 3.333333333333329e-01*G4_3_0_2_2 - 3.333333333333328e-01*G4_3_1_0_0 - 3.333333333333329e-01*G4_3_1_1_0 - 3.333333333333329e-01*G4_3_1_2_0 - 3.333333333333329e-01*G4_3_2_0_1 - 3.333333333333329e-01*G4_3_2_1_1 - 3.333333333333329e-01*G4_3_2_2_1 - 3.333333333333329e-01*G4_3_3_0_2 - 3.333333333333329e-01*G4_3_3_1_2 - 3.333333333333329e-01*G4_3_3_2_2 + 1.666666666666664e-01*G5_4_0_0 + 1.666666666666664e-01*G5_4_0_1 + 1.666666666666664e-01*G5_4_0_2 + 1.666666666666664e-01*G5_4_1_0 + 1.666666666666665e-01*G5_4_1_1 + 1.666666666666665e-01*G5_4_1_2 + 1.666666666666664e-01*G5_4_2_0 + 1.666666666666665e-01*G5_4_2_1 + 1.666666666666665e-01*G5_4_2_2 - 1.666666666666664e-01*G5_5_0_0 - 1.666666666666664e-01*G5_5_1_0 - 1.666666666666664e-01*G5_5_2_0 - 1.666666666666664e-01*G5_6_0_1 - 1.666666666666665e-01*G5_6_1_1 - 1.666666666666665e-01*G5_6_2_1 - 1.666666666666664e-01*G5_7_0_2 - 1.666666666666665e-01*G5_7_1_2 - 1.666666666666665e-01*G5_7_2_2 - 1.666666666666662e-02*G6_0 - 8.333333333333309e-03*G6_1 - 8.333333333333307e-03*G6_2 - 8.333333333333312e-03*G6_3 + 1.666666666666662e-02*G7_0 + 8.333333333333309e-03*G7_1 + 8.333333333333307e-03*G7_2 + 8.333333333333312e-03*G7_3 - 1.666666666666662e-02*G8_0 - 8.333333333333309e-03*G8_1 - 8.333333333333307e-03*G8_2 - 8.333333333333312e-03*G8_3;
    block[1] = 3.333333333333323e-02*G0_0_0_0_0_0 + 3.333333333333324e-02*G0_0_0_0_0_1 + 3.333333333333324e-02*G0_0_0_0_0_2 - 3.333333333333323e-02*G0_0_0_1_0_0 - 3.333333333333324e-02*G0_0_0_2_0_1 - 3.333333333333324e-02*G0_0_0_3_0_2 + 1.666666666666661e-02*G0_0_1_0_0_0 + 1.666666666666661e-02*G0_0_1_0_0_1 + 1.666666666666662e-02*G0_0_1_0_0_2 - 1.666666666666661e-02*G0_0_1_1_0_0 - 1.666666666666661e-02*G0_0_1_2_0_1 - 1.666666666666661e-02*G0_0_1_3_0_2 + 1.666666666666661e-02*G0_0_2_0_0_0 + 1.666666666666661e-02*G0_0_2_0_0_1 + 1.666666666666661e-02*G0_0_2_0_0_2 - 1.666666666666661e-02*G0_0_2_1_0_0 - 1.666666666666661e-02*G0_0_2_2_0_1 - 1.666666666666661e-02*G0_0_2_3_0_2 + 1.666666666666661e-02*G0_0_3_0_0_0 + 1.666666666666662e-02*G0_0_3_0_0_1 + 1.666666666666662e-02*G0_0_3_0_0_2 - 1.666666666666661e-02*G0_0_3_1_0_0 - 1.666666666666662e-02*G0_0_3_2_0_1 - 1.666666666666662e-02*G0_0_3_3_0_2 + 1.666666666666661e-02*G0_1_0_0_0_0 + 1.666666666666661e-02*G0_1_0_0_0_1 + 1.666666666666662e-02*G0_1_0_0_0_2 - 1.666666666666661e-02*G0_1_0_1_0_0 - 1.666666666666661e-02*G0_1_0_2_0_1 - 1.666666666666661e-02*G0_1_0_3_0_2 + 3.333333333333323e-02*G0_1_1_0_0_0 + 3.333333333333323e-02*G0_1_1_0_0_1 + 3.333333333333323e-02*G0_1_1_0_0_2 - 3.333333333333323e-02*G0_1_1_1_0_0 - 3.333333333333323e-02*G0_1_1_2_0_1 - 3.333333333333323e-02*G0_1_1_3_0_2 + 1.666666666666662e-02*G0_1_2_0_0_0 + 1.666666666666662e-02*G0_1_2_0_0_1 + 1.666666666666662e-02*G0_1_2_0_0_2 - 1.666666666666662e-02*G0_1_2_1_0_0 - 1.666666666666662e-02*G0_1_2_2_0_1 - 1.666666666666662e-02*G0_1_2_3_0_2 + 1.666666666666662e-02*G0_1_3_0_0_0 + 1.666666666666662e-02*G0_1_3_0_0_1 + 1.666666666666662e-02*G0_1_3_0_0_2 - 1.666666666666662e-02*G0_1_3_1_0_0 - 1.666666666666662e-02*G0_1_3_2_0_1 - 1.666666666666662e-02*G0_1_3_3_0_2 + 1.666666666666661e-02*G0_2_0_0_0_0 + 1.666666666666661e-02*G0_2_0_0_0_1 + 1.666666666666661e-02*G0_2_0_0_0_2 - 1.666666666666661e-02*G0_2_0_1_0_0 - 1.666666666666661e-02*G0_2_0_2_0_1 - 1.666666666666661e-02*G0_2_0_3_0_2 + 1.666666666666662e-02*G0_2_1_0_0_0 + 1.666666666666662e-02*G0_2_1_0_0_1 + 1.666666666666662e-02*G0_2_1_0_0_2 - 1.666666666666662e-02*G0_2_1_1_0_0 - 1.666666666666662e-02*G0_2_1_2_0_1 - 1.666666666666662e-02*G0_2_1_3_0_2 + 3.333333333333323e-02*G0_2_2_0_0_0 + 3.333333333333324e-02*G0_2_2_0_0_1 + 3.333333333333324e-02*G0_2_2_0_0_2 - 3.333333333333323e-02*G0_2_2_1_0_0 - 3.333333333333324e-02*G0_2_2_2_0_1 - 3.333333333333324e-02*G0_2_2_3_0_2 + 1.666666666666662e-02*G0_2_3_0_0_0 + 1.666666666666662e-02*G0_2_3_0_0_1 + 1.666666666666662e-02*G0_2_3_0_0_2 - 1.666666666666662e-02*G0_2_3_1_0_0 - 1.666666666666662e-02*G0_2_3_2_0_1 - 1.666666666666662e-02*G0_2_3_3_0_2 + 1.666666666666662e-02*G0_3_0_0_0_0 + 1.666666666666662e-02*G0_3_0_0_0_1 + 1.666666666666662e-02*G0_3_0_0_0_2 - 1.666666666666662e-02*G0_3_0_1_0_0 - 1.666666666666662e-02*G0_3_0_2_0_1 - 1.666666666666662e-02*G0_3_0_3_0_2 + 1.666666666666662e-02*G0_3_1_0_0_0 + 1.666666666666662e-02*G0_3_1_0_0_1 + 1.666666666666662e-02*G0_3_1_0_0_2 - 1.666666666666662e-02*G0_3_1_1_0_0 - 1.666666666666662e-02*G0_3_1_2_0_1 - 1.666666666666662e-02*G0_3_1_3_0_2 + 1.666666666666662e-02*G0_3_2_0_0_0 + 1.666666666666662e-02*G0_3_2_0_0_1 + 1.666666666666662e-02*G0_3_2_0_0_2 - 1.666666666666662e-02*G0_3_2_1_0_0 - 1.666666666666662e-02*G0_3_2_2_0_1 - 1.666666666666662e-02*G0_3_2_3_0_2 + 3.333333333333323e-02*G0_3_3_0_0_0 + 3.333333333333324e-02*G0_3_3_0_0_1 + 3.333333333333324e-02*G0_3_3_0_0_2 - 3.333333333333323e-02*G0_3_3_1_0_0 - 3.333333333333324e-02*G0_3_3_2_0_1 - 3.333333333333324e-02*G0_3_3_3_0_2 - 8.333333333333320e-02*G1_0_0_0_0 - 8.333333333333322e-02*G1_0_0_0_1 - 8.333333333333322e-02*G1_0_0_0_2 + 8.333333333333320e-02*G1_0_1_0_0 + 8.333333333333322e-02*G1_0_2_0_1 + 8.333333333333322e-02*G1_0_3_0_2 - 8.333333333333320e-02*G1_1_0_0_0 - 8.333333333333322e-02*G1_1_0_0_1 - 8.333333333333322e-02*G1_1_0_0_2 + 8.333333333333320e-02*G1_1_1_0_0 + 8.333333333333322e-02*G1_1_2_0_1 + 8.333333333333322e-02*G1_1_3_0_2 - 8.333333333333320e-02*G1_2_0_0_0 - 8.333333333333322e-02*G1_2_0_0_1 - 8.333333333333322e-02*G1_2_0_0_2 + 8.333333333333320e-02*G1_2_1_0_0 + 8.333333333333322e-02*G1_2_2_0_1 + 8.333333333333322e-02*G1_2_3_0_2 - 8.333333333333320e-02*G1_3_0_0_0 - 8.333333333333322e-02*G1_3_0_0_1 - 8.333333333333322e-02*G1_3_0_0_2 + 8.333333333333320e-02*G1_3_1_0_0 + 8.333333333333322e-02*G1_3_2_0_1 + 8.333333333333322e-02*G1_3_3_0_2 + 3.333333333333328e-01*G2_0_0_0 + 3.333333333333329e-01*G2_0_0_1 + 3.333333333333329e-01*G2_0_0_2 - 3.333333333333328e-01*G2_1_0_0 - 3.333333333333329e-01*G2_2_0_1 - 3.333333333333329e-01*G2_3_0_2 + 1.333333333333329e-01*G3_0_0_0_0_0 + 1.333333333333329e-01*G3_0_0_0_0_1 + 1.333333333333330e-01*G3_0_0_0_0_2 - 1.333333333333329e-01*G3_0_0_1_0_0 - 1.333333333333329e-01*G3_0_0_2_0_1 - 1.333333333333329e-01*G3_0_0_3_0_2 + 6.666666666666646e-02*G3_0_1_0_0_0 + 6.666666666666646e-02*G3_0_1_0_0_1 + 6.666666666666647e-02*G3_0_1_0_0_2 - 6.666666666666646e-02*G3_0_1_1_0_0 - 6.666666666666646e-02*G3_0_1_2_0_1 - 6.666666666666646e-02*G3_0_1_3_0_2 + 6.666666666666644e-02*G3_0_2_0_0_0 + 6.666666666666644e-02*G3_0_2_0_0_1 + 6.666666666666646e-02*G3_0_2_0_0_2 - 6.666666666666644e-02*G3_0_2_1_0_0 - 6.666666666666644e-02*G3_0_2_2_0_1 - 6.666666666666644e-02*G3_0_2_3_0_2 + 6.666666666666644e-02*G3_0_3_0_0_0 + 6.666666666666647e-02*G3_0_3_0_0_1 + 6.666666666666647e-02*G3_0_3_0_0_2 - 6.666666666666644e-02*G3_0_3_1_0_0 - 6.666666666666647e-02*G3_0_3_2_0_1 - 6.666666666666647e-02*G3_0_3_3_0_2 + 6.666666666666646e-02*G3_1_0_0_0_0 + 6.666666666666646e-02*G3_1_0_0_0_1 + 6.666666666666647e-02*G3_1_0_0_0_2 - 6.666666666666646e-02*G3_1_0_1_0_0 - 6.666666666666646e-02*G3_1_0_2_0_1 - 6.666666666666646e-02*G3_1_0_3_0_2 + 1.333333333333329e-01*G3_1_1_0_0_0 + 1.333333333333329e-01*G3_1_1_0_0_1 + 1.333333333333329e-01*G3_1_1_0_0_2 - 1.333333333333329e-01*G3_1_1_1_0_0 - 1.333333333333329e-01*G3_1_1_2_0_1 - 1.333333333333329e-01*G3_1_1_3_0_2 + 6.666666666666647e-02*G3_1_2_0_0_0 + 6.666666666666647e-02*G3_1_2_0_0_1 + 6.666666666666647e-02*G3_1_2_0_0_2 - 6.666666666666647e-02*G3_1_2_1_0_0 - 6.666666666666647e-02*G3_1_2_2_0_1 - 6.666666666666647e-02*G3_1_2_3_0_2 + 6.666666666666649e-02*G3_1_3_0_0_0 + 6.666666666666649e-02*G3_1_3_0_0_1 + 6.666666666666650e-02*G3_1_3_0_0_2 - 6.666666666666649e-02*G3_1_3_1_0_0 - 6.666666666666649e-02*G3_1_3_2_0_1 - 6.666666666666649e-02*G3_1_3_3_0_2 + 6.666666666666643e-02*G3_2_0_0_0_0 + 6.666666666666644e-02*G3_2_0_0_0_1 + 6.666666666666646e-02*G3_2_0_0_0_2 - 6.666666666666643e-02*G3_2_0_1_0_0 - 6.666666666666644e-02*G3_2_0_2_0_1 - 6.666666666666644e-02*G3_2_0_3_0_2 + 6.666666666666647e-02*G3_2_1_0_0_0 + 6.666666666666647e-02*G3_2_1_0_0_1 + 6.666666666666647e-02*G3_2_1_0_0_2 - 6.666666666666647e-02*G3_2_1_1_0_0 - 6.666666666666647e-02*G3_2_1_2_0_1 - 6.666666666666647e-02*G3_2_1_3_0_2 + 1.333333333333329e-01*G3_2_2_0_0_0 + 1.333333333333329e-01*G3_2_2_0_0_1 + 1.333333333333329e-01*G3_2_2_0_0_2 - 1.333333333333329e-01*G3_2_2_1_0_0 - 1.333333333333329e-01*G3_2_2_2_0_1 - 1.333333333333329e-01*G3_2_2_3_0_2 + 6.666666666666647e-02*G3_2_3_0_0_0 + 6.666666666666649e-02*G3_2_3_0_0_1 + 6.666666666666649e-02*G3_2_3_0_0_2 - 6.666666666666647e-02*G3_2_3_1_0_0 - 6.666666666666649e-02*G3_2_3_2_0_1 - 6.666666666666649e-02*G3_2_3_3_0_2 + 6.666666666666647e-02*G3_3_0_0_0_0 + 6.666666666666649e-02*G3_3_0_0_0_1 + 6.666666666666649e-02*G3_3_0_0_0_2 - 6.666666666666647e-02*G3_3_0_1_0_0 - 6.666666666666649e-02*G3_3_0_2_0_1 - 6.666666666666649e-02*G3_3_0_3_0_2 + 6.666666666666649e-02*G3_3_1_0_0_0 + 6.666666666666649e-02*G3_3_1_0_0_1 + 6.666666666666650e-02*G3_3_1_0_0_2 - 6.666666666666649e-02*G3_3_1_1_0_0 - 6.666666666666649e-02*G3_3_1_2_0_1 - 6.666666666666649e-02*G3_3_1_3_0_2 + 6.666666666666647e-02*G3_3_2_0_0_0 + 6.666666666666649e-02*G3_3_2_0_0_1 + 6.666666666666649e-02*G3_3_2_0_0_2 - 6.666666666666647e-02*G3_3_2_1_0_0 - 6.666666666666649e-02*G3_3_2_2_0_1 - 6.666666666666649e-02*G3_3_2_3_0_2 + 1.333333333333329e-01*G3_3_3_0_0_0 + 1.333333333333329e-01*G3_3_3_0_0_1 + 1.333333333333330e-01*G3_3_3_0_0_2 - 1.333333333333329e-01*G3_3_3_1_0_0 - 1.333333333333329e-01*G3_3_3_2_0_1 - 1.333333333333329e-01*G3_3_3_3_0_2 - 3.333333333333328e-01*G4_0_0_0_0 - 3.333333333333329e-01*G4_0_0_0_1 - 3.333333333333329e-01*G4_0_0_0_2 + 3.333333333333328e-01*G4_0_1_0_0 + 3.333333333333329e-01*G4_0_2_0_1 + 3.333333333333329e-01*G4_0_3_0_2 - 3.333333333333328e-01*G4_1_0_0_0 - 3.333333333333329e-01*G4_1_0_0_1 - 3.333333333333329e-01*G4_1_0_0_2 + 3.333333333333328e-01*G4_1_1_0_0 + 3.333333333333329e-01*G4_1_2_0_1 + 3.333333333333329e-01*G4_1_3_0_2 - 3.333333333333328e-01*G4_2_0_0_0 - 3.333333333333329e-01*G4_2_0_0_1 - 3.333333333333329e-01*G4_2_0_0_2 + 3.333333333333328e-01*G4_2_1_0_0 + 3.333333333333329e-01*G4_2_2_0_1 + 3.333333333333329e-01*G4_2_3_0_2 - 3.333333333333328e-01*G4_3_0_0_0 - 3.333333333333329e-01*G4_3_0_0_1 - 3.333333333333329e-01*G4_3_0_0_2 + 3.333333333333328e-01*G4_3_1_0_0 + 3.333333333333329e-01*G4_3_2_0_1 + 3.333333333333329e-01*G4_3_3_0_2 - 1.666666666666664e-01*G5_4_0_0 - 1.666666666666664e-01*G5_4_0_1 - 1.666666666666664e-01*G5_4_0_2 + 1.666666666666664e-01*G5_5_0_0 + 1.666666666666664e-01*G5_6_0_1 + 1.666666666666664e-01*G5_7_0_2 - 8.333333333333309e-03*G6_0 - 1.666666666666662e-02*G6_1 - 8.333333333333311e-03*G6_2 - 8.333333333333312e-03*G6_3 + 8.333333333333309e-03*G7_0 + 1.666666666666662e-02*G7_1 + 8.333333333333311e-03*G7_2 + 8.333333333333312e-03*G7_3 - 8.333333333333309e-03*G8_0 - 1.666666666666662e-02*G8_1 - 8.333333333333311e-03*G8_2 - 8.333333333333312e-03*G8_3;
    block[2] = 3.333333333333324e-02*G0_0_0_0_1_0 + 3.333333333333324e-02*G0_0_0_0_1_1 + 3.333333333333324e-02*G0_0_0_0_1_2 - 3.333333333333324e-02*G0_0_0_1_1_0 - 3.333333333333324e-02*G0_0_0_2_1_1 - 3.333333333333324e-02*G0_0_0_3_1_2 + 1.666666666666661e-02*G0_0_1_0_1_0 + 1.666666666666662e-02*G0_0_1_0_1_1 + 1.666666666666662e-02*G0_0_1_0_1_2 - 1.666666666666661e-02*G0_0_1_1_1_0 - 1.666666666666662e-02*G0_0_1_2_1_1 - 1.666666666666662e-02*G0_0_1_3_1_2 + 1.666666666666661e-02*G0_0_2_0_1_0 + 1.666666666666661e-02*G0_0_2_0_1_1 + 1.666666666666662e-02*G0_0_2_0_1_2 - 1.666666666666661e-02*G0_0_2_1_1_0 - 1.666666666666661e-02*G0_0_2_2_1_1 - 1.666666666666661e-02*G0_0_2_3_1_2 + 1.666666666666662e-02*G0_0_3_0_1_0 + 1.666666666666662e-02*G0_0_3_0_1_1 + 1.666666666666663e-02*G0_0_3_0_1_2 - 1.666666666666662e-02*G0_0_3_1_1_0 - 1.666666666666662e-02*G0_0_3_2_1_1 - 1.666666666666662e-02*G0_0_3_3_1_2 + 1.666666666666661e-02*G0_1_0_0_1_0 + 1.666666666666662e-02*G0_1_0_0_1_1 + 1.666666666666662e-02*G0_1_0_0_1_2 - 1.666666666666661e-02*G0_1_0_1_1_0 - 1.666666666666662e-02*G0_1_0_2_1_1 - 1.666666666666662e-02*G0_1_0_3_1_2 + 3.333333333333323e-02*G0_1_1_0_1_0 + 3.333333333333324e-02*G0_1_1_0_1_1 + 3.333333333333324e-02*G0_1_1_0_1_2 - 3.333333333333323e-02*G0_1_1_1_1_0 - 3.333333333333324e-02*G0_1_1_2_1_1 - 3.333333333333324e-02*G0_1_1_3_1_2 + 1.666666666666662e-02*G0_1_2_0_1_0 + 1.666666666666662e-02*G0_1_2_0_1_1 + 1.666666666666662e-02*G0_1_2_0_1_2 - 1.666666666666662e-02*G0_1_2_1_1_0 - 1.666666666666662e-02*G0_1_2_2_1_1 - 1.666666666666662e-02*G0_1_2_3_1_2 + 1.666666666666662e-02*G0_1_3_0_1_0 + 1.666666666666662e-02*G0_1_3_0_1_1 + 1.666666666666662e-02*G0_1_3_0_1_2 - 1.666666666666662e-02*G0_1_3_1_1_0 - 1.666666666666662e-02*G0_1_3_2_1_1 - 1.666666666666662e-02*G0_1_3_3_1_2 + 1.666666666666661e-02*G0_2_0_0_1_0 + 1.666666666666661e-02*G0_2_0_0_1_1 + 1.666666666666661e-02*G0_2_0_0_1_2 - 1.666666666666661e-02*G0_2_0_1_1_0 - 1.666666666666661e-02*G0_2_0_2_1_1 - 1.666666666666661e-02*G0_2_0_3_1_2 + 1.666666666666662e-02*G0_2_1_0_1_0 + 1.666666666666662e-02*G0_2_1_0_1_1 + 1.666666666666662e-02*G0_2_1_0_1_2 - 1.666666666666662e-02*G0_2_1_1_1_0 - 1.666666666666662e-02*G0_2_1_2_1_1 - 1.666666666666662e-02*G0_2_1_3_1_2 + 3.333333333333324e-02*G0_2_2_0_1_0 + 3.333333333333324e-02*G0_2_2_0_1_1 + 3.333333333333324e-02*G0_2_2_0_1_2 - 3.333333333333324e-02*G0_2_2_1_1_0 - 3.333333333333324e-02*G0_2_2_2_1_1 - 3.333333333333324e-02*G0_2_2_3_1_2 + 1.666666666666662e-02*G0_2_3_0_1_0 + 1.666666666666662e-02*G0_2_3_0_1_1 + 1.666666666666663e-02*G0_2_3_0_1_2 - 1.666666666666662e-02*G0_2_3_1_1_0 - 1.666666666666662e-02*G0_2_3_2_1_1 - 1.666666666666662e-02*G0_2_3_3_1_2 + 1.666666666666662e-02*G0_3_0_0_1_0 + 1.666666666666662e-02*G0_3_0_0_1_1 + 1.666666666666663e-02*G0_3_0_0_1_2 - 1.666666666666662e-02*G0_3_0_1_1_0 - 1.666666666666662e-02*G0_3_0_2_1_1 - 1.666666666666662e-02*G0_3_0_3_1_2 + 1.666666666666662e-02*G0_3_1_0_1_0 + 1.666666666666662e-02*G0_3_1_0_1_1 + 1.666666666666662e-02*G0_3_1_0_1_2 - 1.666666666666662e-02*G0_3_1_1_1_0 - 1.666666666666662e-02*G0_3_1_2_1_1 - 1.666666666666662e-02*G0_3_1_3_1_2 + 1.666666666666662e-02*G0_3_2_0_1_0 + 1.666666666666662e-02*G0_3_2_0_1_1 + 1.666666666666663e-02*G0_3_2_0_1_2 - 1.666666666666662e-02*G0_3_2_1_1_0 - 1.666666666666662e-02*G0_3_2_2_1_1 - 1.666666666666662e-02*G0_3_2_3_1_2 + 3.333333333333324e-02*G0_3_3_0_1_0 + 3.333333333333324e-02*G0_3_3_0_1_1 + 3.333333333333324e-02*G0_3_3_0_1_2 - 3.333333333333324e-02*G0_3_3_1_1_0 - 3.333333333333324e-02*G0_3_3_2_1_1 - 3.333333333333324e-02*G0_3_3_3_1_2 - 8.333333333333322e-02*G1_0_0_1_0 - 8.333333333333323e-02*G1_0_0_1_1 - 8.333333333333323e-02*G1_0_0_1_2 + 8.333333333333322e-02*G1_0_1_1_0 + 8.333333333333323e-02*G1_0_2_1_1 + 8.333333333333323e-02*G1_0_3_1_2 - 8.333333333333322e-02*G1_1_0_1_0 - 8.333333333333323e-02*G1_1_0_1_1 - 8.333333333333323e-02*G1_1_0_1_2 + 8.333333333333322e-02*G1_1_1_1_0 + 8.333333333333323e-02*G1_1_2_1_1 + 8.333333333333323e-02*G1_1_3_1_2 - 8.333333333333322e-02*G1_2_0_1_0 - 8.333333333333323e-02*G1_2_0_1_1 - 8.333333333333323e-02*G1_2_0_1_2 + 8.333333333333322e-02*G1_2_1_1_0 + 8.333333333333323e-02*G1_2_2_1_1 + 8.333333333333323e-02*G1_2_3_1_2 - 8.333333333333322e-02*G1_3_0_1_0 - 8.333333333333323e-02*G1_3_0_1_1 - 8.333333333333323e-02*G1_3_0_1_2 + 8.333333333333322e-02*G1_3_1_1_0 + 8.333333333333323e-02*G1_3_2_1_1 + 8.333333333333323e-02*G1_3_3_1_2 + 3.333333333333329e-01*G2_0_1_0 + 3.333333333333329e-01*G2_0_1_1 + 3.333333333333329e-01*G2_0_1_2 - 3.333333333333329e-01*G2_1_1_0 - 3.333333333333329e-01*G2_2_1_1 - 3.333333333333329e-01*G2_3_1_2 + 1.333333333333329e-01*G3_0_0_0_1_0 + 1.333333333333329e-01*G3_0_0_0_1_1 + 1.333333333333330e-01*G3_0_0_0_1_2 - 1.333333333333329e-01*G3_0_0_1_1_0 - 1.333333333333329e-01*G3_0_0_2_1_1 - 1.333333333333329e-01*G3_0_0_3_1_2 + 6.666666666666646e-02*G3_0_1_0_1_0 + 6.666666666666647e-02*G3_0_1_0_1_1 + 6.666666666666647e-02*G3_0_1_0_1_2 - 6.666666666666646e-02*G3_0_1_1_1_0 - 6.666666666666647e-02*G3_0_1_2_1_1 - 6.666666666666647e-02*G3_0_1_3_1_2 + 6.666666666666644e-02*G3_0_2_0_1_0 + 6.666666666666646e-02*G3_0_2_0_1_1 + 6.666666666666647e-02*G3_0_2_0_1_2 - 6.666666666666644e-02*G3_0_2_1_1_0 - 6.666666666666646e-02*G3_0_2_2_1_1 - 6.666666666666646e-02*G3_0_2_3_1_2 + 6.666666666666647e-02*G3_0_3_0_1_0 + 6.666666666666650e-02*G3_0_3_0_1_1 + 6.666666666666651e-02*G3_0_3_0_1_2 - 6.666666666666647e-02*G3_0_3_1_1_0 - 6.666666666666650e-02*G3_0_3_2_1_1 - 6.666666666666650e-02*G3_0_3_3_1_2 + 6.666666666666646e-02*G3_1_0_0_1_0 + 6.666666666666647e-02*G3_1_0_0_1_1 + 6.666666666666647e-02*G3_1_0_0_1_2 - 6.666666666666646e-02*G3_1_0_1_1_0 - 6.666666666666647e-02*G3_1_0_2_1_1 - 6.666666666666647e-02*G3_1_0_3_1_2 + 1.333333333333329e-01*G3_1_1_0_1_0 + 1.333333333333329e-01*G3_1_1_0_1_1 + 1.333333333333329e-01*G3_1_1_0_1_2 - 1.333333333333329e-01*G3_1_1_1_1_0 - 1.333333333333329e-01*G3_1_1_2_1_1 - 1.333333333333329e-01*G3_1_1_3_1_2 + 6.666666666666647e-02*G3_1_2_0_1_0 + 6.666666666666649e-02*G3_1_2_0_1_1 + 6.666666666666649e-02*G3_1_2_0_1_2 - 6.666666666666647e-02*G3_1_2_1_1_0 - 6.666666666666649e-02*G3_1_2_2_1_1 - 6.666666666666649e-02*G3_1_2_3_1_2 + 6.666666666666649e-02*G3_1_3_0_1_0 + 6.666666666666650e-02*G3_1_3_0_1_1 + 6.666666666666650e-02*G3_1_3_0_1_2 - 6.666666666666649e-02*G3_1_3_1_1_0 - 6.666666666666650e-02*G3_1_3_2_1_1 - 6.666666666666650e-02*G3_1_3_3_1_2 + 6.666666666666644e-02*G3_2_0_0_1_0 + 6.666666666666646e-02*G3_2_0_0_1_1 + 6.666666666666646e-02*G3_2_0_0_1_2 - 6.666666666666644e-02*G3_2_0_1_1_0 - 6.666666666666646e-02*G3_2_0_2_1_1 - 6.666666666666646e-02*G3_2_0_3_1_2 + 6.666666666666647e-02*G3_2_1_0_1_0 + 6.666666666666649e-02*G3_2_1_0_1_1 + 6.666666666666649e-02*G3_2_1_0_1_2 - 6.666666666666647e-02*G3_2_1_1_1_0 - 6.666666666666649e-02*G3_2_1_2_1_1 - 6.666666666666649e-02*G3_2_1_3_1_2 + 1.333333333333329e-01*G3_2_2_0_1_0 + 1.333333333333330e-01*G3_2_2_0_1_1 + 1.333333333333330e-01*G3_2_2_0_1_2 - 1.333333333333329e-01*G3_2_2_1_1_0 - 1.333333333333330e-01*G3_2_2_2_1_1 - 1.333333333333330e-01*G3_2_2_3_1_2 + 6.666666666666649e-02*G3_2_3_0_1_0 + 6.666666666666650e-02*G3_2_3_0_1_1 + 6.666666666666651e-02*G3_2_3_0_1_2 - 6.666666666666649e-02*G3_2_3_1_1_0 - 6.666666666666650e-02*G3_2_3_2_1_1 - 6.666666666666650e-02*G3_2_3_3_1_2 + 6.666666666666649e-02*G3_3_0_0_1_0 + 6.666666666666650e-02*G3_3_0_0_1_1 + 6.666666666666651e-02*G3_3_0_0_1_2 - 6.666666666666649e-02*G3_3_0_1_1_0 - 6.666666666666650e-02*G3_3_0_2_1_1 - 6.666666666666650e-02*G3_3_0_3_1_2 + 6.666666666666649e-02*G3_3_1_0_1_0 + 6.666666666666650e-02*G3_3_1_0_1_1 + 6.666666666666650e-02*G3_3_1_0_1_2 - 6.666666666666649e-02*G3_3_1_1_1_0 - 6.666666666666650e-02*G3_3_1_2_1_1 - 6.666666666666650e-02*G3_3_1_3_1_2 + 6.666666666666649e-02*G3_3_2_0_1_0 + 6.666666666666649e-02*G3_3_2_0_1_1 + 6.666666666666651e-02*G3_3_2_0_1_2 - 6.666666666666649e-02*G3_3_2_1_1_0 - 6.666666666666649e-02*G3_3_2_2_1_1 - 6.666666666666649e-02*G3_3_2_3_1_2 + 1.333333333333329e-01*G3_3_3_0_1_0 + 1.333333333333330e-01*G3_3_3_0_1_1 + 1.333333333333330e-01*G3_3_3_0_1_2 - 1.333333333333329e-01*G3_3_3_1_1_0 - 1.333333333333330e-01*G3_3_3_2_1_1 - 1.333333333333330e-01*G3_3_3_3_1_2 - 3.333333333333329e-01*G4_0_0_1_0 - 3.333333333333329e-01*G4_0_0_1_1 - 3.333333333333329e-01*G4_0_0_1_2 + 3.333333333333329e-01*G4_0_1_1_0 + 3.333333333333329e-01*G4_0_2_1_1 + 3.333333333333329e-01*G4_0_3_1_2 - 3.333333333333329e-01*G4_1_0_1_0 - 3.333333333333329e-01*G4_1_0_1_1 - 3.333333333333329e-01*G4_1_0_1_2 + 3.333333333333329e-01*G4_1_1_1_0 + 3.333333333333329e-01*G4_1_2_1_1 + 3.333333333333329e-01*G4_1_3_1_2 - 3.333333333333329e-01*G4_2_0_1_0 - 3.333333333333329e-01*G4_2_0_1_1 - 3.333333333333329e-01*G4_2_0_1_2 + 3.333333333333329e-01*G4_2_1_1_0 + 3.333333333333329e-01*G4_2_2_1_1 + 3.333333333333329e-01*G4_2_3_1_2 - 3.333333333333329e-01*G4_3_0_1_0 - 3.333333333333329e-01*G4_3_0_1_1 - 3.333333333333329e-01*G4_3_0_1_2 + 3.333333333333329e-01*G4_3_1_1_0 + 3.333333333333329e-01*G4_3_2_1_1 + 3.333333333333329e-01*G4_3_3_1_2 - 1.666666666666664e-01*G5_4_1_0 - 1.666666666666665e-01*G5_4_1_1 - 1.666666666666665e-01*G5_4_1_2 + 1.666666666666664e-01*G5_5_1_0 + 1.666666666666665e-01*G5_6_1_1 + 1.666666666666665e-01*G5_7_1_2 - 8.333333333333307e-03*G6_0 - 8.333333333333311e-03*G6_1 - 1.666666666666662e-02*G6_2 - 8.333333333333312e-03*G6_3 + 8.333333333333307e-03*G7_0 + 8.333333333333311e-03*G7_1 + 1.666666666666662e-02*G7_2 + 8.333333333333312e-03*G7_3 - 8.333333333333307e-03*G8_0 - 8.333333333333311e-03*G8_1 - 1.666666666666662e-02*G8_2 - 8.333333333333312e-03*G8_3;
    block[3] = 3.333333333333324e-02*G0_0_0_0_2_0 + 3.333333333333324e-02*G0_0_0_0_2_1 + 3.333333333333324e-02*G0_0_0_0_2_2 - 3.333333333333324e-02*G0_0_0_1_2_0 - 3.333333333333324e-02*G0_0_0_2_2_1 - 3.333333333333324e-02*G0_0_0_3_2_2 + 1.666666666666661e-02*G0_0_1_0_2_0 + 1.666666666666662e-02*G0_0_1_0_2_1 + 1.666666666666662e-02*G0_0_1_0_2_2 - 1.666666666666661e-02*G0_0_1_1_2_0 - 1.666666666666662e-02*G0_0_1_2_2_1 - 1.666666666666662e-02*G0_0_1_3_2_2 + 1.666666666666661e-02*G0_0_2_0_2_0 + 1.666666666666661e-02*G0_0_2_0_2_1 + 1.666666666666662e-02*G0_0_2_0_2_2 - 1.666666666666661e-02*G0_0_2_1_2_0 - 1.666666666666661e-02*G0_0_2_2_2_1 - 1.666666666666661e-02*G0_0_2_3_2_2 + 1.666666666666662e-02*G0_0_3_0_2_0 + 1.666666666666662e-02*G0_0_3_0_2_1 + 1.666666666666663e-02*G0_0_3_0_2_2 - 1.666666666666662e-02*G0_0_3_1_2_0 - 1.666666666666662e-02*G0_0_3_2_2_1 - 1.666666666666662e-02*G0_0_3_3_2_2 + 1.666666666666661e-02*G0_1_0_0_2_0 + 1.666666666666662e-02*G0_1_0_0_2_1 + 1.666666666666662e-02*G0_1_0_0_2_2 - 1.666666666666661e-02*G0_1_0_1_2_0 - 1.666666666666662e-02*G0_1_0_2_2_1 - 1.666666666666662e-02*G0_1_0_3_2_2 + 3.333333333333323e-02*G0_1_1_0_2_0 + 3.333333333333324e-02*G0_1_1_0_2_1 + 3.333333333333324e-02*G0_1_1_0_2_2 - 3.333333333333323e-02*G0_1_1_1_2_0 - 3.333333333333324e-02*G0_1_1_2_2_1 - 3.333333333333324e-02*G0_1_1_3_2_2 + 1.666666666666662e-02*G0_1_2_0_2_0 + 1.666666666666662e-02*G0_1_2_0_2_1 + 1.666666666666662e-02*G0_1_2_0_2_2 - 1.666666666666662e-02*G0_1_2_1_2_0 - 1.666666666666662e-02*G0_1_2_2_2_1 - 1.666666666666662e-02*G0_1_2_3_2_2 + 1.666666666666662e-02*G0_1_3_0_2_0 + 1.666666666666662e-02*G0_1_3_0_2_1 + 1.666666666666662e-02*G0_1_3_0_2_2 - 1.666666666666662e-02*G0_1_3_1_2_0 - 1.666666666666662e-02*G0_1_3_2_2_1 - 1.666666666666662e-02*G0_1_3_3_2_2 + 1.666666666666661e-02*G0_2_0_0_2_0 + 1.666666666666661e-02*G0_2_0_0_2_1 + 1.666666666666661e-02*G0_2_0_0_2_2 - 1.666666666666661e-02*G0_2_0_1_2_0 - 1.666666666666661e-02*G0_2_0_2_2_1 - 1.666666666666661e-02*G0_2_0_3_2_2 + 1.666666666666662e-02*G0_2_1_0_2_0 + 1.666666666666662e-02*G0_2_1_0_2_1 + 1.666666666666662e-02*G0_2_1_0_2_2 - 1.666666666666662e-02*G0_2_1_1_2_0 - 1.666666666666662e-02*G0_2_1_2_2_1 - 1.666666666666662e-02*G0_2_1_3_2_2 + 3.333333333333324e-02*G0_2_2_0_2_0 + 3.333333333333324e-02*G0_2_2_0_2_1 + 3.333333333333324e-02*G0_2_2_0_2_2 - 3.333333333333324e-02*G0_2_2_1_2_0 - 3.333333333333324e-02*G0_2_2_2_2_1 - 3.333333333333324e-02*G0_2_2_3_2_2 + 1.666666666666662e-02*G0_2_3_0_2_0 + 1.666666666666662e-02*G0_2_3_0_2_1 + 1.666666666666663e-02*G0_2_3_0_2_2 - 1.666666666666662e-02*G0_2_3_1_2_0 - 1.666666666666662e-02*G0_2_3_2_2_1 - 1.666666666666662e-02*G0_2_3_3_2_2 + 1.666666666666662e-02*G0_3_0_0_2_0 + 1.666666666666662e-02*G0_3_0_0_2_1 + 1.666666666666663e-02*G0_3_0_0_2_2 - 1.666666666666662e-02*G0_3_0_1_2_0 - 1.666666666666662e-02*G0_3_0_2_2_1 - 1.666666666666662e-02*G0_3_0_3_2_2 + 1.666666666666662e-02*G0_3_1_0_2_0 + 1.666666666666662e-02*G0_3_1_0_2_1 + 1.666666666666662e-02*G0_3_1_0_2_2 - 1.666666666666662e-02*G0_3_1_1_2_0 - 1.666666666666662e-02*G0_3_1_2_2_1 - 1.666666666666662e-02*G0_3_1_3_2_2 + 1.666666666666662e-02*G0_3_2_0_2_0 + 1.666666666666662e-02*G0_3_2_0_2_1 + 1.666666666666663e-02*G0_3_2_0_2_2 - 1.666666666666662e-02*G0_3_2_1_2_0 - 1.666666666666662e-02*G0_3_2_2_2_1 - 1.666666666666662e-02*G0_3_2_3_2_2 + 3.333333333333324e-02*G0_3_3_0_2_0 + 3.333333333333324e-02*G0_3_3_0_2_1 + 3.333333333333324e-02*G0_3_3_0_2_2 - 3.333333333333324e-02*G0_3_3_1_2_0 - 3.333333333333324e-02*G0_3_3_2_2_1 - 3.333333333333324e-02*G0_3_3_3_2_2 - 8.333333333333322e-02*G1_0_0_2_0 - 8.333333333333323e-02*G1_0_0_2_1 - 8.333333333333323e-02*G1_0_0_2_2 + 8.333333333333322e-02*G1_0_1_2_0 + 8.333333333333323e-02*G1_0_2_2_1 + 8.333333333333323e-02*G1_0_3_2_2 - 8.333333333333322e-02*G1_1_0_2_0 - 8.333333333333323e-02*G1_1_0_2_1 - 8.333333333333323e-02*G1_1_0_2_2 + 8.333333333333322e-02*G1_1_1_2_0 + 8.333333333333323e-02*G1_1_2_2_1 + 8.333333333333323e-02*G1_1_3_2_2 - 8.333333333333322e-02*G1_2_0_2_0 - 8.333333333333323e-02*G1_2_0_2_1 - 8.333333333333323e-02*G1_2_0_2_2 + 8.333333333333322e-02*G1_2_1_2_0 + 8.333333333333323e-02*G1_2_2_2_1 + 8.333333333333323e-02*G1_2_3_2_2 - 8.333333333333322e-02*G1_3_0_2_0 - 8.333333333333323e-02*G1_3_0_2_1 - 8.333333333333323e-02*G1_3_0_2_2 + 8.333333333333322e-02*G1_3_1_2_0 + 8.333333333333323e-02*G1_3_2_2_1 + 8.333333333333323e-02*G1_3_3_2_2 + 3.333333333333329e-01*G2_0_2_0 + 3.333333333333329e-01*G2_0_2_1 + 3.333333333333329e-01*G2_0_2_2 - 3.333333333333329e-01*G2_1_2_0 - 3.333333333333329e-01*G2_2_2_1 - 3.333333333333329e-01*G2_3_2_2 + 1.333333333333329e-01*G3_0_0_0_2_0 + 1.333333333333329e-01*G3_0_0_0_2_1 + 1.333333333333330e-01*G3_0_0_0_2_2 - 1.333333333333329e-01*G3_0_0_1_2_0 - 1.333333333333329e-01*G3_0_0_2_2_1 - 1.333333333333329e-01*G3_0_0_3_2_2 + 6.666666666666646e-02*G3_0_1_0_2_0 + 6.666666666666647e-02*G3_0_1_0_2_1 + 6.666666666666647e-02*G3_0_1_0_2_2 - 6.666666666666646e-02*G3_0_1_1_2_0 - 6.666666666666647e-02*G3_0_1_2_2_1 - 6.666666666666647e-02*G3_0_1_3_2_2 + 6.666666666666644e-02*G3_0_2_0_2_0 + 6.666666666666646e-02*G3_0_2_0_2_1 + 6.666666666666647e-02*G3_0_2_0_2_2 - 6.666666666666644e-02*G3_0_2_1_2_0 - 6.666666666666646e-02*G3_0_2_2_2_1 - 6.666666666666646e-02*G3_0_2_3_2_2 + 6.666666666666647e-02*G3_0_3_0_2_0 + 6.666666666666650e-02*G3_0_3_0_2_1 + 6.666666666666651e-02*G3_0_3_0_2_2 - 6.666666666666647e-02*G3_0_3_1_2_0 - 6.666666666666650e-02*G3_0_3_2_2_1 - 6.666666666666650e-02*G3_0_3_3_2_2 + 6.666666666666646e-02*G3_1_0_0_2_0 + 6.666666666666647e-02*G3_1_0_0_2_1 + 6.666666666666647e-02*G3_1_0_0_2_2 - 6.666666666666646e-02*G3_1_0_1_2_0 - 6.666666666666647e-02*G3_1_0_2_2_1 - 6.666666666666647e-02*G3_1_0_3_2_2 + 1.333333333333329e-01*G3_1_1_0_2_0 + 1.333333333333329e-01*G3_1_1_0_2_1 + 1.333333333333329e-01*G3_1_1_0_2_2 - 1.333333333333329e-01*G3_1_1_1_2_0 - 1.333333333333329e-01*G3_1_1_2_2_1 - 1.333333333333329e-01*G3_1_1_3_2_2 + 6.666666666666647e-02*G3_1_2_0_2_0 + 6.666666666666649e-02*G3_1_2_0_2_1 + 6.666666666666649e-02*G3_1_2_0_2_2 - 6.666666666666647e-02*G3_1_2_1_2_0 - 6.666666666666649e-02*G3_1_2_2_2_1 - 6.666666666666649e-02*G3_1_2_3_2_2 + 6.666666666666649e-02*G3_1_3_0_2_0 + 6.666666666666650e-02*G3_1_3_0_2_1 + 6.666666666666650e-02*G3_1_3_0_2_2 - 6.666666666666649e-02*G3_1_3_1_2_0 - 6.666666666666650e-02*G3_1_3_2_2_1 - 6.666666666666650e-02*G3_1_3_3_2_2 + 6.666666666666644e-02*G3_2_0_0_2_0 + 6.666666666666646e-02*G3_2_0_0_2_1 + 6.666666666666646e-02*G3_2_0_0_2_2 - 6.666666666666644e-02*G3_2_0_1_2_0 - 6.666666666666646e-02*G3_2_0_2_2_1 - 6.666666666666646e-02*G3_2_0_3_2_2 + 6.666666666666647e-02*G3_2_1_0_2_0 + 6.666666666666649e-02*G3_2_1_0_2_1 + 6.666666666666649e-02*G3_2_1_0_2_2 - 6.666666666666647e-02*G3_2_1_1_2_0 - 6.666666666666649e-02*G3_2_1_2_2_1 - 6.666666666666649e-02*G3_2_1_3_2_2 + 1.333333333333329e-01*G3_2_2_0_2_0 + 1.333333333333330e-01*G3_2_2_0_2_1 + 1.333333333333330e-01*G3_2_2_0_2_2 - 1.333333333333329e-01*G3_2_2_1_2_0 - 1.333333333333330e-01*G3_2_2_2_2_1 - 1.333333333333330e-01*G3_2_2_3_2_2 + 6.666666666666649e-02*G3_2_3_0_2_0 + 6.666666666666650e-02*G3_2_3_0_2_1 + 6.666666666666651e-02*G3_2_3_0_2_2 - 6.666666666666649e-02*G3_2_3_1_2_0 - 6.666666666666650e-02*G3_2_3_2_2_1 - 6.666666666666650e-02*G3_2_3_3_2_2 + 6.666666666666649e-02*G3_3_0_0_2_0 + 6.666666666666650e-02*G3_3_0_0_2_1 + 6.666666666666651e-02*G3_3_0_0_2_2 - 6.666666666666649e-02*G3_3_0_1_2_0 - 6.666666666666650e-02*G3_3_0_2_2_1 - 6.666666666666650e-02*G3_3_0_3_2_2 + 6.666666666666649e-02*G3_3_1_0_2_0 + 6.666666666666650e-02*G3_3_1_0_2_1 + 6.666666666666650e-02*G3_3_1_0_2_2 - 6.666666666666649e-02*G3_3_1_1_2_0 - 6.666666666666650e-02*G3_3_1_2_2_1 - 6.666666666666650e-02*G3_3_1_3_2_2 + 6.666666666666649e-02*G3_3_2_0_2_0 + 6.666666666666649e-02*G3_3_2_0_2_1 + 6.666666666666651e-02*G3_3_2_0_2_2 - 6.666666666666649e-02*G3_3_2_1_2_0 - 6.666666666666649e-02*G3_3_2_2_2_1 - 6.666666666666649e-02*G3_3_2_3_2_2 + 1.333333333333329e-01*G3_3_3_0_2_0 + 1.333333333333330e-01*G3_3_3_0_2_1 + 1.333333333333330e-01*G3_3_3_0_2_2 - 1.333333333333329e-01*G3_3_3_1_2_0 - 1.333333333333330e-01*G3_3_3_2_2_1 - 1.333333333333330e-01*G3_3_3_3_2_2 - 3.333333333333329e-01*G4_0_0_2_0 - 3.333333333333329e-01*G4_0_0_2_1 - 3.333333333333329e-01*G4_0_0_2_2 + 3.333333333333329e-01*G4_0_1_2_0 + 3.333333333333329e-01*G4_0_2_2_1 + 3.333333333333329e-01*G4_0_3_2_2 - 3.333333333333329e-01*G4_1_0_2_0 - 3.333333333333329e-01*G4_1_0_2_1 - 3.333333333333329e-01*G4_1_0_2_2 + 3.333333333333329e-01*G4_1_1_2_0 + 3.333333333333329e-01*G4_1_2_2_1 + 3.333333333333329e-01*G4_1_3_2_2 - 3.333333333333329e-01*G4_2_0_2_0 - 3.333333333333329e-01*G4_2_0_2_1 - 3.333333333333329e-01*G4_2_0_2_2 + 3.333333333333329e-01*G4_2_1_2_0 + 3.333333333333329e-01*G4_2_2_2_1 + 3.333333333333329e-01*G4_2_3_2_2 - 3.333333333333329e-01*G4_3_0_2_0 - 3.333333333333329e-01*G4_3_0_2_1 - 3.333333333333329e-01*G4_3_0_2_2 + 3.333333333333329e-01*G4_3_1_2_0 + 3.333333333333329e-01*G4_3_2_2_1 + 3.333333333333329e-01*G4_3_3_2_2 - 1.666666666666664e-01*G5_4_2_0 - 1.666666666666665e-01*G5_4_2_1 - 1.666666666666665e-01*G5_4_2_2 + 1.666666666666664e-01*G5_5_2_0 + 1.666666666666665e-01*G5_6_2_1 + 1.666666666666665e-01*G5_7_2_2 - 8.333333333333312e-03*G6_0 - 8.333333333333312e-03*G6_1 - 8.333333333333311e-03*G6_2 - 1.666666666666662e-02*G6_3 + 8.333333333333312e-03*G7_0 + 8.333333333333312e-03*G7_1 + 8.333333333333311e-03*G7_2 + 1.666666666666662e-02*G7_3 - 8.333333333333312e-03*G8_0 - 8.333333333333312e-03*G8_1 - 8.333333333333311e-03*G8_2 - 1.666666666666662e-02*G8_3;
    block[4] = -1.666666666666662e-02*G9_4 - 8.333333333333309e-03*G9_5 - 8.333333333333307e-03*G9_6 - 8.333333333333312e-03*G9_7 - 1.666666666666664e-01*G10_0_0_0 - 1.666666666666664e-01*G10_0_0_1 - 1.666666666666664e-01*G10_0_0_2 - 1.666666666666664e-01*G10_0_1_0 - 1.666666666666665e-01*G10_0_1_1 - 1.666666666666665e-01*G10_0_1_2 - 1.666666666666664e-01*G10_0_2_0 - 1.666666666666665e-01*G10_0_2_1 - 1.666666666666665e-01*G10_0_2_2 + 1.666666666666664e-01*G10_1_0_0 + 1.666666666666664e-01*G10_1_1_0 + 1.666666666666664e-01*G10_1_2_0 + 1.666666666666664e-01*G10_2_0_1 + 1.666666666666665e-01*G10_2_1_1 + 1.666666666666665e-01*G10_2_2_1 + 1.666666666666664e-01*G10_3_0_2 + 1.666666666666665e-01*G10_3_1_2 + 1.666666666666665e-01*G10_3_2_2;
    block[5] = -8.333333333333309e-03*G9_4 - 1.666666666666662e-02*G9_5 - 8.333333333333311e-03*G9_6 - 8.333333333333312e-03*G9_7 + 1.666666666666664e-01*G10_0_0_0 + 1.666666666666664e-01*G10_0_0_1 + 1.666666666666664e-01*G10_0_0_2 - 1.666666666666664e-01*G10_1_0_0 - 1.666666666666664e-01*G10_2_0_1 - 1.666666666666664e-01*G10_3_0_2;
    block[6] = -8.333333333333307e-03*G9_4 - 8.333333333333311e-03*G9_5 - 1.666666666666662e-02*G9_6 - 8.333333333333312e-03*G9_7 + 1.666666666666664e-01*G10_0_1_0 + 1.666666666666665e-01*G10_0_1_1 + 1.666666666666665e-01*G10_0_1_2 - 1.666666666666664e-01*G10_1_1_0 - 1.666666666666665e-01*G10_2_1_1 - 1.666666666666665e-01*G10_3_1_2;
    block[7] = -8.333333333333312e-03*G9_4 - 8.333333333333312e-03*G9_5 - 8.333333333333311e-03*G9_6 - 1.666666666666662e-02*G9_7 + 1.666666666666664e-01*G10_0_2_0 + 1.666666666666665e-01*G10_0_2_1 + 1.666666666666665e-01*G10_0_2_2 - 1.666666666666664e-01*G10_1_2_0 - 1.666666666666665e-01*G10_2_2_1 - 1.666666666666665e-01*G10_3_2_2;
  }

  // No contribution from the boundary
  void eval(real block[], const AffineMap& map, unsigned int facet) const {}   

private:

  const real& c0;  const real& c1;  const real& c2;  const real& c3;

};

} }

#endif
